<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.invoice.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class invoice {

//---- Invoice Detail Validation Checks

    function invoice_validate($iv) {
	global $phpgw ;
	$err=""; $error=lang("Error") ;
	if ($iv[invnumber]=="")			$err=lang("Invoice Number Missing");
	if (input2date($iv[transdate])=="")	$err=lang("Invalid Invoice Date") ;
	if (input2date($iv[duedate])=="")	$err=lang("Invalid Due Date") ;
	For ($i=1;isset($iv['itemid'.$i]);$i++) {
		if ($iv['itemid'.$i]=='')	$err=lang("Item Code Missing") ;
		$row = lang("Row") ; $rowi = "[$row $i]" ;
		if ($iv['qty'.$i] and !is_numeric($iv['qty'.$i]))
						$err=$rowi.lang("Invalid Qty, must be numeric");
		if ($iv['discount'.$i] and !is_numeric($iv['discount'.$i]) and $iv[taxstatus]<>"t")
						$err=$rowi.lang("Invalid Discount, must be numeric");
		if ($iv['cost'.$i] and !is_numeric($iv['cost'.$i]))
						$err=$rowi.lang("Invalid Unit Price, must be numeric");
		if ($iv['tax1'.$i] and !is_numeric($iv['tax1'.$i]))
						$err=$rowi.lang("Invalid Tax1, must be numeric");
		if ($iv['tax2'.$i] and !is_numeric($iv['tax2'.$i]))
						$err=$rowi.lang("Invalid Tax2, must be numeric");
		if (($iv[taxstatus]=="f" or $iv[taxstatus]=="t") and $iv['tax1_pref'.$i]=='')
						$err=$rowi.lang("Blank Choice on Primary Tax Rate");
		if (($iv[taxstatus]=="f" or $iv[taxstatus]=="t") and $iv['tax2_pref'.$i]=='')
						$err=$rowi.lang("Blank Choice on Secondary Tax Rate");
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Post Invoice to Database

    function invoice_post($iv, &$t, &$id, $op, $script, $trantype) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id	= $iv['id'] ;
	$source	= $trantype ;
	$desc	= "AP: Invoice# $iv[invnumber]" ;
	$transdate = $iv['transdate'] ;
	if ($iv[taxstatus]=="e")	$iv[taxstatus] = "f" ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO ap(id,invnumber,transdate,vendor,taxincluded,amount," ;
			$sql.=				"netamount,duedate,ordnumber,ap_accno_id) " ;
			$sql.= "VALUES ('$id','$iv[invnumber]','$transdate','$iv[vendor]','$iv[taxstatus]','$iv[sum_itemtotal]',";
			$sql.= "'$iv[sum_netamount]','$iv[duedate]','$iv[ordnumber]','$iv[ap_accno_id]')";
			$phpgw->db->query($sql);
			$sql = "INSERT INTO gl(id,source,description,transdate) VALUES('$id','$source','$desc','$transdate')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE ap SET invnumber='$iv[invnumber]',transdate='$transdate',vendor='$iv[vendor]'," ;
			$sql.= "taxincluded='$iv[taxstatus]',amount='$iv[sum_itemtotal]',netamount='$iv[sum_netamount]'," ;
			$sql.= "duedate='$iv[duedate]',ordnumber='$iv[ordnumber]',ap_accno_id='$iv[ap_accno_id]' " ;
			$sql.="WHERE id=$id";
			$phpgw->db->query($sql);
			$sql ="UPDATE gl SET source='$source',description='$desc',transdate='$transdate' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from ap where id = $id");
			$phpgw->db->query("DELETE from gl where id = $id");
			$phpgw->db->query("DELETE from p_match where invoiceid=$id");
			$phpgw->db->query("DELETE from ipmatch where invoiceid=$id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	if ($op<>'new')	{
		$phpgw->db->query("DELETE from invoice where trans_id=$id");
		$phpgw->db->query("DELETE from acc_trans where trans_id=$id");
		}
	if ($op<>'delete') {
		For ($i=1;isset($iv['itemid'.$i]);$i++) {
			$itemid		= $iv['itemid'.$i];
			$itemtype	= $iv['itemtype'.$i];
			$desc		= $iv['description'.$i];
			$unit		= $iv['unit'.$i];
			$qty		= $iv['qty'.$i];
			$cost		= $iv['cost'.$i];
			$discount	= $iv['discount'.$i];
			$chart_id	= $iv['dr_accno_id'.$i] ;
			$tax1		= $iv['tax1'.$i] ;
			$tax2		= $iv['tax2'.$i] ;
			$t1aid		= $iv['tax1_accno_id'.$i] ;
			$t2aid		= $iv['tax2_accno_id'.$i] ;
			$eaid		= ($itemtype=="s") ? $chart_id : "" ;
			$iaid		= ($itemtype=="i") ? $chart_id : "" ;
			$netamount	= $iv['netamount'.$i] ;
			$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$chart_id','-$netamount','$transdate')";
			$phpgw->db->query($sql);
			if ($tax1<>0 and $tax1<>'') {
				$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
				$sql.= "VALUES ('$id','$t1aid','-$tax1','$transdate')" ;
				$phpgw->db->query($sql);
				}
			if ($tax2<>0 and $tax2<>'') {
				$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
				$sql.= "VALUES ('$id','$t2aid','-$tax2','$transdate')" ;
				$phpgw->db->query($sql);
				}
			$iaid = ($iaid=="") ? 0 : $iaid ;
			$eaid = ($eaid=="") ? 0 : $eaid ;
			$t1aid = ($t1aid=="") ? 0 : $t1aid ;
			$t2aid = ($t2aid=="") ? 0 : $t2aid ;
			$sql =	"INSERT INTO invoice (trans_id,inventory_accno_id,expense_accno_id,itemid,itemtype," ;
			$sql.=	"description,qty,cost,discount,unit,tax1,tax2,tax1_accno_id,tax2_accno_id) " ;
			$sql.=	"VALUES ('$id','$iaid','$eaid','$itemid','$itemtype','$desc','-$qty','$cost'," ;
			$sql.=				"'$discount','$unit','$tax1','$tax2','$t1aid','$t2aid')" ;
			$phpgw->db->query($sql);
			}
		$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
		$sql.= "VALUES ('$id','$iv[ap_accno_id]','$iv[sum_itemtotal]','$transdate')";
		$phpgw->db->query($sql);
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$msg = lang("Remember to perform/adjust payment allocation and attibutes") ;
	$tran = lang("Invoice") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.  $msg.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Invoice Header

    function invoice_header_write(&$t, $iv, $taxscript) {
	global $phpgw ;

	$taxstatus = $iv[taxstatus] ;
	$t->set_var('lang_invnumber',lang('Invoice#'));
	$t->set_var('lang_id',lang('Audit Id:'));
	$t->set_var('lang_ordnumber',lang('PO#'));
	$t->set_var('lang_transdate',lang('Invoice Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_vendor',lang('Vendor'));
	$t->set_var('lang_taxstatus',lang('Unit Price Tax Status'));
	$t->set_var('invnumber',$iv[invnumber]) ;
	$t->set_var('ordnumber',$iv[ordnumber]) ;
	$transdate = $iv[transdate] ;
	$duedate = $iv[duedate] ;
	$vendor = $iv[vendor] ;
	if (!$duedate and $vendor and $transdate) {
		$phpgw->db->query("SELECT * FROM vendor WHERE id='$vendor'");
		$phpgw->db->next_record() ;
		$terms=$phpgw->db->f('terms');
		$td = explode("-",$transdate);
		$duedate=date("Y-m-d",mktime(0,0,0,$td[1],$td[2]+$terms,$td[0])) ;
		}
	$t->set_var('transdate',$transdate) ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('vendor',$vendor) ;
	$t->set_var('vendor_selectlist',vendor_selectlist('',$vendor)) ;
	$optiont = lang('Tax Included') ;
	$optionf = lang('Tax Not Included') ;
	$optione = lang('Tax Exempted') ;
	if ($taxscript=="nt")	$tax_sl = "<OPTION value='e' selected>$optione</OPTION>" ;
	    else {
		$tax_sl = "<OPTION value='t'>$optiont</OPTION>" ;
		$tax_sl.= "<OPTION value='f'>$optionf</OPTION>" ;
		$tax_sl.= "<OPTION value='e'>$optione</OPTION>" ;
		$tax_sl = str_replace("'$taxstatus'","'$taxstatus' selected",$tax_sl) ;
		}
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->set_var('id',$iv[id]) ;
	$t->parse('out','report',True);
	}

//---- Reformat Invoice Array

    function invoice_transform(&$iv,$newrow,$delete) {
	global $phpgw ;

	$row_ = lang('Row')." " ;
	$temp[id] = $iv[id] ;
	$temp[vendor] = $iv[vendor] ;
	$temp[transdate] = $iv[transdate] ;
	$temp[duedate] = $iv[duedate] ;
	$temp[invnumber] = $iv[invnumber] ;
	$temp[ordnumber] = $iv[ordnumber] ;
	$temp[taxstatus] = $iv[taxstatus] ;
	$temp[ap_accno_id] = $iv[ap_accno_id] ;

	if (isset($delete)) {$delrowno = intval(str_replace($row_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($iv['itemid'.$i]);$i++) {
		$itemid = $iv['itemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($itemid<0)	{
			$itemid = -$itemid ;
			$qty = $iv['qty'.$i]==0 ? 1 : $iv['qty'.$i] ;
			$phpgw->db->query("SELECT * FROM assembly WHERE assembly_id='$itemid'");
			while ($phpgw->db->next_record()) {
				$temp['itemid'.$j] = $phpgw->db->f('item_id') ;
				$temp['qty'.$j] = $phpgw->db->f('qty') * $qty ;
				$j++ ;
				}
			continue ;
			}
		$temp['itemid'.$j]		=	$iv['itemid'.$i] ;
		$temp['itemtype'.$j]		=	$iv['itemtype'.$i] ;
		$temp['description'.$j]		=	$iv['description'.$i] ;
		$temp['qty'.$j]			=	$iv['qty'.$i] ;
		$temp['unit'.$j]		=	$iv['unit'.$i] ;
		$temp['cost'.$j]		=	$iv['cost'.$i] ;
		$temp['discount'.$j]		=	$iv['discount'.$i] ;
		$temp['inventory_accno_id'.$j]	=	$iv['inventory_accno_id'.$i] ;
		$temp['expense_accno_id'.$j]	=	$iv['expense_accno_id'.$i] ;
		$temp['dr_accno_id'.$j]		=	$iv['dr_accno_id'.$i] ;
		$temp['tax1_pref'.$j]		=	$iv['tax1_pref'.$i] ;
		$temp['tax2_pref'.$j]		=	$iv['tax2_pref'.$i] ;
		$temp['tax1'.$j]		=	$iv['tax1'.$i] ;
		$temp['tax2'.$j]		=	$iv['tax2'.$i] ;
		$temp['tax1_accno_id'.$j]	=	$iv['tax1_accno_id'.$i] ;
		$temp['tax2_accno_id'.$j]	=	$iv['tax2_accno_id'.$i] ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=True ;
	if ($newrow)					$temp['itemid'.$j] = "" ;
	$iv = $temp ;
	unset($temp) ;
	}

//---- Write Invoice Detail

    function invoice_detail_write(&$t,&$iv,$posted,$firstime) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;	
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$taxstatus = $iv[taxstatus] ;
	$tax_warning = lang("***** Choice Pending") ;
	if ($taxstatus<>'e') {
		$tax_pref_slist = "<OPTION value=''></OPTION>" ;
		$tax_pref_slist.= "<OPTION value='i'>".lang('apply item tax rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='v'>".lang('apply vendor rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='s'>".lang('apply my std rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='z'>".lang('tax rate = zero')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='m'>".lang('manual tax input')."</OPTION>" ;
		$vendor = ($iv[vendor]=="") ? 0 : $iv[vendor];
		$sql = "SELECT vendor_id,chart_id,rate from vendortax a, tax b " ;
		$sql.= "WHERE vendor_id='$vendor' and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$vtax1chartid = $phpgw->db->f(chart_id) ;
		$vtax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,chart_id,rate from vendortax a, tax b " ;
		$sql.= "WHERE vendor_id='$vendor' and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$vtax2chartid = $phpgw->db->f(chart_id) ;
		$vtax2rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,chart_id,rate from vendortax a, tax b, vendor c " ;
		$sql.= "WHERE c.name='zzzzMyself' and vendor_id=c.id and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax1chartid = $phpgw->db->f(chart_id) ;
		$stax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,chart_id,rate from vendortax a, tax b, vendor c " ;
		$sql.= "WHERE c.name='zzzzMyself' and vendor_id=c.id and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax2chartid = $phpgw->db->f(chart_id) ;
		$stax2rate = $phpgw->db->f(rate) ;
		}
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_number',lang('Item Code -- Id<br>(Inventory/Service)'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_btup',lang('BTUP'));
	$t->set_var('lang_discount',lang('Discount')."<br>$");
	$t->set_var('lang_tax',lang('Tax'));
	$phpgw->db->query("SELECT aptax1cap,aptax2cap,aptax1pref,aptax2pref FROM defaults");
	$phpgw->db->next_record() ;
	$t->set_var('lang_tax1',$phpgw->db->f(aptax1cap));
	$t->set_var('lang_tax2',$phpgw->db->f(aptax2cap));
	$tax1pref = $phpgw->db->f(aptax1pref) ;
	$tax2pref = $phpgw->db->f(aptax2pref) ;
	$t->set_var('lang_cost',lang('Unit Price'));
	$t->set_var('lang_itemtotal',lang('Item Total'));
	$t->set_var('lang_netamount',lang('Net of Tax'));
	$t->set_var('lang_accno',lang('Post to Account'));
	$t->set_var('lang_delete',lang('Delete<br>Button'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$item_sl = item_selectlist("",'') ;
	$inv_acc_list = account_selectlist("WHERE link like '%IC:%' or link like '%IC'",'') ;
	$exp_acc_list = account_selectlist("WHERE link like '%AP_amount%'",'') ;
	$tax_acc_list = ($firstime and $iv[frompo]) ? "" : account_selectlist("WHERE link like '%AP_tax%'",'') ;
	$sum_tax1 = $sum_tax2 = $sum_itemtotal = $sum_netamount = 0 ;
	For ($i=1;isset($iv['itemid'.$i]);$i++) {
		$t->set_var('itemid_fld','itemid'.$i) ;
		$t->set_var('itemtype_fld','itemtype'.$i) ;
		$t->set_var('description_fld','description'.$i);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('unit_fld','unit'.$i);
		$t->set_var('discount_fld','discount'.$i);
		$t->set_var('cost_fld','cost'.$i);
		$t->set_var('dr_accno_fld','dr_accno_id'.$i);
		$t->set_var('tax1_pref_fld','tax1_pref'.$i);
		$t->set_var('tax2_pref_fld','tax2_pref'.$i);
		$t->set_var('tax1_fld','tax1'.$i);
		$t->set_var('tax2_fld','tax2'.$i);
		$t->set_var('tax1_accno_fld','tax1_accno_id'.$i);
		$t->set_var('tax2_accno_fld','tax2_accno_id'.$i);
		$itemid = $iv['itemid'.$i] ;
		$itemtype = $iv['itemtype'.$i] ;
		$description = $iv['description'.$i] ;
		$unit = $iv['unit'.$i] ;
		$qty = ($itemid<>'' and $iv['qty'.$i]=='') ? 1 : $iv['qty'.$i] ;
		$discount = ($taxstatus=="t") ? "" : $iv['discount'.$i] ;
		$cost = $iv['cost'.$i] ;
		$drid = $iv['dr_accno_id'.$i] ;
		switch ($itemtype) :
			case "s" :	$drid = ($drid) ? $drid : $iv['expense_accno_id'.$i] ; break ;
			case "i" :	$drid = ($drid) ? $drid : $iv['inventory_accno_id'.$i] ; break ;
			case "" :	$drid = ($drid) ? $drid : "" ; break ;
			endswitch ;
		$tax1_pref = ($iv['tax1_pref'.$i] or $posted) ? $iv['tax1_pref'.$i] : $tax1pref ;
		$tax2_pref = ($iv['tax2_pref'.$i] or $posted) ? $iv['tax2_pref'.$i] : $tax2pref ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		if (($tax1_pref=="" or $tax1_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark1',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark1',"");
		if (($tax2_pref=="" or $tax2_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark2',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark2',"");
		$tax1 = $iv['tax1'.$i] ;
		$tax2 = $iv['tax2'.$i] ;
		$t1aid = $iv['tax1_accno_id'.$i] ;
		$t2aid = $iv['tax2_accno_id'.$i] ;
		$itemid = ($itemid=="") ? 0 : $itemid ;
		if ($itemtype<>"s" and $itemtype<>"i") {
			$phpgw->db->query("SELECT * FROM service WHERE id='$itemid'");
			if ($phpgw->db->next_record()) {
				$drid = $drid<>'' ? $drid : $phpgw->db->f('expense_accno_id');
				$itemtype = "s" ;
				}
			   else {
				$phpgw->db->query("SELECT * FROM parts WHERE id='$itemid'");
				if ($phpgw->db->next_record()) {
					$drid = $drid<>'' ? $drid : $phpgw->db->f('inventory_accno_id');
					$itemtype = "i" ;
					}
				}
			$description = $description<>'' ? $description : $phpgw->db->f('description');
			$unit = $unit<>'' ? $unit : $phpgw->db->f('unit');
			$cost = $cost<>'' ? $cost : $phpgw->db->f('cost');
			}
		$t->set_var('itemid',$itemid) ;
		$t->set_var('item_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$item_sl));
		$t->set_var('itemtype',$itemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$unit);
		$t->set_var('qty',$qty);
		$t->set_var('discount',$discount);
		if ($taxstatus=="t" or $posted)	$t->set_var('disc_readonly','readonly');
			else			$t->set_var('disc_readonly','');
		$t->set_var('cost',$cost);
		switch ($itemtype) :
			case "s" :	$slist = str_replace("'$drid'","'$drid' selected",$exp_acc_list) ; break ;
			case "i" :	$slist = str_replace("'$drid'","'$drid' selected",$inv_acc_list) ; break ;
			case "" :	$slist = "." ; break ;
			endswitch ;
		$t->set_var('dr_acc_selectlist',$slist) ;
		switch ($tax1_pref) :
			case "v" :
				$tax1chartid = $vtax1chartid ;
				$tax1rate = $vtax1rate ;
				break ;
			case "s" :
				$tax1chartid = $stax1chartid ;
				$tax1rate = $stax1rate ;
				break ;
			case "i" :
				$sql = "SELECT chart_id,rate from itemtax a, tax b " ;
				$sql.="WHERE item_id='$itemid' and tax_id=id and taxtype='1' and taxgroup='ap'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax1chartid = $phpgw->db->f(chart_id) ;
				$tax1rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax1rate = 0 ;		break ;
			case "m" :	$tax1rate = 0 ;		break ;
			case " " :	$tax1rate = 0 ;		break ;
			case "" :	$tax1rate = 0 ;		break ;
			endswitch ;
		switch ($tax2_pref) :
			case "v" :
				$tax2chartid = $vtax2chartid ;
				$tax2rate = $vtax2rate ;
				break ;
			case "s" :
				$tax2chartid = $stax2chartid ;
				$tax2rate = $stax2rate ;
				break ;
			case "i" :
				$sql = "SELECT chart_id,rate from itemtax a, tax b " ;
				$sql.="WHERE item_id='$itemid' and tax_id=id and taxtype='2' and taxgroup='ap'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax2chartid = $phpgw->db->f(chart_id) ;
				$tax2rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax2rate = 0 ;		break ;
			case "m" :	$tax2rate = 0 ;		break ;
			case " " :	$tax2rate = 0 ;		break ;
			case "" :	$tax2rate = 0 ;		break ;
			endswitch ;
		switch ($taxstatus) :
			case "f" :
				$t->set_var('btup',$cost);
				$netamount = number_format($qty*$cost-$discount,2,".",'') ;
				$keeptax1 = ($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ") ;
				$keeptax2 = ($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ") ;
				$tax1 = ($keeptax1) ? $tax1 : $netamount*$tax1rate ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $netamount*$tax2rate ;
				$tax2 = number_format($tax2,2,".",'') ;
				$itemtotal = $netamount + $tax1 + $tax2 ;
				break ;
			case "t" :
				$t->set_var('btup','.');
				$t->set_var('discount','');
				$itemtotal = $taxbase = number_format($qty*$cost,2,".",'') ;
				$keeptax1 = ($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ") ;
				$keeptax2 = ($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ") ;
				if ($keeptax1)		$taxbase -= $tax1 ;
				if ($keeptax2)		$taxbase -= $tax2 ;
				$tax1 = ($keeptax1) ? $tax1 : $taxbase*$tax1rate/(1+$tax1rate+$tax2rate) ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $taxbase*$tax2rate/(1+$tax1rate+$tax2rate) ;
				$tax2 = number_format($tax2,2,".",'') ;
				$netamount = $itemtotal - $tax1 - $tax2 ;
				break ;
			case "e" :
				$t->set_var('btup','.');
				$netamount = number_format($qty*$cost-$discount,2,".",'') ;
				$itemtotal = $netamount ;
				$tax1rate = $tax2rate = 0 ;
				$tax1 = $tax2 = 0 ;
				break ;
			endswitch ;
		$t1aid = $t1aid=='' ? $tax1chartid : $t1aid ;
		$slist = $tax1==0 ? "" : str_replace("'$t1aid'","'$t1aid' selected",$tax_acc_list) ;
		$t->set_var('tax1_acc_selectlist',$slist);
		$t2aid = $t2aid=='' ? $tax2chartid : $t2aid ;
		$slist = $tax2==0 ? "" : str_replace("'$t2aid'","'$t2aid' selected",$tax_acc_list) ;
		$t->set_var('tax2_acc_selectlist',$slist);
		$sum_tax1 += $tax1 ;
		$sum_tax2 += $tax2 ;
		$sum_itemtotal += $itemtotal ;
		$sum_netamount += $netamount ;
		$t->set_var('tax1',$tax1);
		$t->set_var('tax2',$tax2);
		$t->set_var('itemtotal',$itemtotal);
		$t->set_var('netamount',$netamount);
		if ($posted)		$t->set_var('rowno',"done") ;
			else		$t->set_var('rowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);

		$iv['itemid'.$i] = $itemid ;
		$iv['itemtype'.$i] = $itemtype ;
		$iv['description'.$i] = $description ;
		$iv['qty'.$i] = $qty ;
		$iv['cost'.$i] = $cost ;
		$iv['discount'.$i] = $discount ;
		$iv['unit'.$i] = $unit ;
		$iv['dr_accno_id'.$i] =  $drid ;
		$iv['tax1'.$i] = $tax1 ;
		$iv['tax2'.$i] = $tax2 ;
		$iv['tax1_accno_id'.$i] = $t1aid ;
		$iv['tax2_accno_id'.$i] = $t2aid ;
		$iv['netamount'.$i] = $netamount ;
		}

	$t->set_var('lang_totalnet',lang('Total Tax / Net Amount'));
	$t->set_var('lang_totalap',lang('Total Payable'));
	$t->set_var('sum_tax',number_format($sum_tax1+$sum_tax2,2,".",'')) ;
	$iv[sum_netamount] = number_format($sum_netamount,2,".",'') ;
	$t->set_var('sum_netamount',$iv[sum_netamount]) ;
	$iv[sum_itemtotal] = number_format($sum_itemtotal,2,".",'') ;
	$t->set_var('sum_itemtotal',$iv[sum_itemtotal]) ;
	$ap_acc_list = account_selectlist("WHERE link like '%AP:%' or link like '%AP'",$iv[ap_accno_id]);
	$t->set_var('ap_acc_selectlist',$ap_acc_list) ;
	$t->parse('out','report',True);
	}

    }

?>
