<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.payment.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class payment {

//---- Payment Detail Validation Checks

    function payment_validate($p) {
	global $phpgw ;
	$err=""; $error=lang("Error") ;
	if ($p[payee]=="")				$err=lang("Payee Missing");
	if ($p[paynumber]=="")				$err=lang("Payment/Cheque Number Missing");
	if (input2date($p[transdate])=="")		$err=lang("Invalid Payment Date");
	if (!is_numeric($p[amount]))			$err=lang("Payment amount must be numeric");
	$sum_pnewsamt = 0 ;
	For ($i=1;isset($p['pinvoiceid'.$i]);$i++) {
		$pnewsamt = $p['pnewsamount'.$i] ;
		$row = lang("Row") ; $rowi = "[$row $i]" ;
		if ($pnewsamt<0)			$err=$rowi.lang("New Amount Settled must be +ve");
		if ($pnewsamt>$p[amount])		$err=$rowi.lang("New Amount Settled > Payment Amount");
		if ($pnewsamt>$p['pinvoiceamt'.$i])	$err=$rowi.lang("New Amount Settled > Invoice Amount");
		if (!is_numeric($pnewsamt) and strlen($pnewsamt)>0)
							$err=$rowi.lang("New Amount Settled must be numeric");
		$sum_pnewsamt += ($pnewsamt=="") ? $p['ps_amount'.$i] : $pnewsamt ;
		}
	if ($sum_pnewsamt>$p[amount])			$err=lang("Total Amount Settled > Payment Amount");
	For ($i=1;isset($p['upinvoiceid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		if ($p['uposamount'.$i]<0)		$err=$rowi.lang("UNPAID invoice overpaid");
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Post Payment to Database

    function payment_post($p, &$t, &$id, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id	= $p[id] ;
	$source	= "APPY";
	$remark	= $p[remark] ;
	$desc	= "AP: Payment# $p[paynumber]" ;
	$transdate= $p[transdate] ;
	$payno	= $p[paynumber] ;
	$vendor	= $p[vendor] ;
	$payee  = $p[payee] ;
	$dracc	= $p[dr_accno_id] ;
	$cracc	= $p[cr_accno_id] ;
	$amount	= $p[amount] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO payment (id,paynumber,transdate,vendor,amount,payee,remark,dr_accno_id,cr_accno_id) " ;
			$sql.= "VALUES ('$id','$payno','$transdate','$vendor','$amount','$payee','$remark','$dracc','$cracc')";
			$phpgw->db->query($sql);
			$sql = "INSERT INTO gl(id,source,description,transdate) VALUES('$id','$source','$desc','$transdate')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE payment SET paynumber='$payno',transdate='$transdate',vendor='$vendor',amount='$amount'," ;
			$sql.="payee='$payee',remark='$remark',dr_accno_id='$dracc',cr_accno_id='$cracc' " ;
			$sql.="WHERE id=$id";
			$phpgw->db->query($sql);
			$sql ="UPDATE gl SET source='$source',description='$desc',transdate='$transdate' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from payment where id = $id");
			$phpgw->db->query("DELETE from gl where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	if ($op<>'new')	{
		$phpgw->db->query("DELETE from acc_trans where trans_id='$id'");
		$phpgw->db->query("DELETE from p_match where paymentid=$id");
		}
	if ($op<>'delete') {
		$sql = "INSERT INTO acc_trans(trans_id,chart_id,amount,transdate) VALUES('$id','$dracc','-$amount','$transdate')";
		$phpgw->db->query($sql);
		$sql = "INSERT INTO acc_trans(trans_id,chart_id,amount,transdate) VALUES('$id','$cracc','$amount','$transdate')";
		$phpgw->db->query($sql);
		For ($i=1;isset($p['pinvoiceid'.$i]);$i++) {
			$s_amt = $p['pnewsamount'.$i]=="" ? $p['ps_amount'.$i] : $p['pnewsamount'.$i] ;
			if ($s_amt<>0) {
				$invid	= $p['pinvoiceid'.$i] ;
				$sql="INSERT INTO p_match (paymentid,invoiceid,s_amount) VALUES ('$id','$invid','$s_amt')";
				$phpgw->db->query($sql);
				}
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$msg = lang("Remember to adjust attibutes of the accounting entries") ;
	$tran = lang("Payment") ;
	$t->set_var("message2","<b>$type $tran [id#$id] $actioned.  $msg</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Payment Header

    function payment_header_write(&$t, $p) {
	global $phpgw ;

	$t->set_var('lang_vendor',lang('Vendor'));
	$t->set_var('lang_payee',lang('Payee'));
	$t->set_var('lang_paynumber',lang('Payment# / Cheque#'));
	$t->set_var('lang_id',lang('Audit Id:'));
	$t->set_var('lang_transdate',lang('Payment Date'));
	$t->set_var('lang_remark',lang('Remark'));
	$t->set_var('lang_amount',lang('Payment Amount'));
	$t->set_var('lang_drpostto',lang('Payment Amount<br>Dr to Account'));
	$t->set_var('lang_crpostto',lang('Payment Amount<br>Cr to Account'));
	$vendor = $p[vendor] ;
	$t->set_var('vendor',$vendor) ;
	$t->set_var('oldvendor',$vendor) ;
	$t->set_var('vendor_selectlist',vendor_selectlist('',$vendor)) ;
	$t->set_var('payee',$p[payee]) ;
	$t->set_var('paynumber',$p[paynumber]) ;
	$t->set_var('id',$p[id]) ;
	$t->set_var('transdate',$p[transdate]) ;
	$t->set_var('remark',$p[remark]) ;
	$t->set_var('amount',$p[amount]) ;
	$t->set_var('oldamount',$p[amount]) ;
	$dr_acc_list = account_selectlist("WHERE link like '%AP:%' or link like '%AP'",$p[dr_accno_id]);
	$t->set_var('dr_acc_selectlist',$dr_acc_list) ;
	$cr_acc_list = account_selectlist("WHERE link like '%AP_paid%'",$p[cr_accno_id]);
	$t->set_var('cr_acc_selectlist',$cr_acc_list) ;
	$t->parse('out','report',True);
	}

//---- Write Payment Detail

    function payment_detail_write(&$t,&$p,$posted) {
	global $phpgw,$phpgw_info ;

	$moverow_ = lang('Move Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_pltitle',lang('List of Fully/Partially PAID Invoices settled by this Payment'));
	$t->set_var('lang_pinvnumber',lang('Invoice#'));
	$t->set_var('lang_pinvoiceid',lang('Invoice ID'));
	$t->set_var('lang_pduedate',lang('Due Date'));
	$t->set_var('lang_pfullamount',lang('Full Invoice Amount'));
	$t->set_var('lang_psettled',lang('Amount Settled<br>via this Payment'));
	$t->set_var('lang_pnewsamount',lang('Amount Settled via this<br>Payment to be Updated to'));
	$msgunderallo = lang('[Payment underallocated to Invoice]');
	$sum_pinvoiceamt = $sum_ps_amount = $sum_pnewsamt = 0 ;
	For ($i=1;isset($p['pinvoiceid'.$i]);$i++) {

		$t->set_var('pinvnumber_fld','pinvnumber'.$i);
		$t->set_var('pinvoiceid_fld','pinvoiceid'.$i);
		$t->set_var('pduedate_fld','pduedate'.$i);
		$t->set_var('pinvoiceamt_fld','pinvoiceamt'.$i);
		$t->set_var('ps_amount_fld','ps_amount'.$i) ;
		$t->set_var('pnewsamount_fld','pnewsamount'.$i);
		$t->set_var('pinvnumber',$p['pinvnumber'.$i]) ;
		$pinvoiceid = $p['pinvoiceid'.$i] ;
		$t->set_var('pinvoiceid',$pinvoiceid) ;
		$t->set_var('pduedate',$p['pduedate'.$i]) ;
		$t->set_var('pinvoiceamt',$p['pinvoiceamt'.$i]) ;
		$t->set_var('ps_amount',$p['ps_amount'.$i]) ;
		$pnewsamount = $p['pnewsamount'.$i] ;
		if (is_numeric($pnewsamount))		$t->set_var('pnewsamount',"") ;
			else				$t->set_var('pnewsamount',$pnewsamount) ;
		if (strlen($pnewsamount)>0 and is_numeric($pnewsamount)) {
			For ($j=1;isset($p['upinvoiceid'.$j]);$j++) {
				if ($pinvoiceid==$p['upinvoiceid'.$j]) {
					$p['ups_amount'.$j] = $pnewsamount ;
					$p['uppaidamount'.$j]= $p['ups_amount'.$j] + $p['ups_othamt'.$j];
					$p['uposamount'.$j] = $p['upinvoiceamt'.$j] - $p['uppaidamount'.$j] ;
					break ;
					}
				}
			if (!isset($p['upinvoiceid'.$j])) {

				$user = trim($phpgw_info["user"]["userid"]);
				$tmp = "pay".$user.time() ;
				$sql = "CREATE TABLE $tmp AS " ;
				$sql.=		"SELECT invnumber,id,duedate,amount,0.0 as s_amount,sum(s_amount) as paidamt " ;
				$sql.=			"FROM ap,p_match WHERE id='$pinvoiceid' and invoiceid='$pinvoiceid' " ;
				$sql.=			"GROUP BY invnumber,id,duedate,amount" ;
				$phpgw->db->query($sql);
				$sql = "INSERT INTO $tmp " ;
				$sql.=		"SELECT invnumber,id,duedate,amount,s_amount,0.0 as paidamt FROM ap,p_match ";
				$sql.=			"WHERE id='$pinvoiceid' and invoiceid='$pinvoiceid' and paymentid='$p[id]' " ;
				$phpgw->db->query($sql);
				$sql = "SELECT invnumber,id,duedate,amount,sum(s_amount) as s_amount,sum(paidamt) as paidamt " ;
				$sql.= "FROM $tmp GROUP BY invnumber,id,duedate,amount " ;
				$phpgw->db->query($sql) ;

				$phpgw->db->next_record() ;
				$p['upinvnumber'.$j]	=	$phpgw->db->f('invnumber') ;
				$p['upinvoiceid'.$j]	=	$phpgw->db->f('id') ;
				$p['upduedate'.$j]	=	$phpgw->db->f('duedate') ;
				$p['upinvoiceamt'.$j]	=	$phpgw->db->f('amount') ;
				$p['ups_amount'.$j]	=	$pnewsamount ;
				$p['ups_othamt'.$j]	=	$phpgw->db->f('paidamt')-$phpgw->db->f('s_amount');
				$p['uppaidamount'.$j]	=	$p['ups_amount'.$j] + $p['ups_othamt'.$j] ;
				$p['uposamount'.$j]	=	$p['upinvoiceamt'.$j] - $p['uppaidamount'.$j] ;
				$sql = "DROP TABLE $tmp" ;
				$phpgw->db->query($sql);

				}
			$t->set_var('ps_amount',$pnewsamount) ;
			$p['ps_amount'.$i] = $pnewsamount ;
			}
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('paidlist_section','paidlist', True);
		$sum_pinvoiceamt	+= $p['pinvoiceamt'.$i] ;
		$sum_ps_amount		+= $p['ps_amount'.$i] ;
		}
	if ($i==1)	$t->set_var('paidlist_section',"");
	$movrowno = intval(str_replace($moverow_,"",$p[move])) ;
	if ($movrowno<>0) {
		$t->set_var('pinvnumber_fld','pinvnumber'.$i);
		$t->set_var('pinvoiceid_fld','pinvoiceid'.$i);
		$t->set_var('pduedate_fld','pduedate'.$i);
		$t->set_var('pinvoiceamt_fld','pinvoiceamt'.$i);
		$t->set_var('ps_amount_fld','ps_amount'.$i) ;
		$t->set_var('pnewsamount_fld','pnewsamount'.$i);
		$t->set_var('pinvnumber',$p['upinvnumber'.$movrowno]) ;
		$t->set_var('pinvoiceid',$p['upinvoiceid'.$movrowno]) ;
		$t->set_var('pduedate',$p['upduedate'.$movrowno]) ;
		$t->set_var('pinvoiceamt',$p['upinvoiceamt'.$movrowno]) ;
		$t->set_var('ps_amount',0) ;
		$t->set_var('pnewsamount',"") ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('paidlist_section','paidlist', True);
		$sum_pinvoiceamt	+= $p['upinvoiceamt'.$movrowno] ;
		}
	$msg = ($p[amount]>$sum_ps_amount) ? " <b>$msgunderallo</b>" : "" ;
	$t->set_var('lang_total',lang('Total Amount').$msg);
	$t->set_var('sum_pinvoiceamt',$sum_pinvoiceamt);
	$t->set_var('sum_ps_amount',$sum_ps_amount);
	$t->set_var('sum_pnewsamt',$sum_pnewsamt);
	$t->set_var('lang_upltitle',lang('List of Fully/Partially UNPAID Invoices accrued on this vendor'));
	$t->set_var('lang_upinvnumber',lang('Invoice#'));
	$t->set_var('lang_upinvoiceid',lang('Invoice ID'));
	$t->set_var('lang_upduedate',lang('Due Date'));
	$t->set_var('lang_upfullamount',lang('Full Invoice Amount'));
	$t->set_var('lang_ups_amount',lang('Amount Settled via this Payment'));
	$t->set_var('lang_ups_othamt',lang('Amount Settled via other Payments'));
	$t->set_var('lang_uppaidamount',lang('Total Amount Settled'));
	$t->set_var('lang_uposamount',lang('Outstanding Unpaid Amount'));
	$t->set_var('lang_upmove2paid',lang('Move to Paid List'));
	For ($i=1;isset($p['upinvoiceid'.$i]);$i++) {
		$t->set_var('upinvnumber_fld','upinvnumber'.$i);
		$t->set_var('upinvoiceid_fld','upinvoiceid'.$i);
		$t->set_var('upduedate_fld','upduedate'.$i);
		$t->set_var('upinvoiceamt_fld','upinvoiceamt'.$i);
		$t->set_var('ups_amount_fld','ups_amount'.$i);
		$t->set_var('ups_othamt_fld','ups_othamt'.$i);
		$t->set_var('uppaidamount_fld','uppaidamount'.$i) ;
		$t->set_var('uposamount_fld','uposamount'.$i);
		$t->set_var('upinvnumber',$p['upinvnumber'.$i]) ;
		$t->set_var('upinvoiceid',$p['upinvoiceid'.$i]) ;
		$t->set_var('upduedate',$p['upduedate'.$i]) ;
		$t->set_var('upinvoiceamt',$p['upinvoiceamt'.$i]) ;
		$t->set_var('ups_amount',$p['ups_amount'.$i]) ;
		$t->set_var('ups_othamt',$p['ups_othamt'.$i]) ;
		$t->set_var('uppaidamount',$p['uppaidamount'.$i]) ;
		$t->set_var('uposamount',$p['uposamount'.$i]) ;
		$t->set_var('rowno',$moverow_.$i) ;
			For ($j=1;isset($p['pinvoiceid'.$j]);$j++) {
			if ($p['upinvoiceid'.$i]==$p['pinvoiceid'.$j]) $t->set_var('rowno',lang("already in the list"));
			}
		if ($movrowno==$i)	$t->set_var('rowno',lang("already in the list")) ;
		if ($posted)		$t->set_var('rowno',"done") ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('unpaidlist_section','unpaidlist', True);
		}
	if ($i==1)	$t->set_var('unpaidlist_section',"");
	}

//---- Perform Payment/Invoice Matching on Balance Amount by Matching Equal Amount

    function match_equal(&$p) {
	global $phpgw ;

	if (!isset($p[upinvoiceid1]))	$message1 = lang("All Invoices already settled") ;
	   else {
		$temp = $p ;
		For ($j=1;isset($p['upinvoiceid'.$j]);$j++)	$duedate[$j] = $temp['upduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$p['upinvnumber'.$j]	=	$temp['upinvnumber'.$key] ;
			$p['upinvoiceid'.$j]	=	$temp['upinvoiceid'.$key] ;
			$p['upduedate'.$j]	=	$val ;
			$p['upinvoiceamt'.$j]	=	$temp['upinvoiceamt'.$key] ;
			$p['ups_amount'.$j]	=	$temp['ups_amount'.$key] ;
			$p['ups_othamt'.$j]	=	$temp['ups_othamt'.$key] ;
			$p['uppaidamount'.$j]	=	$temp['uppaidamount'.$key] ;
			$p['uposamount'.$j]	=	$temp['uposamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $p[amount] ;
	For ($i=1;isset($p['pinvoiceid'.$i]);$i++)	{
		$bal -= $p['ps_amount'.$i] ;
		$p['pnewsamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = lang("Payment is alreadly fully allocated.") ;
	   else {
		For ($j=1;isset($p['upinvoiceid'.$j]);$j++) {
			if ($p['uposamount'.$j]==$bal) {
				$p['ups_amount'.$j] += $bal ;
				$p['uppaidamount'.$j] += $bal ;
				$p['uposamount'.$j]  = 0 ;
				$invoiceid = $p['upinvoiceid'.$j] ;
				For ($i=1;isset($p['pinvoiceid'.$i]);$i++) {
					if ($p['pinvoiceid'.$i]==$invoiceid) {
						$p['ps_amount'.$i] += $bal ;
						$p['pnewsamount'.$i] = "" ;
						break ;
						}
					}
				if (!isset($p['pinvoiceid'.$i])) {
					$p['pinvnumber'.$i]	= $p['upinvnumber'.$j] ;
					$p['pinvoiceid'.$i]	= $p['upinvoiceid'.$j] ;
					$p['pduedate'.$i]	= $p['upduedate'.$j] ;
					$p['pinvoiceamt'.$i]	= $p['upinvoiceamt'.$j];
					$p['ps_amount'.$i]	= $bal ;
					$p['pnewsamount'.$i]	= "" ;
					}
				break ;
				}
			}
		}
	if (isset($p['upinvoiceid'.$j]))	$message3 = lang("Matching completed.  If result OK, click POST button to update.") ;
	$message = lang("No (equal) matching item found") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	if (isset($message3))		$message = $message3 ;
	return "<b>$message</b>" ;
	}

//---- Perform Payment/Invoice Matching on Balance Amount by FIFO Scheme

    function match_fifo(&$p) {
	global $phpgw ;

	if (!isset($p[upinvoiceid1]))	$message1 = lang("All Invoices already settled") ;
	   else {
		$temp = $p ;
		For ($j=1;isset($p['upinvoiceid'.$j]);$j++)	$duedate[$j] = $temp['upduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$p['upinvnumber'.$j]	=	$temp['upinvnumber'.$key] ;
			$p['upinvoiceid'.$j]	=	$temp['upinvoiceid'.$key] ;
			$p['upduedate'.$j]	=	$val ;
			$p['upinvoiceamt'.$j]	=	$temp['upinvoiceamt'.$key] ;
			$p['ups_amount'.$j]	=	$temp['ups_amount'.$key] ;
			$p['ups_othamt'.$j]	=	$temp['ups_othamt'.$key] ;
			$p['uppaidamount'.$j]	=	$temp['uppaidamount'.$key] ;
			$p['uposamount'.$j]	=	$temp['uposamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $p[amount] ;
	For ($i=1;isset($p['pinvoiceid'.$i]);$i++)	{
		$bal -= $p['ps_amount'.$i] ;
		$p['pnewsamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = lang("Payment is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($p['upinvoiceid'.$j]);$j++) {
			$uposamt = $p['uposamount'.$j] ;
			if ($uposamt>0) {
				if ($bal>=$uposamt) {
					$p['ups_amount'.$j] += $uposamt ;
					$p['uppaidamount'.$j] += $uposamt ;
					$p['uposamount'.$j]  = 0 ;
					$invoiceid = $p['upinvoiceid'.$j] ;
					For ($i=1;isset($p['pinvoiceid'.$i]);$i++) {
						if ($p['pinvoiceid'.$i]==$invoiceid) {
							$p['ps_amount'.$i] += $uposamt ;
							$p['pnewsamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($p['pinvoiceid'.$i])) {
						$p['pinvnumber'.$i]	= $p['upinvnumber'.$j] ;
						$p['pinvoiceid'.$i]	= $invoiceid ;
						$p['pduedate'.$i]	= $p['upduedate'.$j] ;
						$p['pinvoiceamt'.$i]	= $p['upinvoiceamt'.$j];
						$p['ps_amount'.$i]	+= $uposamt ;
						$p['pnewsamount'.$i]	= "" ;
						}
					$bal -= $uposamt ;
					}
				   else {
					$p['ups_amount'.$j] += $bal ;
					$p['uppaidamount'.$j] += $bal ;
					$p['uposamount'.$j]  -= $bal ;
					$invoiceid = $p['upinvoiceid'.$j] ;
					For ($i=1;(isset($p['pinvoiceid'.$i]) and $bal>0);$i++) {
						if ($p['pinvoiceid'.$i]==$invoiceid) {
							$p['ps_amount'.$i] += $bal ;
							$p['pnewsamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($p['pinvoiceid'.$i])) {
						$p['pinvnumber'.$i]	= $p['upinvnumber'.$j] ;
						$p['pinvoiceid'.$i]	= $invoiceid ;
						$p['pduedate'.$i]	= $p['upduedate'.$j] ;
						$p['pinvoiceamt'.$i]	= $p['upinvoiceamt'.$j];
						$p['ps_amount'.$i]	= $bal ;
						$p['pnewsamount'.$i]	= "" ;
						}
					$bal = 0 ;
					}
				}
			}
		}
	$message = lang("Matching completed.  If result OK, click POST button to update.") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	return "<b>$message</b>" ;
	}

//---- Clear current on-screen Payment/Invoice Matching

    function match_clear(&$p) {
	global $phpgw ;

	For ($i=1;isset($p['pinvoiceid'.$i]);$i++)	{
		$invoiceid = $p['pinvoiceid'.$i] ;
		$psamt = $p['ps_amount'.$i] ;
		For ($j=1;isset($p['upinvoiceid'.$j]);$j++) {
			if ($p['upinvoiceid'.$j]==$invoiceid) {
				$p['ups_amount'.$j] = 0 ;
				$p['uppaidamount'.$j] -= $psamt ;
				$p['uposamount'.$j]  += $psamt ;
				break ;
				}
			}
		if (!isset($p['upinvoiceid'.$j])) {
			$p['upinvnumber'.$j]	=	$p['pinvnumber'.$i] ;
			$p['upinvoiceid'.$j]	=	$invoiceid ;
			$p['upduedate'.$j]	=	$p['pduedate'.$i] ;
			$p['upinvoiceamt'.$j]	=	$p['pinvoiceamt'.$i] ;
			$p['ups_amount'.$j]	=	0 ;
			$p['ups_othamt'.$j]	=	$p['pinvoiceamt'.$i] - $psamt ;
			$p['uppaidamount'.$j]	=	$p['ups_othamt'.$j] ;
			$p['uposamount'.$j]	=	$psamt ;
			}
		unset($p['pinvoiceid'.$i]) ;
		}
	$message = lang("All (on-screen) matchings for current Invoice cleared.") ;
	return "<b>$message</b>" ;
	}

    }

?>
