<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.vendor.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class vendor {

//---- Vendor Detail Validation Checks

    function vendor_validate($v) {
	global $phpgw ;
	$err="";
	if ($v[name]=="")				$err=lang("Error: Vendor Name Missing") ;
	if ($v[contact]=="")				$err=lang("Error: Vendor Contact Missing");
	if ($v[terms] and !is_numeric($v[terms]))	$err=lang("Error: payment term must be numeric");
	if ($v[terms]<0 or $v[terms]>366)		$err=lang("Error: payment term must be 0-366 days");
	if ($v[phone] and !is_numeric($v[phone]))	$err=lang("Error: phone# must be numeric") ;
	if ($v[fax] and !is_numeric($v[fax]))		$err=lang("Error: fax# must be numeric");
	if ($v[email] and strpos($v[email],'@')=='')	$err=lang("Error: invalid email address");
	if ($err)	$err = "<b>$err</b>" ;
	return $err ;
	}

//---- Post Vendor Detail to Database

    function vendor_post($v, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $v[id] ;
	$tax = ($v[taxincluded]=='yes') ? "t" : "f" ;
	$t1 = $v[tax1] ;
	$t2 = $v[tax2] ;
	$v[terms] = ($v[terms]=="") ? 0 : $v[terms] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO vendor(id,name,addr1,addr2,addr3,addr4,terms,taxincluded,contact,phone,fax,";
			$sql.="email,notes) VALUES ('$id','$v[name]','$v[addr1]','$v[addr2]','$v[addr3]','$v[addr4]'," ;
			$sql.="'$v[terms]','$tax','$v[contact]','$v[phone]','$v[fax]','$v[email]','$v[notes]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE vendor SET name='$v[name]',addr1='$v[addr1]',addr2='$v[addr2]'," ;
			$sql.="addr3='$v[addr3]',addr4='$v[addr4]',terms='$v[terms]',taxincluded='$tax',";
			$sql.="contact='$v[contact]',phone='$v[phone]',fax='$v[fax]',email='$v[email]',";
			$sql.="notes='$v[notes]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM vendor WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE FROM vendortax WHERE vendor_id=$id and (taxtype=1 or taxtype=2)") ;
	if ($op<>'delete') {
		if ($t1<>"")	$phpgw->db->query("INSERT INTO vendortax(vendor_id,tax_id,taxtype) VALUES('$id','$t1','1')");
		if ($t2<>"")	$phpgw->db->query("INSERT INTO vendortax(vendor_id,tax_id,taxtype) VALUES('$id','$t2','2')");
		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Vendor") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Vendor Detail

    function vendor_write(&$t, &$v) {
	global $phpgw ;

	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_address',lang('Address'));
	$t->set_var('lang_terms',lang('Terms:Net'));
	$t->set_var('lang_day',lang('Days'));
	$t->set_var('lang_tax',lang('Tax Included'));
	$t->set_var('lang_taxnote',lang('Invoice Unit Price listed with Tax Included [Initial Default]'));
	$t->set_var('lang_contact',lang('Contact'));
	$t->set_var('lang_phone',lang('Phone'));
	$t->set_var('lang_fax',lang('Fax'));
	$t->set_var('lang_email',lang('E-Mail'));
	$t->set_var('lang_tax1',lang('Primary Tax'));
	$t->set_var('lang_tax2',lang('Secondary Tax'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_reserved',lang('Reserved Space'));
	$t->set_var('name',$v[name]);
	$t->set_var('id',$v[id]);
	$t->set_var('addr1',$v[addr1]);
	$t->set_var('addr2',$v[addr2]);
	$t->set_var('addr3',$v[addr3]);
	$t->set_var('addr4',$v[addr4]);
	$t->set_var('terms',$v[terms]);
	if ($v[taxincluded]=='t') 		$t->set_var('checked',"checked");
	$t->set_var('contact',$v[contact]);
	$t->set_var('phone',$v[phone]);
	$t->set_var('fax',$v[fax]);
	$t->set_var('email',$v[email]);
	$t->set_var('tax1_selectlist',tax_selectlist("WHERE taxgroup='ap'",$v[tax1]));
	$t->set_var('tax2_selectlist',tax_selectlist("WHERE taxgroup='ap'",$v[tax2]));
	$t->set_var('notes',$v[notes]);
	$t->parse('out','report',True);
	}

    }

?>
