<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.customer.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class customer {

//---- Customer Detail Validation Checks

    function customer_validate($c) {
	global $phpgw ;
	$err="";
	if ($c[name]=="")					$err=lang("Error: Customer Name Missing");
	if ($c[contact]=="")					$err=lang("Error: Customer Contact Missing");
	if ($c[phone] and !is_numeric($c[phone]))		$err=lang("Error: phone# must be numeric");
	if ($c[fax] and !is_numeric($c[fax]))			$err=lang("Error: fax# must be numeric");
	if ($c[email] and strpos($c[email],'@')=='')		$err=lang("Error: invalid email address");
	if ($c[shiptophone] and !is_numeric($c[shiptophone]))	$err=lang("Error: ship-to phone# must be numeric");
	if ($c[shiptofax] and !is_numeric($c[shiptofax]))	$err=lang("Error: ship-to fax# must be numeric");
	if ($c[shiptoemail] and strpos($c[shiptoemail],'@')=='')	$err=lang("Error: invalid ship-to email address");
	if ($c[terms] and !is_numeric($c[terms]))		$err=lang("Error: payment term must be numeric");
	if ($c[terms]<0 or $c[terms]>366)			$err=lang("Error: payment term must be 0-366 days");
	if ($c[creditlimit] and !is_numeric($c[creditlimit]))	$err=lang("Error: credit limit must be numeric");
	if ($c[discount] and !is_numeric($c[discount]))		$err=lang("Error: discount must be numeric");
	if ($c[discount]<0 or $c[discount]>1)			$err=lang("Error: discount must be 0-1");
	if ($err)	$err = "<b>$err<b>" ;
	return $err ;
	}

//---- Post Customer Detail to Database

    function customer_post($c, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $c[id] ;
	$s2a1=$c[shiptoaddr1]; $s2a2=$c[shiptoaddr2]; $s2a3=$c[shiptoaddr3]; $s2a4=$c[shiptoaddr4];
	$s2co=$c[shiptocontact]; $s2ph=$c[shiptophone]; $s2fa=$c[shiptofax]; $s2em=$c[shiptoemail];
	$tax = ($c[taxincluded]=='yes')?"t":"f" ;
	$t1 = $c[tax1] ;
	$t2 = $c[tax2] ;
	$c[terms] = ($c[terms]=="") ? 0 : $c[terms] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO customer (id,name, addr1, addr2, addr3, addr4, contact, phone, fax, email, ";
			$sql.="shiptoname, shiptoaddr1, shiptoaddr2, shiptoaddr3,  shiptoaddr4,shiptocontact, ";
			$sql.="shiptophone, shiptofax, shiptoemail, terms, creditlimit, discount, taxincluded, ";
			$sql.="notes) VALUES ('$id','$c[name]','$c[addr1]','$c[addr2]','$c[addr3]','$c[addr4]'," ;
			$sql.="'$c[contact]','$c[phone]','$c[fax]','$c[email]','$c[shiptoname]'," ;
			$sql.="'$s2a1','$s2a2','$s2a3','$s2a4','$s2co','$s2ph','$s2fa','$s2em'," ;
			$sql.="'$c[terms]','$c[creditlimit]','$c[discount]','$tax','$c[notes]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE customer SET name='$c[name]'," ;
			$sql.="addr1='$c[addr1]',addr2='$c[addr2]',addr3='$c[addr3]',addr4='$c[addr4]',";
			$sql.="contact='$c[contact]',phone='$c[phone]',fax='$c[fax]',email='$c[email]',";
			$sql.="shiptoname='$c[shiptoname]',";
			$sql.="shiptoaddr1='$s2a1',shiptoaddr2='$s2a2',shiptoaddr3='$s2a3',shiptoaddr4='$s2a4',";
			$sql.="shiptocontact='$s2co',shiptophone='$s2ph',shiptofax='$s2fa',shiptoemail='$s2em',";
			$sql.="terms='$c[terms]',creditlimit='$c[creditlimit]',discount='$c[discount]',";
			$sql.="taxincluded='$tax',notes='$c[notes]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM customer WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE FROM customertax WHERE customer_id=$id and (taxtype=1 or taxtype=2)") ;
	if ($op<>'delete') {
		if ($t1<>"")	$phpgw->db->query("INSERT INTO customertax(customer_id,tax_id,taxtype) VALUES('$id','$t1','1')");
		if ($t2<>"")	$phpgw->db->query("INSERT INTO customertax(customer_id,tax_id,taxtype) VALUES('$id','$t2','2')");
		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Customer") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Customer Detail

    function customer_write(&$t, &$c) {
	global $phpgw ;

	$t->set_var('lang_billing',lang('Billing'));
	$t->set_var('lang_shipping',lang('Shipping'));
	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_address',lang('Address'));
	$t->set_var('lang_terms',lang('Terms:Net'));
	$t->set_var('lang_day',lang('Days'));
	$t->set_var('lang_tax',lang('Tax Included'));
	$t->set_var('lang_taxnote',lang('Invoice Unit Price listed with Tax Included [Initital Default]'));
	$t->set_var('lang_contact',lang('Contact'));
	$t->set_var('lang_phone',lang('Phone'));
	$t->set_var('lang_fax',lang('Fax'));
	$t->set_var('lang_email',lang('E-Mail'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_creditlimit',lang('Credit Limit'));
	$t->set_var('lang_discount',lang('%Discount'));
	$t->set_var('lang_percent',lang('%'));
	$t->set_var('lang_tax1',lang('Primary Tax'));
	$t->set_var('lang_tax2',lang('Secondary Tax'));
	$t->set_var('lang_reserved',lang('Reserved Space'));

	$t->set_var('id',$c[id]);
	$t->set_var('name',$c[name]);
	$t->set_var('addr1',$c[addr1]);
	$t->set_var('addr2',$c[addr2]);
	$t->set_var('addr3',$c[addr3]);
	$t->set_var('addr4',$c[addr4]);
	$t->set_var('contact',$c[contact]);
	$t->set_var('phone',$c[phone]);
	$t->set_var('fax',$c[fax]);
	$t->set_var('email',$c[email]);
	$t->set_var('shiptoname',$c[shiptoname]);
	$t->set_var('shiptoaddr1',$c[shiptoaddr1]);
	$t->set_var('shiptoaddr2',$c[shiptoaddr2]);
	$t->set_var('shiptoaddr3',$c[shiptoaddr3]);
	$t->set_var('shiptoaddr4',$c[shiptoaddr4]);
	$t->set_var('shiptocontact',$c[shiptocontact]);
	$t->set_var('shiptophone',$c[shiptophone]);
	$t->set_var('shiptofax',$c[shiptofax]);
	$t->set_var('shiptoemail',$c[shiptoemail]);
	$t->set_var('terms',$c[terms]);
	$t->set_var('creditlimit',$c[creditlimit]);
	$t->set_var('discount',$c[discount]);
	$discpct = $c[discount]*100 ;
	$t->set_var('lang_discnote',lang("i.e.")." $discpct %");
	if ($c[taxincluded]=='t' or $c[taxincluded]=='yes')		$t->set_var('checked',"checked");
	$t->set_var('tax1_selectlist',tax_selectlist("WHERE taxgroup='ar'",$c[tax1]));
	$t->set_var('tax2_selectlist',tax_selectlist("WHERE taxgroup='ar'",$c[tax2]));
	$t->set_var('notes',$c[notes]);
	$t->parse('out','report',True);
	}

    }
