<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.invacctran.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class Invacctran {

//---- Invacctran Validation Checks

    function invacctran_validate($iat) {
	global $phpgw ;

	$err="";
	$date=input2date( $iat[transdate] ) ;
	if ($date=="")							$err=lang("Error: Invalid Date");
	if ($iat["description"]=="")					$err=lang("Error: Description Missing");
	$total_dr=''; $total_cr='';
	For ($i=1;isset($iat['accno'.$i]);$i++) {
		$dr			=	$iat['dr'.$i];
		$cr			=	$iat['cr'.$i];
		$total_dr		+=	$dr ;
		$total_cr		+=	$cr	;
		$row = lang("Row");  $rowi = "[$row $i]" ;
		if (!ereg('^[0-9]*\\.?[0-9]{0,2}$',$dr) or $dr<0)	$err=$rowi.lang("Error: Invalid Dr");
		if (!ereg('^[0-9]*\\.?[0-9]{0,2}$',$cr) or $cr<0)	$err=$rowi.lang("Error: Invalid Cr");
		if ($dr==0 and $cr==0)			$err=$rowi.lang("Error: Both Dr&Cr=0(delete row if needed)");
		if ($dr>0 and $cr>0)			$err=$rowi.lang("Error: Dr and Cr cannot both have value!");
		}
	if (sprintf("%01.2f",$total_dr)<>sprintf("%01.2f",$total_cr))	$err=lang("Error: Total Dr <> Cr");
	if (sprintf("%01.2f",$total_cr)<>sprintf("%01.2f",$iat[total]))
					$err=lang("Error: should not change original total Dr/Cr amt of ").$iat[total] ;
	
	$phpgw->db->query("SELECT attrib1cnval,attrib2cnval,attrib3cnval FROM defaults");
	$phpgw->db->next_record();
	if ($phpgw->db->f('attrib1cnval')=="yes") {
		$cnval = True ;
		$atval = $iat['attrib11'] ;
		For ($i=2;isset($iat['accno'.$i]);$i++)
			if ($iat['attrib1'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)			$err = lang("Error:  Attrib1 value not constant") ;
		}
	if ($phpgw->db->f('attrib2cnval')=="yes") {
		$cnval = True ;
		$atval = $iat['attrib21'] ;
		For ($i=2;isset($iat['accno'.$i]);$i++)
			if ($iat['attrib2'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)			$err = lang("Error:  Attrib2 value not constant") ;
		}
	if ($phpgw->db->f('attrib3cnval')=="yes") {
		$cnval = True ;
		$atval = $iat['attrib31'] ;
		For ($i=2;isset($iat['accno'.$i]);$i++)
			if ($iat['attrib3'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)			$err = lang("Error:  Attrib3 value not constant") ;
		}

	if ($err)	$err = "<b>$err</b>" ;
	return $err ;
	}

//---- Post invacctran to Database

    function invacctran_post($iat, &$t, $fromnt, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $iat[id] ;
	$source	= ($fromnt=="yes") ? "ARNT" : "ARWT" ;
	$desc = $iat['description'] ;
	$transdate = $iat[transdate] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql ="INSERT INTO gl (id,source,description,transdate) VALUES " ;
			$sql.="('$id','$source','$desc','$transdate')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE gl SET source='$source',description='$desc',transdate='$transdate' " ;
			$sql.="WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from gl where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE from acc_trans where trans_id='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($iat['accno'.$i]);$i++) {
			$chart_id	=	$iat['accno'.$i];
			$attrib1	=	$iat['attrib1'.$i] ;
			$attrib2	=	$iat['attrib2'.$i] ;
			$attrib3	=	$iat['attrib3'.$i] ;
			$dr		=	$iat['dr'.$i] ;
			$cr		=	$iat['cr'.$i] ;
			if ($dr==0) $amount=$cr; else $amount=-$dr;
			$attrib1 = ($attrib1=="") ? 0 : $attrib1 ;
			$attrib2 = ($attrib2=="") ? 0 : $attrib2 ;
			$attrib3 = ($attrib3=="") ? 0 : $attrib3 ;
			$sql = "INSERT INTO acc_trans (trans_id,chart_id,attrib1,attrib2,attrib3,amount,transdate)" ;
			$sql.=	"VALUES ('$id','$chart_id','$attrib1','$attrib2','$attrib3','$amount','$transdate')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Invoice Accounting Entries") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write invacctran Header

    function invacctran_header_write(&$t, $iat) {
	global $phpgw ;

	$t->set_var('lang_date',lang('Date :'));
	$t->set_var('lang_source',lang('Source :'));
	$t->set_var('lang_description',lang('Description :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_attrib1',$a1cap);
	$t->set_var('lang_attrib2',$a2cap);
	$t->set_var('lang_attrib3',$a3cap);
	$t->set_var('transdate',$iat[transdate]) ;
	$t->set_var('source',$iat[source]) ;
	$t->set_var('description',$iat[description]) ;
	$t->set_var('id',$iat[id]) ;
	$t->set_var('total',$iat[total]) ;
	$t->parse('out','report',True);
	}

//---- Write invacctran Detail

    function invacctran_detail_write(&$t, $iat, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$id = $iat[id] ;
	$phpgw->db->query('Select * from defaults');
	$phpgw->db->next_record();
	$a1cap = $phpgw->db->f('attrib1cap') ;
	$a1tbl = $phpgw->db->f('attrib1tbl') ;
	$a1sdf = $phpgw->db->f('attrib1sdesc') ;
	$a2cap = $phpgw->db->f('attrib2cap') ;
	$a2tbl = $phpgw->db->f('attrib2tbl') ;
	$a2sdf = $phpgw->db->f('attrib2sdesc') ;
	$a3cap = $phpgw->db->f('attrib3cap') ;
	$a3tbl = $phpgw->db->f('attrib3tbl') ;
	$a3sdf = $phpgw->db->f('attrib3sdesc') ;
	$a1slist = attrib_selectlist($a1tbl,$a1sdf,'','') ;
	$a2slist = attrib_selectlist($a2tbl,$a2sdf,'','') ;
	$a3slist = attrib_selectlist($a3tbl,$a3sdf,'','') ;
	$phpgw->db->query("Select ar_accno_id,amount from ar where id='$iat[id]'");
	$phpgw->db->next_record() ;
	$aracc = $phpgw->db->f('ar_accno_id') ;
	$aramt = $phpgw->db->f('amount') ;
	$phpgw->db->query("Select tax1,tax2,tax1_accno_id,tax2_accno_id from invoice where trans_id='$id'");
	while ($phpgw->db->next_record()) {
		$tax1 = sprintf("%01.2f",$phpgw->db->f('tax1')) ;
		$tax2 = sprintf("%01.2f",$phpgw->db->f('tax2')) ;
		$t1acc = $phpgw->db->f('tax1_accno_id') ;
		$t2acc = $phpgw->db->f('tax2_accno_id') ;
		$taxmask.= "$t1acc--$tax1:$t2acc--$tax2:" ;
		}
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_accno',lang('Account Number'));
	$t->set_var('lang_attrib1',lang("Attribute").":<br>$a1cap");
	$t->set_var('lang_attrib2',lang("Attribute").":<br>$a2cap");
	$t->set_var('lang_attrib3',lang("Attribute").":<br>$a3cap");
	$at1cap = $iat[attrib1_cap] ;
	$at2cap = $iat[attrib2_cap] ;
	$at3cap = $iat[attrib3_cap] ;
	$t->set_var('attrib1cap_selectlist',str_replace("'$at1cap'","'$at1cap'"." selected",$a1slist)) ;
	$t->set_var('attrib2cap_selectlist',str_replace("'$at2cap'","'$at2cap'"." selected",$a2slist)) ;
	$t->set_var('attrib3cap_selectlist',str_replace("'$at3cap'","'$at3cap'"." selected",$a3slist)) ;
	$t->set_var('lang_dr',lang('Debit'));
	$t->set_var('lang_cr',lang('Credit'));
	$t->set_var('lang_delete',lang('Delete'));
	$total_dr = 0;
	$total_cr = 0;
	$acc_list = account_selectlist("WHERE charttype='A'","") ;

	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($iat['accno'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('accno_fld','accno'.$i) ;
			$t->set_var('attrib1_fld','attrib1'.$i) ;
			$t->set_var('attrib2_fld','attrib2'.$i) ;
			$t->set_var('attrib3_fld','attrib3'.$i) ;
			$t->set_var('dr_fld','dr'.$i);
			$t->set_var('cr_fld','cr'.$i);
			$t->set_var('account_selectlist',$acc_list);
			$t->set_var('attrib1_selectlist',$a1slist) ;
			$t->set_var('attrib2_selectlist',$a2slist) ;
			$t->set_var('attrib3_selectlist',$a3slist) ;
			$t->set_var('dr',"") ;
			$t->set_var('cr',"") ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('linedisabled',"") ;
			$t->set_var('linereadonly',"") ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$chart_id	=	$iat['accno'.$i] ;
		$attrib1	=	$iat['attrib1'.$i] ;
		$attrib2	=	$iat['attrib2'.$i] ;
		$attrib3	=	$iat['attrib3'.$i] ;
		$dr		=	$iat['dr'.$i] ;
		$cr		=	$iat['cr'.$i] ;
		$total_dr	+=	$dr ;
		$total_cr	+=	$cr ;
		$accno_fld	=	'accno'.$j ;
		$attrib1_fld	=	'attrib1'.$j ;
		$attrib2_fld	=	'attrib2'.$j ;
		$attrib3_fld	=	'attrib3'.$j ;
		$dr_fld		=	'dr'.$j ;
		$cr_fld		=	'cr'.$j ;
		$t->set_var('accno_fld',$accno_fld) ;
		$t->set_var('attrib1_fld',$attrib1_fld) ;
		$t->set_var('attrib2_fld',$attrib2_fld) ;
		$t->set_var('attrib3_fld',$attrib3_fld) ;
		$t->set_var('dr_fld',$dr_fld);
		$t->set_var('cr_fld',$cr_fld);
		$t->set_var('account_selectlist',str_replace("'$chart_id'","'$chart_id' selected",$acc_list)) ;
		$t->set_var('attrib1_selectlist',str_replace("'$attrib1'","'$attrib1'"." selected",$a1slist)) ;
		$t->set_var('attrib2_selectlist',str_replace("'$attrib2'","'$attrib2'"." selected",$a2slist)) ;
		$t->set_var('attrib3_selectlist',str_replace("'$attrib3'","'$attrib3'"." selected",$a3slist)) ;
		$t->set_var('dr',$dr) ;
		$t->set_var('cr',$cr) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('linedisabled',"") ;
		$t->set_var('linereadonly',"") ;
		if ($chart_id==$aracc and $dr==$aramt)	{
			$t->set_var('account_selectlist',account_selectlist("WHERE id='$aracc'",""));
			$t->set_var('linedisabled',"disabled") ;
			$t->set_var('linereadonly',"readonly") ;
			}
		$acccr = "$chart_id--".sprintf("%01.2f",$cr) ;
		if (substr_count($taxmask,$acccr)>0)	{
			$t->set_var('account_selectlist',account_selectlist("WHERE id='$chart_id'",""));
			$t->set_var('linedisabled',"disabled") ;
			$t->set_var('linereadonly',"readonly") ;
			}
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==2 and $delrowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('accno_fld','accno'.$i) ;
		$t->set_var('attrib1_fld','attrib1'.$i) ;
		$t->set_var('attrib2_fld','attrib2'.$i) ;
		$t->set_var('attrib3_fld','attrib3'.$i) ;
		$t->set_var('dr_fld','dr'.$i);
		$t->set_var('cr_fld','cr'.$i);
		$t->set_var('account_selectlist',$acc_list);
		$t->set_var('attrib1_selectlist',$a1slist) ;
		$t->set_var('attrib2_selectlist',$a2slist) ;
		$t->set_var('attrib3_selectlist',$a3slist) ;
		$t->set_var('dr',"") ;
		$t->set_var('cr',"") ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('linedisabled',"") ;
		$t->set_var('linereadonly',"") ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_total',lang('Total'));
	$t->set_var('total_dr',sprintf("%01.2f",$total_dr)) ;
	$t->set_var('total_cr',sprintf("%01.2f",$total_cr)) ;

	$t->parse('out','report',True);
	}

    }

?>
