<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.receipt.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class receipt {

//---- Receipt Detail Validation Checks

    function receipt_validate($r) {
	global $phpgw ;
	$err=""; $error=lang("Error") ;
	$row = lang("Row") ;
	if ($r[rptnumber]=="")				$err=lang("Receipt Number Missing");
	if (input2date($r[transdate])=="")		$err=lang("Invalid Receipt Date");
	if (!is_numeric($r[amount]))			$err=lang("Receipt amount must be numeric");
	$sum_pnewsamt = 0 ;
	For ($i=1;isset($r['pinvoiceid'.$i]);$i++) {
		$pnewsamt = $r['pnewsamount'.$i] ;
		$rowi = "[$row $i]" ;
		if ($pnewsamt<0)			$err=$rowi.lang("New Amount Settled must be +ve");
		if ($pnewsamt>$r[amount])		$err=$rowi.lang("New Amount Settled > Receipt Amount");
		if ($pnewsamt>$r['pinvoiceamt'.$i])	$err=$rowi.lang("New Amount Settled > Invoice Amount");
		if (!is_numeric($pnewsamt) and strlen($pnewsamt)>0)
							$err=$rowi.lang("New Amount Settled must be numeric");
		$sum_pnewsamt += ($pnewsamt=="") ? $r['ps_amount'.$i] : $pnewsamt ;
		}
	if ($sum_pnewsamt>$r[amount])			$err=lang("Total Amount Settled > Receipt Amount");
	For ($i=1;isset($r['upinvoiceid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		if ($r['uposamount'.$i]<0)		$err=$rowi.lang("UNPAID invoice overpaid");
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Post Receipt to Database

    function receipt_post($r, &$t, &$id, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id	= $r['id'] ;
	$source	= "ARRT" ;
	$desc	= "AR: Receipt# $r[rptnumber]" ;
	$transdate = $r[transdate] ;
	$rptno	= $r[rptnumber] ;
	$cheque = $r[cheque] ;
	$customer = $r[customer] ;
	$amount	= $r[amount] ;
	$remark	= $r[remark] ;
	$dracc	= $r[dr_accno_id] ;
	$cracc	= $r[cr_accno_id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql="SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO receipt(id,rptnumber,cheque,transdate,customer,amount,remark,dr_accno_id,cr_accno_id) ";
			$sql.= "VALUES ('$id','$rptno','$cheque','$transdate','$customer','$amount','$remark','$dracc','$cracc')";
			$phpgw->db->query($sql);
			$sql = "INSERT INTO gl(id,source,description,transdate) VALUES('$id','$source','$desc','$transdate')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE receipt SET rptnumber='$rptno',cheque='$cheque',transdate='$transdate',";
			$sql.= "customer='$customer',amount='$amount',remark='$remark',dr_accno_id='$dracc',cr_accno_id='$cracc' ";
			$sql.= "WHERE id=$id";
			$phpgw->db->query($sql);
			$sql ="UPDATE gl SET source='$source',description='$desc',transdate='$transdate' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from receipt where id = $id");
			$phpgw->db->query("DELETE from gl where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	if ($op<>'new')	{
		$phpgw->db->query("DELETE from r_match where receiptid=$id");
		$phpgw->db->query("DELETE from acc_trans where trans_id=$id");
		}
	if ($op<>'delete') {
		$sql="INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) VALUES ('$id','$dracc','-$amount','$transdate')";
		$phpgw->db->query($sql);
		$sql="INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) VALUES ('$id','$cracc','$amount','$transdate')";
		$phpgw->db->query($sql);
		For ($i=1;isset($r['pinvoiceid'.$i]);$i++) {
			$s_amt = $r['pnewsamount'.$i]=="" ? $r['ps_amount'.$i] : $r['pnewsamount'.$i] ;
			if ($s_amt<>0) {
				$invid	= $r['pinvoiceid'.$i] ;
				$sql="INSERT INTO r_match (receiptid,invoiceid,s_amount) VALUES ('$id','$invid','$s_amt')";
				$phpgw->db->query($sql);
				}
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly") ;
	$msg = lang("Remember to adjust attributes of the accounting entries") ;
	$tran = lang("Receipt") ;
	$t->set_var("message2","<b>$type $tran [id#$id] $actioned.  $msg</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Receipt Header

    function receipt_header_write(&$t, $r) {
	global $phpgw ;

	$t->set_var('lang_customer',lang('Customer'));
	$t->set_var('lang_rptnumber',lang('Receipt#'));
	$t->set_var('lang_cheque',lang('Cheque#'));
	$t->set_var('lang_id',lang('Audit Id:')." ");
	$t->set_var('lang_transdate',lang('Receipt Date'));
	$t->set_var('lang_remark',lang('Remark'));
	$t->set_var('lang_amount',lang('Receipt Amount'));
	$t->set_var('lang_drpostto',lang('Receipt Amount<br>Dr to Account'));
	$t->set_var('lang_crpostto',lang('Receipt Amount<br>Cr to Account'));
	$customer = $r[customer] ;
	$t->set_var('customer',$customer) ;
	$t->set_var('oldcustomer',$customer) ;
	$t->set_var('customer_selectlist',customer_selectlist('',$customer)) ;
	$t->set_var('rptnumber',$r[rptnumber]) ;
	$t->set_var('cheque',$r[cheque]) ;
	$t->set_var('id',$r[id]) ;
	$t->set_var('transdate',$r[transdate]) ;
	$t->set_var('remark',$r[remark]) ;
	$t->set_var('amount',$r[amount]) ;
	$t->set_var('oldamount',$r[amount]) ;
	$dr_acc_list = account_selectlist("WHERE link like '%AR_paid%'",$r[dr_accno_id]);
	$t->set_var('dr_acc_selectlist',$dr_acc_list) ;
	$cr_acc_list = account_selectlist("WHERE link like '%AR:%' or link like '%AR'",$r[cr_accno_id]);
	$t->set_var('cr_acc_selectlist',$cr_acc_list) ;
	$t->parse('out','report',True);
	}

//---- Write Receipt Detail

    function receipt_detail_write(&$t,&$r,$posted) {
	global $phpgw,$phpgw_info ;

	$moverow_ = lang('Move Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_pltitle',lang('List of Fully/Partially PAID Invoices settled by this Receipt'));
	$t->set_var('lang_pinvnumber',lang('Invoice#'));
	$t->set_var('lang_pinvoiceid',lang('Invoice ID'));
	$t->set_var('lang_pduedate',lang('Due Date'));
	$t->set_var('lang_pfullamount',lang('Full Invoice Amount'));
	$t->set_var('lang_psettled',lang('Amount Settled<br>via this Receipt'));
	$t->set_var('lang_pnewsamount',lang('Amount Settled via this<br>Receipt to be Updated to'));
	$sum_pinvoiceamt = $sum_ps_amount = $sum_pnewsamt = 0 ;
	For ($i=1;isset($r['pinvoiceid'.$i]);$i++) {
		$t->set_var('pinvnumber_fld','pinvnumber'.$i);
		$t->set_var('pinvoiceid_fld','pinvoiceid'.$i);
		$t->set_var('pduedate_fld','pduedate'.$i);
		$t->set_var('pinvoiceamt_fld','pinvoiceamt'.$i);
		$t->set_var('ps_amount_fld','ps_amount'.$i) ;
		$t->set_var('pnewsamount_fld','pnewsamount'.$i);
		$t->set_var('pinvnumber',$r['pinvnumber'.$i]) ;
		$pinvoiceid = $r['pinvoiceid'.$i] ;
		$t->set_var('pinvoiceid',$pinvoiceid) ;
		$t->set_var('pduedate',$r['pduedate'.$i]) ;
		$t->set_var('pinvoiceamt',$r['pinvoiceamt'.$i]) ;
		$t->set_var('ps_amount',$r['ps_amount'.$i]) ;
		$pnewsamount = $r['pnewsamount'.$i] ;
		if (is_numeric($pnewsamount))		$t->set_var('pnewsamount',"") ;
			else				$t->set_var('pnewsamount',$pnewsamount) ;
		if (strlen($pnewsamount)>0 and is_numeric($pnewsamount)) {
			For ($j=1;isset($r['upinvoiceid'.$j]);$j++) {
				if ($pinvoiceid==$r['upinvoiceid'.$j]) {
					$r['ups_amount'.$j] = $pnewsamount ;
					$r['uppaidamount'.$j]= $r['ups_amount'.$j] + $r['ups_othamt'.$j];
					$r['uposamount'.$j] = $r['upinvoiceamt'.$j] - $r['uppaidamount'.$j] ;
					break ;
					}
				}
			if (!isset($r['upinvoiceid'.$j])) {
				$user = trim($phpgw_info["user"]["userid"]);
				$tmp = "rpt".$user.time() ;
				$sql = "CREATE TABLE $tmp AS SELECT invnumber,id,duedate,amount,0.0 as s_amount,sum(s_amount) as paidamt " ;
				$sql.=			"FROM ar,r_match WHERE id='$pinvoiceid' and invoiceid='$pinvoiceid' " ;
				$sql.=			"GROUP BY invnumber,id,duedate,amount" ;
				$phpgw->db->query($sql);
				$sql = "INSERT INTO $tmp SELECT invnumber,id,duedate,amount,s_amount,0.0 as paidamt FROM ar,r_match ";
				$sql.=			"WHERE id='$pinvoiceid' and invoiceid='$pinvoiceid' and receiptid='$r[id]' " ;
				$phpgw->db->query($sql);
				$sql = "SELECT invnumber,id,duedate,amount,sum(s_amount) as s_amount,sum(paidamt) as paidamt " ;
				$sql.=			"FROM $tmp GROUP BY invnumber,id,duedate,amount " ;
				$phpgw->db->query($sql) ;

				$phpgw->db->next_record() ;
				$r['upinvnumber'.$j]	=	$phpgw->db->f('invnumber') ;
				$r['upinvoiceid'.$j]	=	$phpgw->db->f('id') ;
				$r['upduedate'.$j]	=	$phpgw->db->f('duedate') ;
				$r['upinvoiceamt'.$j]	=	$phpgw->db->f('amount') ;
				$r['ups_amount'.$j]	=	$pnewsamount ;
				$r['ups_othamt'.$j]	=	$phpgw->db->f('paidamt')-$phpgw->db->f('s_amount');
				$r['uppaidamount'.$j]	=	$r['ups_amount'.$j] + $r['ups_othamt'.$j] ;
				$r['uposamount'.$j]	=	$r['upinvoiceamt'.$j] - $r['uppaidamount'.$j] ;

				$sql = "DROP TABLE $tmp" ;
				$phpgw->db->query($sql);
				}
			$t->set_var('ps_amount',$pnewsamount) ;
			$r['ps_amount'.$i] = $pnewsamount ;
			}
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('paidlist_section','paidlist', True);
		$sum_pinvoiceamt	+= $r['pinvoiceamt'.$i] ;
		$sum_ps_amount		+= $r['ps_amount'.$i] ;
		}
	if ($i==1)	$t->set_var('paidlist_section',"");
	$movrowno = intval(str_replace($moverow_,"",$r[move])) ;
	if ($movrowno<>0) {
		$t->set_var('pinvnumber_fld','pinvnumber'.$i);
		$t->set_var('pinvoiceid_fld','pinvoiceid'.$i);
		$t->set_var('pduedate_fld','pduedate'.$i);
		$t->set_var('pinvoiceamt_fld','pinvoiceamt'.$i);
		$t->set_var('ps_amount_fld','ps_amount'.$i) ;
		$t->set_var('pnewsamount_fld','pnewsamount'.$i);
		$t->set_var('pinvnumber',$r['upinvnumber'.$movrowno]) ;
		$t->set_var('pinvoiceid',$r['upinvoiceid'.$movrowno]) ;
		$t->set_var('pduedate',$r['upduedate'.$movrowno]) ;
		$t->set_var('pinvoiceamt',$r['upinvoiceamt'.$movrowno]) ;
		$t->set_var('ps_amount',0) ;
		$t->set_var('pnewsamount',"") ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('paidlist_section','paidlist', True);
		$sum_pinvoiceamt	+= $r['upinvoiceamt'.$movrowno] ;
		}
	$msg = ($r[amount]>$sum_ps_amount) ? lang("[Receipt underallocated to Invoice]") : "" ;
	$t->set_var('lang_total',lang('Total Amount')." ".$msg);
	$t->set_var('sum_pinvoiceamt',$sum_pinvoiceamt);
	$t->set_var('sum_ps_amount',$sum_ps_amount);
	$t->set_var('sum_pnewsamt',$sum_pnewsamt);
	$t->set_var('lang_upltitle',lang('List of Fully/Partially UNPAID Invoices accrued on this customer'));
	$t->set_var('lang_upinvnumber',lang('Invoice#'));
	$t->set_var('lang_upinvoiceid',lang('Invoice ID'));
	$t->set_var('lang_upduedate',lang('Due Date'));
	$t->set_var('lang_upfullamount',lang('Full Invoice Amount'));
	$t->set_var('lang_ups_amount',lang('Amount Settled via this Payment'));
	$t->set_var('lang_ups_othamt',lang('Amount Settled via other Payments'));
	$t->set_var('lang_uppaidamount',lang('Total Amount Settled'));
	$t->set_var('lang_uposamount',lang('Outstanding Unpaid Amount'));
	$t->set_var('lang_upmove2paid',lang('Move to Paid List'));
	For ($i=1;isset($r['upinvoiceid'.$i]);$i++) {
		$t->set_var('upinvnumber_fld','upinvnumber'.$i);
		$t->set_var('upinvoiceid_fld','upinvoiceid'.$i);
		$t->set_var('upduedate_fld','upduedate'.$i);
		$t->set_var('upinvoiceamt_fld','upinvoiceamt'.$i);
		$t->set_var('ups_amount_fld','ups_amount'.$i);
		$t->set_var('ups_othamt_fld','ups_othamt'.$i);
		$t->set_var('uppaidamount_fld','uppaidamount'.$i) ;
		$t->set_var('uposamount_fld','uposamount'.$i);
		$t->set_var('upinvnumber',$r['upinvnumber'.$i]) ;
		$t->set_var('upinvoiceid',$r['upinvoiceid'.$i]) ;
		$t->set_var('upduedate',$r['upduedate'.$i]) ;
		$t->set_var('upinvoiceamt',$r['upinvoiceamt'.$i]) ;
		$t->set_var('ups_amount',$r['ups_amount'.$i]) ;
		$t->set_var('ups_othamt',$r['ups_othamt'.$i]) ;
		$t->set_var('uppaidamount',$r['uppaidamount'.$i]) ;
		$t->set_var('uposamount',$r['uposamount'.$i]) ;
		$t->set_var('rowno',$moverow_.$i) ;
		For ($j=1;isset($r['pinvoiceid'.$j]);$j++) {
			if ($r['upinvoiceid'.$i]==$r['pinvoiceid'.$j]) $t->set_var('rowno',lang("already in the list"));
			}
		if ($movrowno==$i)	$t->set_var('rowno',lang("already in the list")) ;
		if ($posted)		$t->set_var('rowno',"done") ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('unpaidlist_section','unpaidlist', True);
		}
	if ($i==1)	$t->set_var('unpaidlist_section',"");
	}

//---- Perform Receipt/Invoice Matching on Balance Amount by Matching Equal Amount

    function match_equal(&$r) {
	global $phpgw ;

	if (!isset($r[upinvoiceid1]))	$message1 = lang("All Invoices already settled") ;
	   else {
		$temp = $r ;
		For ($j=1;isset($r['upinvoiceid'.$j]);$j++)	$duedate[$j] = $temp['upduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$r['upinvnumber'.$j]	=	$temp['upinvnumber'.$key] ;
			$r['upinvoiceid'.$j]	=	$temp['upinvoiceid'.$key] ;
			$r['upduedate'.$j]	=	$val ;
			$r['upinvoiceamt'.$j]	=	$temp['upinvoiceamt'.$key] ;
			$r['ups_amount'.$j]	=	$temp['ups_amount'.$key] ;
			$r['ups_othamt'.$j]	=	$temp['ups_othamt'.$key] ;
			$r['uppaidamount'.$j]	=	$temp['uppaidamount'.$key] ;
			$r['uposamount'.$j]	=	$temp['uposamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $r[amount] ;
	For ($i=1;isset($r['pinvoiceid'.$i]);$i++)	{
		$bal -= $r['ps_amount'.$i] ;
		$r['pnewsamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = lang("Receipt is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($r['upinvoiceid'.$j]);$j++) {
			if ($r['uposamount'.$j]==$bal) {
				$r['ups_amount'.$j] += $bal ;
				$r['uppaidamount'.$j] += $bal ;
				$r['uposamount'.$j]  = 0 ;
				$invoiceid = $r['upinvoiceid'.$j] ;
				For ($i=1;isset($r['pinvoiceid'.$i]);$i++) {
					if ($r['pinvoiceid'.$i]==$invoiceid) {
						$r['ps_amount'.$i] += $bal ;
						$r['pnewsamount'.$i] = "" ;
						break ;
						}
					}
				if (!isset($r['pinvoiceid'.$i])) {
					$r['pinvnumber'.$i]	= $r['upinvnumber'.$j] ;
					$r['pinvoiceid'.$i]	= $r['upinvoiceid'.$j] ;
					$r['pduedate'.$i]	= $r['upduedate'.$j] ;
					$r['pinvoiceamt'.$i]	= $r['upinvoiceamt'.$j];
					$r['ps_amount'.$i]	= $bal ;
					$r['pnewsamount'.$i]	= "" ;
					}
				break ;
				}
			}
		}
	if (isset($r['upinvoiceid'.$j]))	$message3 = lang("Matching completed.  If result OK, click POST button to update.") ;
	$message = lang("No (equal) matching item found") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	if (isset($message3))		$message = $message3 ;
	return "<b>$message</b>" ;
	}

//---- Perform Receipt/Invoice Matching on Balance Amount by FIFO Scheme

    function match_fifo(&$r) {
	global $phpgw ;

	if (!isset($r[upinvoiceid1]))	$message1 = lang("All Invoices already settled") ;
	   else {
		$temp = $r ;
		For ($j=1;isset($r['upinvoiceid'.$j]);$j++)	$duedate[$j] = $temp['upduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$r['upinvnumber'.$j]	=	$temp['upinvnumber'.$key] ;
			$r['upinvoiceid'.$j]	=	$temp['upinvoiceid'.$key] ;
			$r['upduedate'.$j]	=	$val ;
			$r['upinvoiceamt'.$j]	=	$temp['upinvoiceamt'.$key] ;
			$r['ups_amount'.$j]	=	$temp['ups_amount'.$key] ;
			$r['ups_othamt'.$j]	=	$temp['ups_othamt'.$key] ;
			$r['uppaidamount'.$j]	=	$temp['uppaidamount'.$key] ;
			$r['uposamount'.$j]	=	$temp['uposamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $r[amount] ;
	For ($i=1;isset($r['pinvoiceid'.$i]);$i++)	{
		$bal -= $r['ps_amount'.$i] ;
		$r['pnewsamount'.$i] = "" ;
		}

	if ($bal==0)	$message2 = lang("Receipt is alreadly fully allocated") ;
	   else	{
		For ($j=1;isset($r['upinvoiceid'.$j]);$j++) {
			$uposamt = $r['uposamount'.$j] ;
			if ($uposamt>0) {
				if ($bal>=$uposamt) {
					$r['ups_amount'.$j] += $uposamt ;
					$r['uppaidamount'.$j] += $uposamt ;
					$r['uposamount'.$j]  = 0 ;
					$invoiceid = $r['upinvoiceid'.$j] ;
					For ($i=1;isset($r['pinvoiceid'.$i]);$i++) {
						if ($r['pinvoiceid'.$i]==$invoiceid) {
							$r['ps_amount'.$i] += $uposamt ;
							$r['pnewsamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($r['pinvoiceid'.$i])) {
						$r['pinvnumber'.$i]	= $r['upinvnumber'.$j] ;
						$r['pinvoiceid'.$i]	= $invoiceid ;
						$r['pduedate'.$i]	= $r['upduedate'.$j] ;
						$r['pinvoiceamt'.$i]	= $r['upinvoiceamt'.$j];
						$r['ps_amount'.$i]	+= $uposamt ;
						$r['pnewsamount'.$i]	= "" ;
						}
					$bal -= $uposamt ;
					}
				   else {
					$r['ups_amount'.$j] += $bal ;
					$r['uppaidamount'.$j] += $bal ;
					$r['uposamount'.$j]  -= $bal ;
					$invoiceid = $r['upinvoiceid'.$j] ;
					For ($i=1;(isset($r['pinvoiceid'.$i]) and $bal>0);$i++) {
						if ($r['pinvoiceid'.$i]==$invoiceid) {
							$r['ps_amount'.$i] += $bal ;
							$r['pnewsamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($r['pinvoiceid'.$i])) {
						$r['pinvnumber'.$i]	= $r['upinvnumber'.$j] ;
						$r['pinvoiceid'.$i]	= $invoiceid ;
						$r['pduedate'.$i]	= $r['upduedate'.$j] ;
						$r['pinvoiceamt'.$i]	= $r['upinvoiceamt'.$j];
						$r['ps_amount'.$i]	= $bal ;
						$r['pnewsamount'.$i]	= "" ;
						}
					$bal = 0 ;
					}
				}
			}
		}
	$message = lang("Matching completed.  If result OK, click POST button to update.") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	return "<b>$message</b>" ;
	}

//---- Clear current on-screen Receipt/Invoice Matching

    function match_clear(&$r) {
	global $phpgw ;

	For ($i=1;isset($r['pinvoiceid'.$i]);$i++)	{
		$invoiceid = $r['pinvoiceid'.$i] ;
		$psamt = $r['ps_amount'.$i] ;
		For ($j=1;isset($r['upinvoiceid'.$j]);$j++) {
			if ($r['upinvoiceid'.$j]==$invoiceid) {
				$r['ups_amount'.$j] = 0 ;
				$r['uppaidamount'.$j] -= $psamt ;
				$r['uposamount'.$j]  += $psamt ;
				break ;
				}
			}
		if (!isset($r['upinvoiceid'.$j])) {
			$r['upinvnumber'.$j]	=	$r['pinvnumber'.$i] ;
			$r['upinvoiceid'.$j]	=	$invoiceid ;
			$r['upduedate'.$j]	=	$r['pduedate'.$i] ;
			$r['upinvoiceamt'.$j]	=	$r['pinvoiceamt'.$i] ;
			$r['ups_amount'.$j]	=	0 ;
			$r['ups_othamt'.$j]	=	$r['pinvoiceamt'.$i] - $psamt ;
			$r['uppaidamount'.$j]	=	$r['ups_othamt'.$j] ;
			$r['uposamount'.$j]	=	$psamt ;
			}
		unset($r['pinvoiceid'.$i]) ;
		}
	$message = lang("All (on-screen) matchings for current Invoice cleared") ;
	return "<b>$message</b>" ;
	}

    }

?>
