<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.suspense.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class suspense {

//---- Suspense Item Detail Validation Checks

    function suspense_validate($s) {
	global $phpgw ;
	$err="";
	if (!$s[transdate])				$err=lang("Error: Transaction date missing") ;
	if (!$s[amount])				$err=lang("Error: Amount missing") ;
	if ($s[transdate] and input2date($s[transdate])=="")
							$err=lang("Error: Invalid transaction date");
	if ($s[amount] and !is_numeric($s[amount]))	$err=lang("Error: Amount must be numeric");
	if ($err)	$err = "<b>$err</b>" ;
	return $err ;
	}

//---- Post Suspense Item Detail to Database

    function suspense_post($s, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $s[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO bkr_trans(trans_id,chart_id,source,description,cheque,refnumber,amount,transdate) ";
			$sql.="VALUES ('$id','$s[chart_id]','$s[source]','$s[description]','$s[cheque]','$s[refnumber]'," ;
			$sql.=		"'$s[amount]','$s[transdate]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE bkr_trans SET chart_id='$s[chart_id]',source='$s[source]'," ;
			$sql.="description='$s[description]',cheque='$s[cheque]',refnumber='$s[refnumber]'," ;
			$sql.="amount='$s[amount]',transdate='$s[transdate]' WHERE trans_id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM bkr_trans WHERE trans_id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("suspense Item") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Suspense Item Detail

    function suspense_write(&$t, &$s) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit ID'));
	$t->set_var('lang_chart_id',lang('Bank Account'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_transdate',lang('Transaction Date'));
	$t->set_var('lang_refnumber',lang('Reference#'));
	$t->set_var('lang_source',lang('Source'));
	$t->set_var('lang_cheque',lang('Cheque#'));
	$t->set_var('lang_amount',lang('Amount'));
	$id = ($s[id]) ? $s[id] : $s[trans_id] ;
	$t->set_var('id',$id) ;
	$default = ($s[chart_id]) ? "$s[chart_id]" : "" ;
	$chart_id_sl = account_selectlist("WHERE (link like '%AP_paid%' or link like '%AR_paid%') and category='A'",$default);
	$t->set_var('chart_id_selectlist',$chart_id_sl);
	$t->set_var('description',$s[description]);
	$t->set_var('transdate',$s[transdate]);
	$t->set_var('refnumber',$s[refnumber]);
	$source_sl = str_replace("'$s[source]'","'$s[source]'"." selected",su_source_selectlist() ) ;
	$t->set_var('source_selectlist',$source_sl);
	$t->set_var('cheque',$s[cheque]);
	$t->set_var('amount',$s[amount]);
	$t->parse('out','report',True);
	}

    }

?>
