<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.achieve.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class achieve {

//---- Achievement Code Detail Validation Checks

    function achieve_validate($a) {
	global $phpgw ;

	$err=""; $error=lang('Error') ;
	if ($a[name]=="")		$err=lang('Achievement Code Name Missing');
	if ($a[description]=="")	$err=lang('Achievement description Missing');
	if (!is_numeric($a[min]))	$err=lang('Min Level must be numeric');
	if (!is_numeric($a[max]))	$err=lang('Max Level must be numeric');
	if (!is_numeric($a[rate]))	$err=lang('Rate must be numeric');
	if (isset($a[min]) and isset($a[max]) and $a[min]>$a[max])
					$err=lang('Min Level > Max Level') ;
	if ($err)			$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Achievement Code Delete Validation Checks

    function delete_validate($a) {
	global $phpgw ;

	$err=""; $error=lang('Error') ;
	if ($a[name]=='not_applicable')	$err = lang("Achievement 'not_applicable' should not be deleted") ;
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}


//---- Post Achievement Code Detail to Database

    function achieve_post($a, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id	= $a[id] ;
	$app	= $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO achievement (id,name,description,min,max,rate) " ;
			$sql.= "VALUES('$id','$a[name]','$a[description]','$a[min]','$a[max]','$a[rate]')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE achievement SET name='$a[name]',description='$a[description]'," ;
			$sql.= "min='$a[min]',max='$a[max]',rate='$a[rate]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from achievement where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Achievement Code") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Achievement Code Detail

    function achieve_write(&$t, &$a) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_name',lang('Achievement Code Name'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_min',lang('Minimum Level'));
	$t->set_var('lang_max',lang('Maximum Level'));
	$t->set_var('lang_rate',lang('Pay Rate'));
	$id = $a[id] ;
	$t->set_var('id',$id);
	$t->set_var('name',$a[name]);
	$t->set_var('description',$a[description]);
	$t->set_var('min',$a[min]);
	$t->set_var('max',$a[max]);
	$t->set_var('rate',$a[rate]);
	$t->parse('out','report',True);
	}

    }

?>
