<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.ec.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class ec {

//---- ec Validation Checks

    function ec_validate($e) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	$row = lang("Row") ;
	$ec1=$ec2=$ec3=$nk = "" ;
	For ($i=1;isset($e['eccode'.$i]);$i++) {
		$family = $e['family'.$i] ;
		$given = $e['given'.$i] ;
		$contact = $e['contact'.$i] ;
		if ($family=="")				$err="[$row $i]".lang("Family Name Missing");
		if ($given=="")					$err="[$row $i]".lang("Given Name Missing");
		if ($contact=="")				$err="[$row $i]".lang("Contact Phone# Missing");
		if ($contact<>"" and !is_numeric($contact))	$err="[$row $i]".lang("Contact Phone# must be numeric");
		switch ($e['eccode'.$i]) :
			case "EC1" :	if ($ec1<>"") $err="[$row $i]".lang("Duplicate EC1 Emergency Contact") ;	$ec1 = "EC1" ;	break ;
			case "EC2" :	if ($ec2<>"") $err="[$row $i]".lang("Duplicate EC2 Emergency Contact") ;	$ec2 = "EC2" ;	break ;
			case "EC3" :	if ($ec3<>"") $err="[$row $i]".lang("Duplicate EC3 Emergency Contact") ;	$ec3 = "EC3" ;	break ;
			case "NK" :	if ($nk<>"") $err="[$row $i]".lang("Duplicate NK Emergency Contact") ;	$nk = "NK" ;	break ;
			endswitch ;
		}
	if ($i>1) {
		if ($ec1==""	)	$err = lang("Emergency Contact 1 missing") ;
		if ($nk=="")		$err = lang("Next of Kin Emergency Contact missing") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post ec to Database

    function ec_post($e, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $e[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :						break ;
		case "edit" :	$actioned = lang("updated") ;		break ;
		case "delete" :						break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE from ec where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($e['eccode'.$i]);$i++) {
			$prefix = $e['prefix'.$i] ;
			$family = $e['family'.$i] ;
			$given = $e['given'.$i] ;
			$suffix = $e['suffix'.$i] ;
			$contact = $e['contact'.$i] ;
			$relation = $e['relation'.$i] ;
			$eccode = $e['eccode'.$i] ;
			$sql = "INSERT INTO ec(empid,prefix,family,given,suffix,contact,relation,eccode) " ;
			$sql.= "VALUES('$id','$prefix','$family','$given','$suffix','$contact','$relation','$eccode')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Emergency Contact for Employee") ;
	$t->set_var("message","<b>$tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write ec Header

    function ec_header_write(&$t, $e) {
	global $phpgw ;

	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$e[name]) ;
	$t->set_var('id',$e[id]) ;
	$t->parse('out','report',True);
	}

//---- Write ec Detail

    function ec_detail_write(&$t, $e, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$id = $e[id] ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_prefix',lang("Prefix"));
	$t->set_var('lang_family',lang("Family Name"));
	$t->set_var('lang_given',lang("Given Name"));
	$t->set_var('lang_suffix',lang("Suffix"));
	$t->set_var('lang_contact',lang("Contact Phone"));
	$t->set_var('lang_relation',lang("Relationship"));
	$t->set_var('lang_pointer',"=>");
	$t->set_var('lang_eccode',lang("EC Code -- Description") );
	$t->set_var('lang_delete',lang('Delete'));
	
	$blankopt = "<OPTION value=''></OPTION>" ;
	$lang_prefix = lang('prefix') ;
	$lang_suffix = lang('suffix') ;
	$lang_relation = lang('relation') ;
	$lang_ec = lang('ec') ;
	$prefix_sl = hrcodename_selectlist("WHERE type='$lang_prefix'",'',"short") ;
	$suffix_sl = $blankopt.hrcodename_selectlist("WHERE type='$lang_suffix'",'',"short") ;
	$relation_sl = hrcodename_selectlist("WHERE type='$lang_relation'",'',"long") ;
	$eccode_sl = hrcodename_selectlist("WHERE type='$lang_ec'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($e['eccode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('prefix_fld','prefix'.$i) ;
			$t->set_var('family_fld','family'.$i) ;
			$t->set_var('given_fld','given'.$i) ;
			$t->set_var('suffix_fld','suffix'.$i) ;
			$t->set_var('contact_fld','contact'.$i) ;
			$t->set_var('relation_fld','relation'.$i) ;
			$t->set_var('eccode_fld','eccode'.$i) ;
			$t->set_var('prefix_selectlist',$prefix_sl) ;
			$t->set_var('family','') ;
			$t->set_var('given','') ;
			$t->set_var('suffix_selectlist',$suffix_sl) ;
			$t->set_var('contact','') ;
			$t->set_var('relation_selectlist',$relation_sl) ;
			$t->set_var('eccode_selectlist',$eccode_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$prefix		=	$e['prefix'.$i] ;
		$suffix		=	$e['suffix'.$i] ;
		$relation	=	$e['relation'.$i] ;
		$eccode		=	$e['eccode'.$i] ;

		$t->set_var('prefix_fld','prefix'.$j) ;
		$t->set_var('family_fld','family'.$j) ;
		$t->set_var('given_fld','given'.$j) ;
		$t->set_var('suffix_fld','suffix'.$j) ;
		$t->set_var('contact_fld','contact'.$j) ;
		$t->set_var('relation_fld','relation'.$j) ;
		$t->set_var('eccode_fld','eccode'.$j) ;

		$t->set_var('prefix_selectlist',str_replace("'$prefix'","'$prefix' selected",$prefix_sl)) ;
		$t->set_var('family',$e['family'.$i]) ;
		$t->set_var('given',$e['given'.$i]) ;
		$t->set_var('suffix_selectlist',str_replace("'$suffix'","'$suffix' selected",$suffix_sl)) ;
		$t->set_var('contact',$e['contact'.$i]) ;
		$t->set_var('relation_selectlist',str_replace("'$relation'","'$relation' selected",$relation_sl)) ;
		$t->set_var('eccode_selectlist',str_replace("'$eccode'","'$eccode' selected",$eccode_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('prefix_fld','prefix'.$i) ;
		$t->set_var('family_fld','family'.$i) ;
		$t->set_var('given_fld','given'.$i) ;
		$t->set_var('suffix_fld','suffix'.$i) ;
		$t->set_var('contact_fld','contact'.$i) ;
		$t->set_var('relation_fld','relation'.$i) ;
		$t->set_var('eccode_fld','eccode'.$i) ;
		$t->set_var('prefix_selectlist',$prefix_sl) ;
		$t->set_var('family','') ;
		$t->set_var('given','') ;
		$t->set_var('suffix_selectlist',$suffix_sl) ;
		$t->set_var('contact','') ;
		$t->set_var('relation_selectlist',$relation_sl) ;
		$t->set_var('eccode_selectlist',$eccode_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

    }

?>

