<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.email.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class email {

//---- Email Validation Checks

    function email_validate($e) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	$row = lang("Row") ;
	$busi=$priv=$proj= "" ;
	For ($i=1;isset($e['emailcode'.$i]);$i++) {
		$prefix = $e['prefix'.$i] ;
		$suffix = $e['suffix'.$i] ;
		if ($prefix=="")				$err="[$row $i]".lang("email prefix missing");
		if ($suffix=="")				$err="[$row $i]".lang("email suffix missing");
		switch ($e['emailcode'.$i]) :
			case "BUSI" :	$busi = "BUSI" ;	break ;
			case "PRIV" :	$priv = "PRIV" ;	break ;
			case "PROJ" :	$proj = "PROJ" ;	break ;
			endswitch ;
		}
	if ($i>1) {
		if ($busi=="")		$err = lang("BUSI email missing") ;
		if ($priv=="")		$err = lang("PRIV email missing") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Email to Database

    function email_post($e, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $e[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :						break ;
		case "edit" :	$actioned = lang("updated") ;		break ;
		case "delete" :						break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE from email where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($e['emailcode'.$i]);$i++) {
			$prefix = $e['prefix'.$i] ;
			$suffix = $e['suffix'.$i] ;
			$emailcode = $e['emailcode'.$i] ;
			$sql = "INSERT INTO email(empid,prefix,suffix,emailcode) " ;
			$sql.= "VALUES('$id','$prefix','$suffix','$emailcode')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Email for Employee") ;
	$t->set_var("message","<b>$tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Email Header

    function email_header_write(&$t, $e) {
	global $phpgw ;

	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$e[name]) ;
	$t->set_var('id',$e[id]) ;
	$t->parse('out','report',True);
	}

//---- Write Email Detail

    function email_detail_write(&$t, $e, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$lang_email = lang('email') ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$id = $e[id] ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_prefix',lang("Prefix"));
	$t->set_var('lang_act',"@");
	$t->set_var('lang_suffix',lang("Suffix"));
	$t->set_var('lang_pointer',"=>");
	$t->set_var('lang_emailcode',lang("Email Code -- Description") );
	$t->set_var('lang_delete',lang('Delete'));

	$emailcode_sl = hrcodename_selectlist("WHERE type='$lang_email'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($e['emailcode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('prefix_fld','prefix'.$i) ;
			$t->set_var('suffix_fld','suffix'.$i) ;
			$t->set_var('emailcode_fld','emailcode'.$i) ;
			$t->set_var('prefix','') ;
			$t->set_var('suffix','') ;
			$t->set_var('emailcode_selectlist',$emailcode_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$emailcode	=	$e['emailcode'.$i] ;

		$t->set_var('prefix_fld','prefix'.$j) ;
		$t->set_var('suffix_fld','suffix'.$j) ;
		$t->set_var('emailcode_fld','emailcode'.$j) ;

		$t->set_var('prefix',$e['prefix'.$i]) ;
		$t->set_var('suffix',$e['suffix'.$i]) ;
		$t->set_var('emailcode_selectlist',str_replace("'$emailcode'","'$emailcode' selected",$emailcode_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('prefix_fld','prefix'.$i) ;
		$t->set_var('suffix_fld','suffix'.$i) ;
		$t->set_var('emailcode_fld','emailcode'.$i) ;
		$t->set_var('prefix','') ;
		$t->set_var('suffix','') ;
		$t->set_var('emailcode_selectlist',$emailcode_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

    }

?>

