<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.hrcode.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class hrcode {

//---- HR Code Detail Validation Checks

    function hrcode_validate($h) {
	global $phpgw ;
	$err=""; $error=lang("Error") ;
	$maxname = 5 ;
	$maxdesc = 25 ;
	$desc = $h[description] ;
	if ($h[name]=="")			$err = lang("HR code name Missing") ;
	   else if (strlen($h[name])>$maxname)	$err = lang("HR code name too long") ;
	if ($desc=="")				$err = lang("HR code description Missing") ;
	   else if (strlen($desc)>$maxdesc)	$err = lang("HR code description too long") ;
	if ($h[type]<>$h[oldtype] or $h[name]<>$h[oldname]) {
		$phpgw->db->query("SELECT * from hrcode where type='$h[type]' and name='$h[name]'");
		if ($phpgw->db->num_rows()>0)	$err = lang("Type/Name Combo already exists") ;
		}
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- HR Code Delete Validation Checks

    function delete_validate($h) {
	global $phpgw ;
	
	$err=""; $error=lang('Error') ;
	$allow = $h[allowdelete] ;
	if ($allow<>"y" and $allow<>"Y")	$err = lang("HR code flagged deletion not allowed") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post HR Code Detail to Database

    function hrcode_post($h, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id	= $h[id] ;
	$app	= $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO hrcode(id,type,name,description,allowdelete) " ;
			$sql.= "VALUES('$id','$h[type]','$h[name]','$h[description]','$h[allowdelete]')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE hrcode SET type='$h[type]',name='$h[name]'," ;
			$sql.= "description='$h[description]',allowdelete='$h[allowdelete]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from hrcode where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("HR Code") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write HR Code Detail

    function hrcode_write(&$t, $h) {
	global $phpgw ;

	$noyes_sl = "<OPTION value='n'>".lang('No')."</OPTION>" ;
	$noyes_sl.= "<OPTION value='y'>".lang('Yes')."</OPTION>" ;
	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_type',lang('HR Code Type'));
	$t->set_var('lang_name',lang('HR Code Name'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_adelete',lang('Allow Delete'));
	$t->set_var('id',$h[id]);
	$t->set_var('type_selectlist',hrcodetype_selectlist('',$h[type]));
	$t->set_var('oldtype',$h[oldtype]);
	$t->set_var('name',$h[name]);
	$t->set_var('oldname',$h[oldname]);
	$t->set_var('description',$h[description]);
	$ad_sl = str_replace("'$h[allowdelete]'","'$h[allowdelete]' selected",$noyes_sl) ;
	$t->set_var('adelete_selectlist',$ad_sl);
	$t->parse('out','report',True);
	}

    }

?>
