<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.leave.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class leave {

//---- Leave Validation Checks

    function leave_validate($l) {
	global $phpgw ;

	$err=""; $error = lang("Error") ;
	$row = lang("Row") ;
	if (!isset($l[fromyear1]))			return $err ;
	$al=$cl=$ji=$js=$ml=$sl=$ua=$ul = "" ;
	For ($i=1;isset($l['fromyear'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		$fromdate = input2date($l['fromyear'.$i].'-'.$l['frommonth'.$i].'-'.$l['fromday'.$i]) ;
		if ($fromdate=="") {
			$err=$rowi.lang("Invalid From Date");
			$errRow[$i] = True ;
			}
		$todate = input2date($l['toyear'.$i].'-'.$l['tomonth'.$i].'-'.$l['today'.$i]) ;
		if ($todate=="") {
			$err=$rowi.lang("Invalid To Date");
			$errRow[$i] = True ;
			}
		$leavefrom[$i] = strtotime($fromdate) ;
		$leaveto[$i] = strtotime($todate) ;
		if ($fromdate<>"" and $todate<>"" and $leavefrom[$i]>$leaveto[$i]) {
			$err=$rowi.lang("From Date later than To Date") ;
			$errRow[$i] = True ;
			}
		$duration = $l['duration'.$i] ;
		if ($duration=='' or $duration==0)	$err=$rowi.lang("invalid Workdays figure") ;
		if ($duration*10%5 <>0)			$err=$rowi.lang("Workdays must be whole day or half a day") ;
		if ($fromdate<>"" and $todate<>"" and ($leaveto[$i]-$leavefrom[$i])<(($duration-1)*24*60*60))
							$err=$rowi.lang("Work Days > Period duration") ;
		if ($l['fromyear'.$i]<>$l['toyear'.$i])	$err=$rowi.lang("From year must equal To year") ;
		}
	$size = $i-1 ;
	For ($i=1;$i<$size;$i++) {
		For ($j=$i+1;$j<=$size;$j++) {
			$rowij = "[$row $i/$j]" ;
			if (!$errRow[$i] and !$errRow[$j] and $leavefrom[$j]>=$leavefrom[$i] and $leavefrom[$j]<=$leaveto[$i])
							$err=$rowij.lang("overlapping leave periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $leaveto[$j]>=$leavefrom[$i] and $leaveto[$j]<=$leaveto[$i])
							$err=$rowij.lang("overlapping leave periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $leavefrom[$i]>=$leavefrom[$j] and $leavefrom[$i]<=$leaveto[$j])
							$err=$rowij.lang("overlapping leave periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $leaveto[$i]>=$leavefrom[$j] and $leaveto[$i]<=$leaveto[$j])
							$err=$rowij.lang("overlapping leave periods") ;
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Leave to Database

    function leave_post($l, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $l[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :						break ;
		case "edit" :	$actioned = lang("updated") ;		break ;
		case "delete" :						break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE from leave where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($l['fromyear'.$i]);$i++) {
			$leavefrom	=	$l['fromyear'.$i].'-'.$l['frommonth'.$i].'-'.$l['fromday'.$i] ;
			$leaveto	=	$l['toyear'.$i].'-'.$l['tomonth'.$i].'-'.$l['today'.$i] ;
			$leavecode	=	$l['leavecode'.$i] ;
			$duration	=	$l['duration'.$i] ;
			$sql = "INSERT INTO leave (empid,leavefrom,leaveto,leavecode,duration) " ;
			$sql.= "VALUES ('$id','$leavefrom','$leaveto','$leavecode','$duration')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Record for Employee") ;
	$t->set_var("message","<b>$tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Leave Header

    function leave_header_write(&$t, $l) {
	global $phpgw ;

	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$l[name]) ;
	$t->set_var('id',$l[id]) ;
	$t->parse('out','report',True);
	}

//---- Write Leave Detail

    function leave_detail_write(&$t, $l, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$id = $l[id] ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_fromyear',lang('From<br>Year'));
	$t->set_var('lang_frommonth',lang('From<br>Month'));
	$t->set_var('lang_fromday',lang('From<br>Day'));
	$t->set_var('lang_hyphen','-');
	$t->set_var('lang_toyear',lang('To<br>Year'));
	$t->set_var('lang_tomonth',lang('To<br>Month'));
	$t->set_var('lang_today',lang('To<br>Day'));
	$t->set_var('lang_pointer',"=>");
	$t->set_var('lang_leavecode',lang('Leave Code -- Description'));
	$t->set_var('lang_duration',lang('Work Days'));
	$t->set_var('lang_delete',lang('Delete'));
	$lang_leave = lang('leave') ;

	$blankopt = "<OPTION value=''></OPTION>" ;
	$year_sl = year_selectlist('','') ;
	$month_sl = month_selectlist('','') ;
	$day_sl = day_selectlist('','') ;
	$leavecode_sl = hrcodename_selectlist("WHERE type='$lang_leave'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($l['fromyear'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('fromyear_fld','fromyear'.$i) ;
			$t->set_var('frommonth_fld','frommonth'.$i) ;
			$t->set_var('fromday_fld','fromday'.$i) ;
			$t->set_var('toyear_fld','toyear'.$i) ;
			$t->set_var('tomonth_fld','tomonth'.$i) ;
			$t->set_var('today_fld','today'.$i) ;
			$t->set_var('leavecode_fld','leavecode'.$i) ;
			$t->set_var('duration_fld','duration'.$i);
			$t->set_var('fromyear_selectlist',$year_sl);
			$t->set_var('frommonth_selectlist',$month_sl) ;
			$t->set_var('fromday_selectlist',$day_sl) ;
			$t->set_var('toyear_selectlist',$year_sl);
			$t->set_var('tomonth_selectlist',$month_sl) ;
			$t->set_var('today_selectlist',$day_sl) ;
			$t->set_var('leavecode_selectlist',$leavecode_sl) ;
			$t->set_var('duration','') ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$fromyear	=	$l['fromyear'.$i] ;
		$frommonth	=	$l['frommonth'.$i] ;
		$fromday	=	$l['fromday'.$i] ;
		$toyear		=	$l['toyear'.$i] ;
		$tomonth	=	$l['tomonth'.$i] ;
		$today		=	$l['today'.$i] ;
		$leavecode	=	$l['leavecode'.$i] ;
		$duration	=	$l['duration'.$i] ;

		$t->set_var('fromyear_fld','fromyear'.$j) ;
		$t->set_var('frommonth_fld','frommonth'.$j) ;
		$t->set_var('fromday_fld','fromday'.$j) ;
		$t->set_var('toyear_fld','toyear'.$j) ;
		$t->set_var('tomonth_fld','tomonth'.$j) ;
		$t->set_var('today_fld','today'.$j) ;
		$t->set_var('leavecode_fld','leavecode'.$j) ;
		$t->set_var('duration_fld','duration'.$j);
		$t->set_var('fromyear_selectlist',str_replace("'$fromyear'","'$fromyear' selected",$year_sl)) ;
		$t->set_var('frommonth_selectlist',str_replace("'$frommonth'","'$frommonth' selected",$month_sl)) ;
		$t->set_var('fromday_selectlist',str_replace("'$fromday'","'$fromday' selected",$day_sl)) ;
		$t->set_var('toyear_selectlist',str_replace("'$toyear'","'$toyear' selected",$year_sl)) ;
		$t->set_var('tomonth_selectlist',str_replace("'$tomonth'","'$tomonth' selected",$month_sl)) ;
		$t->set_var('today_selectlist',str_replace("'$today'","'$today' selected",$day_sl)) ;
		$t->set_var('leavecode_selectlist',str_replace("'$leavecode'","'$leavecode' selected",$leavecode_sl)) ;
		$t->set_var('duration',$duration) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('fromyear_fld','fromyear'.$i) ;
		$t->set_var('frommonth_fld','frommonth'.$i) ;
		$t->set_var('fromday_fld','fromday'.$i) ;
		$t->set_var('toyear_fld','toyear'.$i) ;
		$t->set_var('tomonth_fld','tomonth'.$i) ;
		$t->set_var('today_fld','today'.$i) ;
		$t->set_var('leavecode_fld','leavecode'.$i) ;
		$t->set_var('duration_fld','duration'.$i);
		$t->set_var('fromyear_selectlist',$year_sl);
		$t->set_var('frommonth_selectlist',$month_sl) ;
		$t->set_var('fromday_selectlist',$day_sl) ;
		$t->set_var('toyear_selectlist',$year_sl);
		$t->set_var('tomonth_selectlist',$month_sl) ;
		$t->set_var('today_selectlist',$day_sl) ;
		$t->set_var('leavecode_selectlist',$leavecode_sl) ;
		$t->set_var('duration','') ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

    }

?>
