<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.pr.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class pr {

//---- pr Validation Checks

    function pr_validate($p) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	$row = lang("Row") ;
	if (!isset($p[fromyear1]))			return $err ;
	$al=$cl=$ji=$js=$ml=$sl=$ua=$ul = "" ;
	For ($i=1;isset($p['fromyear'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		$fromdate = input2date($p['fromyear'.$i].'-'.$p['frommonth'.$i].'-'.$p['fromday'.$i]) ;
		if ($fromdate=="") {
			$err=$rowi.lang("Invalid Period From Date");
			$errRow[$i] = True ;
			}
		$todate = input2date($p['toyear'.$i].'-'.$p['tomonth'.$i].'-'.$p['today'.$i]) ;
		if ($todate=="") {
			$err=$rowi.lang("Invalid Period To Date");
			$errRow[$i] = True ;
			}
		$pddate = input2date($p['pdyear'.$i].'-'.$p['pdmonth'.$i].'-'.$p['pdday'.$i]) ;
		if ($pddate=="") {
			$err=$rowi.lang("Invalid (discussion with staff) Date");
			$errRow[$i] = True ;
			}
		$prfrom[$i] = strtotime($fromdate) ;
		$prto[$i] = strtotime($todate) ;
		$prpd[$i] = strtotime($pddate) ;
		if ($fromdate<>"" and $todate<>"" and $prfrom[$i]>$prto[$i]) {
			$err=$rowi.lang("Period From Date later than Period To Date") ;
			$errRow[$i] = True ;
			}
		if ($todate<>"" and $pddate<>"" and $prpd[$i]<$prto[$i]) {
			$err=$rowi.lang("Discussion made before Period End") ;
			$errRow[$i] = True ;
			}
		if ($p[id]==$p['reviewer'.$i]) {
			$err=$rowi.lang("Staff cannot review one's ownself") ;
			$errRow[$i] = True ;
			}
		}
	$size = $i-1 ;
	For ($i=1;$i<$size;$i++) {
		For ($j=$i+1;$j<=$size;$j++) {
			$rowij = "[$row $i/$j]" ;
			if (!$errRow[$i] and !$errRow[$j] and $prfrom[$j]>=$prfrom[$i] and $prfrom[$j]<=$prto[$i])
							$err=$rowij.lang("Overlapping performance periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $prto[$j]>=$prfrom[$i] and $prto[$j]<=$prto[$i])
							$err=$rowij.lang("Overlapping performance periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $prfrom[$i]>=$prfrom[$j] and $prfrom[$i]<=$prto[$j])
							$err=$rowij.lang("Overlapping performance periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $prto[$i]>=$prfrom[$j] and $prto[$i]<=$prto[$j])
							$err=$rowij.lang("Overlapping performance periods") ;
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post pr to Database

    function pr_post($p, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $p[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :						break ;
		case "edit" :	$actioned = lang("updated") ;		break ;
		case "delete" :						break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE from pr where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($p['fromyear'.$i]);$i++) {
			$prfrom	=	$p['fromyear'.$i].'-'.$p['frommonth'.$i].'-'.$p['fromday'.$i] ;
			$prto	=	$p['toyear'.$i].'-'.$p['tomonth'.$i].'-'.$p['today'.$i] ;
			$prcode	=	$p['prcode'.$i] ;
			$comment =	$p['comment'.$i] ;
			$reviewer =	$p['reviewer'.$i] ;
			$prpd	=	$p['pdyear'.$i].'-'.$p['pdmonth'.$i].'-'.$p['pdday'.$i] ;
			$sql = "INSERT INTO pr (empid,prfrom,prto,prcode,comment,reviewer,pddate) " ;
			$sql.= "VALUES ('$id','$prfrom','$prto','$prcode','$comment','$reviewer','$prpd')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Performance Review for Employee") ;
	$t->set_var("message","<b>$tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write pr Header

    function pr_header_write(&$t, $p) {
	global $phpgw ;

	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$p[name]) ;
	$t->set_var('id',$p[id]) ;
	$t->parse('out','report',True);
	}

//---- Write Performance Review Detail

    function pr_detail_write(&$t, $p, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$id = $p[id] ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_from',lang('Period From'));
	$t->set_var('lang_to',lang('Period To'));
	$t->set_var('lang_performance',lang('Performance Level'));
	$t->set_var('lang_pddate',lang('Discussed with Staff On'));
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_year',lang('Year'));
	$t->set_var('lang_month',lang('Month'));
	$t->set_var('lang_day',lang('Day'));
	$t->set_var('lang_hyphen','-');
	$t->set_var('lang_prcode',lang("Code -- Description")."<br>".lang("[TBC - to be considered]") );
	$t->set_var('lang_comment',lang('Comment by Reviewer'));
	$t->set_var('lang_reviewer',lang('Performance reviewed by'));
	$t->set_var('lang_delete',lang('Delete'));

	$blankopt = "<OPTION value=''></OPTION>" ;
	$lang_pr = lang('pr') ;
	$year_sl = year_selectlist('','') ;
	$month_sl = month_selectlist('','') ;
	$day_sl = day_selectlist('','') ;
	$prcode_sl = hrcodename_selectlist("WHERE type='$lang_pr'",'',"long") ;
	$reviewer_sl = employee_selectlist('','') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($p['fromyear'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('fromyear_fld','fromyear'.$i) ;
			$t->set_var('frommonth_fld','frommonth'.$i) ;
			$t->set_var('fromday_fld','fromday'.$i) ;
			$t->set_var('toyear_fld','toyear'.$i) ;
			$t->set_var('tomonth_fld','tomonth'.$i) ;
			$t->set_var('today_fld','today'.$i) ;
			$t->set_var('prcode_fld','prcode'.$i) ;
			$t->set_var('comment_fld','comment'.$i);
			$t->set_var('reviewer_fld','reviewer'.$i);
			$t->set_var('pdyear_fld','pdyear'.$i) ;
			$t->set_var('pdmonth_fld','pdmonth'.$i) ;
			$t->set_var('pdday_fld','pdday'.$i) ;
			$t->set_var('fromyear_selectlist',$year_sl);
			$t->set_var('frommonth_selectlist',$month_sl) ;
			$t->set_var('fromday_selectlist',$day_sl) ;
			$t->set_var('toyear_selectlist',$year_sl);
			$t->set_var('tomonth_selectlist',$month_sl) ;
			$t->set_var('today_selectlist',$day_sl) ;
			$t->set_var('prcode_selectlist',$prcode_sl) ;
			$t->set_var('comment','') ;
			$t->set_var('reviewer_selectlist',$reviewer_sl) ;
			$t->set_var('pdyear_selectlist',$year_sl);
			$t->set_var('pdmonth_selectlist',$month_sl) ;
			$t->set_var('pdday_selectlist',$day_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$fromyear	=	$p['fromyear'.$i] ;
		$frommonth	=	$p['frommonth'.$i] ;
		$fromday	=	$p['fromday'.$i] ;
		$toyear		=	$p['toyear'.$i] ;
		$tomonth	=	$p['tomonth'.$i] ;
		$today		=	$p['today'.$i] ;
		$prcode		=	$p['prcode'.$i] ;
		$comment	=	$p['comment'.$i] ;
		$reviewer	=	$p['reviewer'.$i] ;
		$pdyear		=	$p['pdyear'.$i] ;
		$pdmonth	=	$p['pdmonth'.$i] ;
		$pdday		=	$p['pdday'.$i] ;

		$t->set_var('fromyear_fld','fromyear'.$j) ;
		$t->set_var('frommonth_fld','frommonth'.$j) ;
		$t->set_var('fromday_fld','fromday'.$j) ;
		$t->set_var('toyear_fld','toyear'.$j) ;
		$t->set_var('tomonth_fld','tomonth'.$j) ;
		$t->set_var('today_fld','today'.$j) ;
		$t->set_var('prcode_fld','prcode'.$j) ;
		$t->set_var('comment_fld','comment'.$j);
		$t->set_var('reviewer_fld','reviewer'.$j);
		$t->set_var('pdyear_fld','pdyear'.$j) ;
		$t->set_var('pdmonth_fld','pdmonth'.$j) ;
		$t->set_var('pdday_fld','pdday'.$j) ;
		$t->set_var('fromyear_selectlist',str_replace("'$fromyear'","'$fromyear' selected",$year_sl)) ;
		$t->set_var('frommonth_selectlist',str_replace("'$frommonth'","'$frommonth' selected",$month_sl)) ;
		$t->set_var('fromday_selectlist',str_replace("'$fromday'","'$fromday' selected",$day_sl)) ;
		$t->set_var('toyear_selectlist',str_replace("'$toyear'","'$toyear' selected",$year_sl)) ;
		$t->set_var('tomonth_selectlist',str_replace("'$tomonth'","'$tomonth' selected",$month_sl)) ;
		$t->set_var('today_selectlist',str_replace("'$today'","'$today' selected",$day_sl)) ;
		$t->set_var('prcode_selectlist',str_replace("'$prcode'","'$prcode' selected",$prcode_sl)) ;
		$t->set_var('comment',$comment) ;
		$t->set_var('reviewer_selectlist',str_replace("'$reviewer'","'$reviewer' selected",$reviewer_sl)) ;
		$t->set_var('pdyear_selectlist',str_replace("'$pdyear'","'$pdyear' selected",$year_sl)) ;
		$t->set_var('pdmonth_selectlist',str_replace("'$pdmonth'","'$pdmonth' selected",$month_sl)) ;
		$t->set_var('pdday_selectlist',str_replace("'$pdday'","'$pdday' selected",$day_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('fromyear_fld','fromyear'.$i) ;
		$t->set_var('frommonth_fld','frommonth'.$i) ;
		$t->set_var('fromday_fld','fromday'.$i) ;
		$t->set_var('toyear_fld','toyear'.$i) ;
		$t->set_var('tomonth_fld','tomonth'.$i) ;
		$t->set_var('today_fld','today'.$i) ;
		$t->set_var('prcode_fld','prcode'.$i) ;
		$t->set_var('comment_fld','comment'.$i);
		$t->set_var('reviewer_fld','reviewer'.$i);
		$t->set_var('pdyear_fld','pdyear'.$i) ;
		$t->set_var('pdmonth_fld','pdmonth'.$i) ;
		$t->set_var('pdday_fld','pdday'.$i) ;
		$t->set_var('fromyear_selectlist',$year_sl);
		$t->set_var('frommonth_selectlist',$month_sl) ;
		$t->set_var('fromday_selectlist',$day_sl) ;
		$t->set_var('toyear_selectlist',$year_sl);
		$t->set_var('tomonth_selectlist',$month_sl) ;
		$t->set_var('today_selectlist',$day_sl) ;
		$t->set_var('prcode_selectlist',$prcode_sl) ;
		$t->set_var('comment','') ;
		$t->set_var('reviewer_selectlist',$reviewer_sl) ;
		$t->set_var('pdyear_selectlist',$year_sl);
		$t->set_var('pdmonth_selectlist',$month_sl) ;
		$t->set_var('pdday_selectlist',$day_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

    }

?>
