<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.timesheet.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class timesheet {

//---- timesheet Validation Checks

    function timesheet_validate($ts) {
	global $phpgw,$phpgw_info ;

	$err="";
	$error = lang("Error") ;
	$row = lang("Row") ;
	$lang_na = lang('not_applicable') ;
	$lang_leave = lang('leave') ;
	$phpgw->db->query("SELECT * FROM achievement WHERE name='$lang_na'");
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$achinaid = $phpgw->db->f('id');
	$leavecodes = hrcodename_selectlist("WHERE type='$lang_leave'",'','short') ;
	$hour_ttl = 0 ;
	For ($i=1;isset($ts['tsyear'.$i]);$i++) {
		$rowi = "[$row $i] " ;
		$tsyear = $ts['tsyear'.$i] ;
		$tsmonth = $ts['tsmonth'.$i] ;
		$tsday = $ts['tsday'.$i] ;
		$date = input2date("$tsyear-$tsmonth-$tsday") ;
		$activity = $ts['activity'.$i] ;
		$hour = $ts['hour'.$i] ;
		$day = $ts['day'.$i] ;
		if ($date=="")				$err=$rowi.lang("Invalid Date");
		$dateweek = date('W',mktime(0,0,0,$tsmonth,$tsday,$tsyear)) ;
		if ($dateweek<>$ts[week] and $dateweek<>1)
							$err=$rowi.lang("Date not compatible to Week") ;
		if ($activity=='')			$err=$rowi.lang("Invalid Activity") ;
		   else	if (substr_count($leavecodes,$ts['activity'.$i])==0)	{
				if (!is_numeric($hour) or $hour<=0)	$err=$rowi.lang("Invalid Hour") ;
				if ($day<>0)				$err=$rowi.lang("Invalid Day") ;
				}
		   	else {
				if ($hour<>0)				$err=$rowi.lang("Invalid Hour") ;
				if ($day==0)				$err=$rowi.lang("Invalid Day") ;
		   		}
		$hour_ttl += $hour ;
		$day_ttl += $day ;
		if ($ts['achival'.$i]=='' and $ts['achiunit'.$i]=='' and $ts['achieve'.$i]<>$achinaid)
			$err = $rowi.lang("Since Achievement<>not_applicable, either value or unit must be non-blank") ;
		}
	if ($hour_ttl<>$ts[hour_ttl])			$err=lang("Invalid Total Hours") ;
	if ($day_ttl<>$ts[day_ttl])			$err=lang("Invalid Total Days") ;
	$sql = "SELECT * FROM timesheet WHERE empid='$ts[empid]' and year='$ts[year]' and week='$ts[week]'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	if ($phpgw->db->num_rows()<>0 and $phpgw->db->f('id')<>$ts[id])
				$err=lang("Timesheet for the specified week already exist") ;
	$user = trim($phpgw_info["user"]["userid"]);
	$err1 = lang("Such address is needed to despatch email requesting timesheet approval") ;
	$sql = "SELECT * from email a, employee b WHERE empid=b.id and username='$user' and emailcode='BUSI'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0)	{
		$err0 = lang("You don't have a BUSI email address on record") ;
		$err = "$err0.  $err1." ;
		}
	$sql = "SELECT * from email a, employee b, employee c " ;
	$sql.= "WHERE empid=b.id and c.supervisor=b.id and c.username='$user' and emailcode='BUSI'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0)	{
		$err0 = lang("Your Supervisor don't have a BUSI email address on record") ;
		$err = "$err0.  $err1." ;
		}
	if ($err)		$err="<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Post timesheet to Database

    function timesheet_post($ts, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $ts[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql ="INSERT INTO timesheet (id,empid,year,week,hour_ttl,day_ttl,approved_by) " ;
			$sql.="VALUES ('$id','$ts[empid]','$ts[year]','$ts[week]','$ts[hour_ttl]','$ts[day_ttl]','')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE timesheet SET empid='$ts[empid]',year='$ts[year]',week='$ts[week]'," ;
			$sql.="hour_ttl='$ts[hour_ttl]',day_ttl='$ts[day_ttl]',approved_by='' ";
			$sql.="WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "approve" :
			$sql = "SELECT name FROM employee WHERE username='$user'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$name = $phpgw->db->f('name');
			$sql = "UPDATE timesheet SET approved_by='$name' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Pending") ;
			$actioned = lang("approved") ;
			break ;
		case "delete" :
			$phpgw->db->query("SELECT empid,year,week from timesheet where id = $id");
			$phpgw->db->next_record();
			$ts[empid] = $phpgw->db->f('empid');
			$ts[year] = $phpgw->db->f('year');
			$ts[week] = $phpgw->db->f('week');
			$phpgw->db->query("DELETE from timesheet where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	if ($op<>'new' and $op<>'approve')	$phpgw->db->query("DELETE from ts_trans where trans_id='$id'");
	if ($op<>'delete' and $op<>'approve') {
		For ($i=1;isset($ts['tsyear'.$i]);$i++) {
			$transdate	= $ts['tsyear'.$i]."-".$ts['tsmonth'.$i]."-".$ts['tsday'.$i];
			$project	= ($ts['project'.$i]=="") ? 0 : $ts['project'.$i] ;
			$activity	= $ts['activity'.$i] ;
			$hour		= $ts['hour'.$i] ;
			$day		= $ts['day'.$i] ;
			$achieve	= $ts['achieve'.$i] ;
			$achival	= $ts['achival'.$i] ;
			$achiunit	= $ts['achiunit'.$i] ;
			$sql = "INSERT INTO ts_trans " ;
			$sql.= "(trans_id,transdate,project,activity,hour,day,achieve,achival,achiunit) " ;
			$sql.= "VALUES ('$id','$transdate','$project','$activity','$hour','$day'," ;
			$sql.=		"'$achieve','$achival','$achiunit')" ;
			$phpgw->db->query($sql);
			}
		}
	if ($op=='approve') {
		For ($i=1;isset($ts['tsyear'.$i]);$i++) {
			if ($ts['day'.$i]==0)	continue ;
			$empid		= $ts[empid] ;
			$transdate	= $ts['tsyear'.$i]."-".$ts['tsmonth'.$i]."-".$ts['tsday'.$i];
			$leavecode	= $ts['activity'.$i] ;
			$duration	= $ts['day'.$i] ;
			$sql = "INSERT INTO leave (empid,leavefrom,leaveto,leavecode,duration) " ;
			$sql.= "VALUES ('$empid','$transdate','$transdate','$leavecode','$duration')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang('Timesheet') ;
	$msg = "$type $tran [id#$id] $actioned." ;

	$user = trim($phpgw_info["user"]["userid"]);
	$phpgw->db->query("SELECT name,id FROM employee WHERE username='$user'");
	$phpgw->db->next_record();
	$hrstaffname = $phpgw->db->f('name');
	$hrstaffid = $phpgw->db->f('id');
	$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$hrstaffid' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$hrstaffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername " ;
	$sql.= "FROM employee a, employee b WHERE a.id='$ts[empid]' and a.supervisor=b.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffname = $phpgw->db->f('staffname');
	$superid = $phpgw->db->f('superid');
	$supername = $phpgw->db->f('supername');
	$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$ts[empid]' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$superid' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$recipient = "$staffname < $staffemail >" ;
	$subject = lang("%1's Timesheet for YEAR:%2 and WEEK:%3 %4 by HR Staff",$staffname,$ts[year],$ts[week],$actioned) ;
	$message = '' ;
	$headers = "From: $hrstaffname < $hrstaffemail > \n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $hrstaffname < $hrstaffemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	$successmsg = lang("Email advising action on %1's Timesheet for YEAR:%2 and WEEK:%3 successfully sent to",$staffname,$ts[year],$ts[week]) ;
	$failuremsg = lang("Email advising action on %1's Timesheet for YEAR:%2 and WEEK:%3 fails to deliver.  Please manually inform",$staffname,$ts[year],$ts[week]) ;
	$lang_staff = lang("Staff:") ;
	if ($result)	$msg = "$msg<br>$lang_staff $successmsg $staffname." ;
		else	$msg = "$msg<br>$lang_staff $failuremsg $staffname." ;
	$recipient = "$supername < $superemail >" ;
	if ($op<>'delete')	$subject.= ' => '.lang('Please approve') ;
	$lang_super = lang("Supervisor:") ;
	$result= mail($recipient,$subject,$message,$headers) ;
	if ($result)	$msg = "$msg<br>$lang_super $successmsg $supername." ;
		else	$msg = "$msg<br>$lang_super $failuremsg $supername." ;

	$t->set_var("message","<b>$msg</b>") ;
	$t->set_var('lang_confirm',"<b>$msg</b>");

	return True ;
	}

//---- Write timesheet Header

    function timesheet_header_write(&$t, $ts, $where) {
	global $phpgw,$phpgw_info ;

	$t->set_var('lang_empid',lang('Employee'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_year',lang('Year'));
	$t->set_var('lang_week',lang('Week'));
	$t->set_var('lang_approved_by',lang('Approved By'));
	$user = trim($phpgw_info["user"]["userid"]);
	if (!$where)	$where = " WHERE id='$ts[empid]' " ;
	$t->set_var('empid_selectlist',employee_selectlist($where,$ts[empid])) ;
	$t->set_var('year_selectlist',year_selectlist('',$ts[year])) ;
	$t->set_var('week_selectlist',week_selectlist('',$ts[week])) ;
	$t->set_var('approved_by',$ts[approved_by]) ;
	$t->set_var('id',$ts[id]) ;
	$t->parse('out','report',True);
	}

//---- Write timesheet Detail

    function timesheet_detail_write(&$t, $ts, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$lang_activity = lang('activity') ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;
	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_pah',lang('Project---Activity/Leave---Hours---Days'));
	$t->set_var('lang_achievement',lang('Result Achieved'));
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_tsyear',lang('Year'));
	$t->set_var('lang_tsmonth',lang('Month'));
	$t->set_var('lang_tsday',lang('Day'));
	$t->set_var('lang_project',lang('Project'));
	$t->set_var('lang_activity',lang('Activity/Leave'));
	$t->set_var('lang_hour',lang('Hour Worked'));
	$t->set_var('lang_day',lang('Days On Leave'));
	$t->set_var('lang_achieve',lang('Achievement'));
	$t->set_var('lang_achival',lang('Value'));
	$t->set_var('lang_achiunit',lang('Unit'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('tsyear0_selectlist',year_selectlist('',$ts[tsyear0],'short')) ;
	$t->set_var('tsmonth0_selectlist',month_selectlist('',$ts[tsmonth0],'short')) ;
	$t->set_var('tsday0_selectlist',day_selectlist('',$ts[tsday0],'short')) ;

	$lang_leave = lang('leave') ;
	$nullopt = "<OPTION value=''></OPTION>" ;
	$act_sl = hrcodename_selectlist("WHERE type='$lang_activity'",'','long') ;
	$act_sl.= $nullopt ;
	$act_sl.= "<OPTION value=''>".lang('On Leave (Pls enter -0- as hours worked)')."</OPTION>" ;
	$act_sl.= hrcodename_selectlist("WHERE type='$lang_leave'",'','long') ;
	$lang_day = lang('day') ;
	$day_sl = $nullopt."<OPTION value='1'>1 $lang_day</OPTION><OPTION value='0.5'>0.5 $lang_day</OPTION>" ;
	$hour_ttl = 0;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($ts['tsyear'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('tsyear_fld','tsyear'.$i) ;
			$t->set_var('tsmonth_fld','tsmonth'.$i) ;
			$t->set_var('tsday_fld','tsday'.$i) ;
			$t->set_var('project_fld','project'.$i) ;
			$t->set_var('activity_fld','activity'.$i) ;
			$t->set_var('hour_fld','hour'.$i) ;
			$t->set_var('day_fld','day'.$i) ;
			$t->set_var('achieve_fld','achieve'.$i);
			$t->set_var('achival_fld','achival'.$i);
			$t->set_var('achiunit_fld','achiunit'.$i);
			$t->set_var('tsyear_selectlist',year_selectlist('',$ts['tsyear'.$i],'short')) ;
			$t->set_var('tsmonth_selectlist',month_selectlist('',$ts['tsmonth'.$i],'short')) ;
			$t->set_var('tsday_selectlist',day_selectlist('',$ts['tsday'.$i],'short')) ;
			$t->set_var('project_selectlist',$nullopt.project_selectlist('','',short)) ;
			$t->set_var('activity_selectlist',$act_sl);
			$t->set_var('hour','') ;
			$t->set_var('day_selectlist',$day_sl);
			$t->set_var('achieve_selectlist',achieve_selectlist("","",'short')) ;
			$t->set_var('achival','') ;
			$t->set_var('achiunit','') ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$t->set_var('tsyear_fld','tsyear'.$j) ;
		$t->set_var('tsmonth_fld','tsmonth'.$j) ;
		$t->set_var('tsday_fld','tsday'.$j) ;
		$t->set_var('project_fld','project'.$j) ;
		$t->set_var('activity_fld','activity'.$j) ;
		$t->set_var('hour_fld','hour'.$j) ;
		$t->set_var('day_fld','day'.$j) ;
		$t->set_var('achieve_fld','achieve'.$j);
		$t->set_var('achival_fld','achival'.$j);
		$t->set_var('achiunit_fld','achiunit'.$j);
		$t->set_var('tsyear_selectlist',year_selectlist('',$ts['tsyear'.$i],'short')) ;
		$t->set_var('tsmonth_selectlist',month_selectlist('',$ts['tsmonth'.$i],'short')) ;
		$t->set_var('tsday_selectlist',day_selectlist('',$ts['tsday'.$i],'short')) ;
		$t->set_var('project_selectlist',$nullopt.project_selectlist('',$ts['project'.$i],'short')) ;
		$default = $ts['activity'.$i] ;
		$t->set_var('activity_selectlist',str_replace("'$default'","'$default' selected",$act_sl)) ;
		$t->set_var('hour',$ts['hour'.$i]) ;
		$default = $ts['day'.$i] ;
		$t->set_var('day_selectlist',str_replace("'$default'","'$default' selected",$day_sl)) ;
		$t->set_var('achieve_selectlist',achieve_selectlist("",$ts['achieve'.$i],'short')) ;
		$t->set_var('achival',$ts['achival'.$i]) ;
		$t->set_var('achiunit',$ts['achiunit'.$i]) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==2 and $delrowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('tsyear_fld','tsyear'.$i) ;
		$t->set_var('tsmonth_fld','tsmonth'.$i) ;
		$t->set_var('tsday_fld','tsday'.$i) ;
		$t->set_var('project_fld','project'.$i) ;
		$t->set_var('activity_fld','activity'.$i) ;
		$t->set_var('hour_fld','hour'.$i) ;
		$t->set_var('day_fld','day'.$i) ;
		$t->set_var('achieve_fld','achieve'.$i);
		$t->set_var('achival_fld','achival'.$i);
		$t->set_var('achiunit_fld','achiunit'.$i);
		$t->set_var('project_selectlist',$nullopt.project_selectlist('','','short')) ;
		$t->set_var('activity_selectlist',$act_sl) ;
		$t->set_var('hour','') ;
		$t->set_var('day_selectlist',$day_sl) ;
		$t->set_var('achieve_selectlist',achieve_selectlist("","",'short')) ;
		$t->set_var('achival','') ;
		$t->set_var('achiunit','') ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_total',lang('Total'));
	$t->set_var('hour_ttl',$ts[hour_ttl]) ;
	$t->set_var('day_ttl',$ts[day_ttl]) ;

	$t->parse('out','report',True);
	}

    }

?>
