<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.assembly.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

	class assembly {

//---- Assembly Validation Checks

    function assembly_validate($as,$edit) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	if (!$edit)	{
		$phpgw->db->query("SELECT distinct * from assembly where assembly_id=$as[assembly]");
		if ($phpgw->db->next_record())		$err=lang("Assembly already exists");
		}
	For ($i=1;isset($as['item'.$i]);$i++) {
		$row = lang("Row") ;  $rowi = "[$row $i]" ;
		if ($as['item'.$i]==$as[assembly])	$err=$rowi.lang("Assembly cannot be inside itself");
		if (!$as['qty'.$i])			$err=$rowi.lang("Missing Component Qty");
		if ($as['qty'.$i] and !is_numeric($as['qty'.$i]))
							$err=$rowi.lang("Invalid Component Qty, must be numeric");
		if ($as['qty'.$i] and $as['qty'.$i]<=0)	$err=$rowi.lang("Invalid Component Qty, must be positive");
		For ($j=1;isset($as['item'.$j]);$j++) {
			$rowj = "[$row $j]" ;
			if ($as['item'.$i]==$as['item'.$j] and $i<>$j)
							$err=$rowi.$rowj.lang("Duplicative Components");
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Assembly to Database

    function assembly_post($as, &$t, &$id, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $as[assembly] ;
	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "new" :	$type = lang("New") ;	$actioned = lang("added") ;	break ;
		case "edit" :	$type = lang("Old") ;	$actioned = lang("updated") ;	break ;
		case "delete" :	$type = lang("Old") ;	$actioned = lang("deleted") ;	break ;
		endswitch ;
	if ($op<>'new')		$phpgw->db->query("DELETE FROM assembly WHERE assembly_id=$id") ;
	if ($op<>'delete') {
		For ($i=1;isset($as['item'.$i]);$i++) {
			$item	= $as['item'.$i];
			$qty	= $as['qty'.$i] ;
			$phpgw->db->query("INSERT INTO assembly (assembly_id,item_id,qty) VALUES ('$id','$item','$qty')");
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Assembly for Part") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Assembly Header

    function assembly_header_write(&$t, $as, $fixassembly) {
	global $phpgw ;

	$t->set_var('lang_ginfo',lang("General Information"));
	$t->set_var('lang_assembly',lang("Assembly"));
	$t->set_var('lang_number',lang("Name/Number"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_description',lang("Description"));
	$t->set_var('lang_notes',lang("Notes"));
	$part_list = ($fixassembly)? part_selectlist("WHERE id='$as[id]'",''): part_selectlist("",$as[assembly]) ;
	$t->set_var('part_sl',$part_list);

	$t->set_var('partnumber',$as[partnumber]) ;
	$t->set_var('description',$as[description]) ;
	$t->set_var('id',$as[id]) ;
	$t->set_var('notes',$as[notes]);

	$t->parse('out','report',True);
	}

//---- Write Assembly Detail

    function assembly_detail_write(&$t, $as, $posted, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_comp',lang('Component Part'));
	$t->set_var('lang_compqty',lang('Qty of Component inside Assembly'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$item_list = item_selectlist("",'') ;
	if (isset($delete)) {$rowno = intval(str_replace($row_,"",$delete)); }
	For ($i=1;isset($as['item'.$i]);$i++) {
		if ($i<>$rowno) {
			$item_id	=	$as['item'.$i] ;
			$qty		=	$as['qty'.$i] ;
			if (isset($delete) and $i>$rowno) {$j=$i-1;} else {$j=$i;}
			$t->set_var('item_fld','item'.$j) ;
			$t->set_var('qty_fld','qty'.$j) ;
			$t->set_var('option_block',str_replace("'$item_id'","'$item_id' selected",$item_list));
			$t->set_var('qty',$qty) ;
			if ($posted)	$t->set_var('rowno',"done") ;
				else	$t->set_var('rowno',$row_.$j) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)			$i=1 ;
	if ($i==1)					$newrow=True ;
	if ($newrow) {
		$t->set_var('item_fld','item'.$i) ;
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('option_block',$item_list);
		$t->set_var('qty',"") ;
		$t->set_var('rowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

    }

?>
