<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.gd.inc.php,v 0.0.5 2002/02/11 C K Wu $ */
  
    class gd {

//---- Goods Delivery Validation Checks

    function gd_validate($g,$edit) {
	global $phpgw ;

	$err=""; $error=lang("Error");
	$date=input2date( $g[transdate] ) ;
	if ($date=="")				$err=lang("Invalid Goods Delivery Date");
	if ($g["description"]=="")		$err=lang("GD Description Missing");
	$id = $g[id] ;
	$customer = $g[customer] ;
	$totalqty = 0 ;
	For ($i=1;isset($g['part'.$i]);$i++) {
		$qty = $g['qty'.$i] ;
		$so  = $g['so'.$i] ;
		$part= $g['part'.$i] ;
		$row = lang("Row") ;
		$rowi = "[$row $i]" ;
		if ($qty and !is_numeric($qty)) $err=$rowi.lang("Invalid Qty, must be numeric");
		if ($qty==0)			$err=$rowi.lang("Invalid Qty, must be non-zero");
		$phpgw->db->query("SELECT customer from so where id='$so' and customer='$customer'") ;
		if (!$phpgw->db->next_record()) $err=$rowi.lang("SO belongs to another customer");
		$phpgw->db->query("SELECT qty from oitem where trans_id='$so' and itemid='$part'") ;
		if ($phpgw->db->next_record()) {
				$soqty = $phpgw->db->f('qty') ;
			$sql = "SELECT sum(qty) as q from inv_trans WHERE order_id='$so' and parts_id='$part'";
				if ($edit)		$sql .= " and trans_id<>'$id'" ;
				$phpgw->db->query($sql) ;
				$phpgw->db->next_record() ;
				$q = -$phpgw->db->f('q') ;
				if ($qty>($soqty-$q))	$err=$rowi.lang("Qty to deliver > O/S SO qty") ;
				}
			else				$err=$rowi.lang("SO does not have this part") ;
		$sql = "SELECT sum(qty) as stk from inv_trans WHERE parts_id='$part'" ;
		if ($edit)		$sql .= " and trans_id<>'$id'" ;
		$phpgw->db->query($sql) ;
		$phpgw->db->next_record() ;
		$stk = $phpgw->db->f('stk') ;
		if ($qty>($stk))		$err=$rowi.lang("Qty to deliver overdrawn existing stock") ;
		For ($j=1;isset($g['part'.$j]);$j++) {
			$rowj = "[$row $j]" ;
			if ($g['part'.$i]==$g['part'.$j] and $g['so'.$i]==$g['so'.$j] and $i<>$j)
						$err=$rowi.$rowj.lang("Rows with same SO&Part#");
			}
		$totalqty += $g['qty'.$i] ;
		}
	if ($totalqty<>$g[controltot])		$err=lang("Qty Total <> Inputted Control Total");
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Goods Delivery to Database

    function gd_post($g, &$t, &$id, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $g[id] ;
	$source	= "GD" ;
	$desc = $g[description] ;
	$transdate = $g[transdate] ;
	$customer = $g[customer] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO il (id,source,description,to_from,transdate) " ;
			$sql.= "VALUES('$id','$source','$desc','$customer','$transdate')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE il SET source='$source',description='$desc'," ;
			$sql.= "to_from='$customer',transdate='$transdate' WHERE id='$id'";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from il where id = '$id'");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE from inv_trans where trans_id='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($g['part'.$i]);$i++) {
			$so	= $g['so'.$i] ;
			$part	= $g['part'.$i];
			$qty	= -$g['qty'.$i];
			$sql = "INSERT INTO inv_trans (trans_id,order_id,parts_id,qty,transdate)" ;
			$sql.= "VALUES ('$id','$so','$part','$qty','$transdate')" ;
			$phpgw->db->query($sql);
			}
		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Goods Delivery") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Goods Delivery Header

    function gd_header_write(&$t, $g) {
	global $phpgw ;

	$t->set_var('lang_date',lang('Date :'));
	$t->set_var('lang_customer',lang('Customer :'));
	$t->set_var('lang_source',lang('Source :'));
	$t->set_var('lang_description',lang('Description :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('transdate',$g[transdate]) ;
	$t->set_var('customer_selectlist',customer_selectlist('',$g[customer])) ;
	$t->set_var('source',$g[source]) ;
	$t->set_var('description',$g[description]) ;
	$t->set_var('id',$g[id]) ;
	$t->parse('out','report',True);
	}

//---- Write Goods Delivery Detail

    function gd_detail_write(&$t, $g, $posted, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_parts',lang('Part Number -- Description -- ID'));
	$t->set_var('lang_so',lang('(Delivered against) SO Number -- ID'));
	$t->set_var('lang_qty',lang('Quantity'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$part_list = part_selectlist("",'') ;
	if ($g[customer]=="")	$g[customer]=0 ;
	$so_list = so_selectlist(" WHERE customer='$g[customer]' ",'') ;
	if (isset($delete)) {$rowno = intval(str_replace($row_,"",$delete)); }
	For ($i=1;isset($g['part'.$i]);$i++) {
		if ($i<>$rowno) {
			$so				=	$g['so'.$i];
			$part			=	$g['part'.$i] ;
			$qty			=	$g['qty'.$i];
			$j = ($delete and $i>$rowno) ? $i-1 : $i ;
			$t->set_var('so_fld','so'.$j) ;
			$t->set_var('part_fld','part'.$j) ;
			$t->set_var('qty_fld','qty'.$j);
			$t->set_var('so_list',str_replace("'$so'","'$so' selected",$so_list));
			$t->set_var('parts_list',str_replace("'$part'","'$part' selected",$part_list));
			$t->set_var('qty',$qty) ;
			if ($posted)	$t->set_var('rowno',"done");	else	$t->set_var('rowno',$row_.$j);
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('so_fld','so'.$i) ;
		$t->set_var('so_list',$so_list);
		$t->set_var('part_fld','part'.$i) ;
		$t->set_var('parts_list',$part_list);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('qty',"") ;
		$t->set_var('rowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);		
		}
	$t->set_var('lang_controltot',lang('Quantity Control Total'));
	$t->set_var('controltot',$g[controltot]) ;	

	$t->parse('out','report',True);
	}

    }

?>
