<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.ia.inc.php,v 0.0.5 2002/02/11 C K Wu $ */
  
    class ia {

//---- Inventory Adjustment Validation Checks

    function ia_validate($iaa) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	$date=input2date( $iaa[transdate] ) ;
	if ($date=="")				$err=lang("Invalid Inventory Adjustment Date");
	if ($iaa["description"]=="")		$err=lang("IA Description Missing") ;
	$totalqty = $totalamt = 0 ;
	For ($i=1;isset($iaa['part'.$i]);$i++) {
		$row = lang("Row") ; $rowi = "[$row $i]" ;
		if ($iaa['qty'.$i] and !is_numeric($iaa['qty'.$i]))
						$err=$rowi.lang("Invalid Qty, must be numeric");
		if ($iaa['qty'.$i]==0)		$err=$rowi.lang("Invalid Qty, must be non-zero");
		$totalqty += $iaa['qty'.$i] ;
		}
	if ($totalqty<>$iaa[controltot])	$err=lang("Qty Total <> Inputted Control Total");
	if ($err)	$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Inventory Adjustment to Database

    function ia_post($iaa, &$t, &$id, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $iaa[id] ;
	$source	= "IA" ;
	$desc = $iaa[description] ;
	$transdate = $iaa[transdate] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO il (id,source,description,transdate) " ;
			$sql.= "VALUES('$id','$source','$desc','$transdate')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE il SET source='$source',description='$desc',transdate='$transdate' WHERE id='$id'";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from il where id = '$id'");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE from inv_trans where trans_id='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($iaa['part'.$i]);$i++) {
			$part	= $iaa['part'.$i];
			$qty	= $iaa['qty'.$i];
			$sql = "INSERT INTO inv_trans (trans_id,parts_id,qty,transdate)" ;
			$sql.= "VALUES ('$id','$part','$qty','$transdate')" ;
			$phpgw->db->query($sql);
			}
		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Inventory Adjustment") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Inventory Adjustment Header

    function ia_header_write(&$t, $iaa) {
	global $phpgw ;

	$t->set_var('lang_date',lang('Date :'));
	$t->set_var('lang_source',lang('Source :'));
	$t->set_var('lang_description',lang('Description :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('transdate',$iaa[transdate]) ;
	$t->set_var('source',$iaa[source]) ;
	$t->set_var('description',$iaa[description]) ;
	$t->set_var('id',$iaa[id]) ;
	$t->parse('out','report',True);
	}

//---- Write Inventory Adjustment Detail

    function ia_detail_write(&$t, $iaa, $posted, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_parts',lang('Part Number -- Description -- ID'));
	$t->set_var('lang_qty',lang('Quantity (+ve: increase stock, -ve: decrease stock)'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$part_list = part_selectlist("",'') ;
	if (isset($delete)) {$rowno = intval(str_replace($row_,"",$delete)); }
	For ($i=1;isset($iaa['part'.$i]);$i++) {
		if ($i<>$rowno) {
			$part			=	$iaa['part'.$i] ;
			$qty			=	$iaa['qty'.$i];
			$j = ($delete and $i>$rowno) ? $i-1 : $i ;
			$t->set_var('part_fld','part'.$j) ;
			$t->set_var('qty_fld','qty'.$j);
			$t->set_var('option_block',str_replace("'$part'","'$part' selected",$part_list));
			$t->set_var('qty',$qty) ;
			if ($posted)	$t->set_var('rowno',"done");	else	$t->set_var('rowno',$row_.$j);
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('part_fld','part'.$i) ;
		$t->set_var('option_block',$part_list);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('qty',"") ;
		$t->set_var('rowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_controltot',lang('Quantity Control Total'));
	$t->set_var('controltot',$iaa[controltot]) ;

	$t->parse('out','report',True);
	}

    }

?>
