<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.inventory.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

	class inventory {  

//---- Inventory Detail Validation Checks

    function inventory_validate($iv) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	if ($iv[partnumber]=="")				$err=lang("Part Name/Number Missing");
	if ($iv[rop] and !is_numeric($iv[rop]))			$err=lang("Invalid Reorder Level, must be numeric");
	if ($iv[weight] and !is_numeric($iv[weight]))		$err=lang("Invalid Weight, must be numeric");
	if ($iv[listprice] and !is_numeric($iv[listprice]))	$err=lang("Invalid list price, must be numeric");
	if ($iv[sellprice] and !is_numeric($iv[sellprice]))	$err=lang("Invalid selling price, must be numeric");
	if ($iv[cost] and !is_numeric($iv[cost]))		$err=lang("Invalid Cost, must be numeric");
	if ($iv[listprice] and $iv[sellprice] and ($iv[listprice]<$iv[sellprice]))
								$err=lang("List Price < Selling Price");
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Inventory Detail to Database

    function inventory_post($iv, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $iv[id] ;
	$pricedate = ($iv[oldprice]<>$iv[sellprice]) ? date("Y-m-d") : $iv[priceupdate] ;
	$costdate = ($iv[oldcost]<>$iv[cost]) ? date("Y-m-d") : $iv[costupdate] ;
	
	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql ="INSERT INTO parts (id,partnumber,description,bin,rop,unit,weight,listprice,";
			$sql.="sellprice,cost,inventory_accno_id,income_accno_id,expense_accno_id,notes) VALUES " ;
			$sql.="('$id','$iv[partnumber]','$iv[description]','$iv[bin]','$iv[rop]','$iv[unit]',";
			$sql.="'$iv[weight]','$iv[listprice]','$iv[sellprice]','$iv[cost]'," ;
			$sql.="'$iv[inventory_accno_id]','$iv[income_accno_id]','$iv[expense_accno_id]','$iv[notes]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE parts SET partnumber='$iv[partnumber]',description='$iv[description]',";
			$sql.="bin='$iv[bin]',rop='$iv[rop]',unit='$iv[unit]',weight='$iv[weight]',";
			$sql.="listprice='$iv[listprice]',sellprice='$iv[sellprice]'," ;
			$sql.="priceupdate='$pricedate',cost='$iv[cost]',costupdate='$costdate',notes='$iv[notes]'," ;
			$sql.="inventory_accno_id='$iv[inventory_accno_id]'," ;
			$sql.="income_accno_id='$iv[income_accno_id]',expense_accno_id='$iv[expense_accno_id]' " ;
			$sql.="WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from parts where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	if ($op<>'new')		$phpgw->db->query("DELETE FROM itemtax WHERE item_id=$id") ;
	if ($op<>'delete') {
		if ($iv[aptax1]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$iv[aptax1]','1')";
			$phpgw->db->query($sql);
			}
		if ($iv[aptax2]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$iv[aptax2]','2')";
			$phpgw->db->query($sql);
			}
		if ($iv[artax1]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$iv[artax1]','1')";
			$phpgw->db->query($sql);
			}
		if ($iv[artax2]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$iv[artax2]','2')";
			$phpgw->db->query($sql);
			}
		if ($iv[cstax1]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$iv[cstax1]','1')";
			$phpgw->db->query($sql);
			}
		if ($iv[cstax2]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$iv[cstax2]','2')";
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Inventory Item") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

/*	if ($edit) {
		$sql ="UPDATE parts SET partnumber='$iv[partnumber]',description='$iv[description]',";
		$sql.="bin='$iv[bin]',rop='$iv[rop]',unit='$iv[unit]',weight='$iv[weight]',";
		$sql.="listprice='$iv[listprice]',sellprice='$iv[sellprice]'," ;
		$sql.="priceupdate='$pricedate',cost='$iv[cost]',costupdate='$costdate',notes='$notes'," ;
		$sql.="inventory_accno_id='$iv[inventory_accno_id]'," ;
		$sql.="income_accno_id='$iv[income_accno_id]',expense_accno_id='$iv[expense_accno_id]' " ;
		$sql.="WHERE id=$id";
		$phpgw->db->query($sql);
		$sql = "DELETE FROM itemtax WHERE item_id=$id" ;
		$phpgw->db->query($sql);
		}
	    else {
		if ($db_type=="mysql")	{
			$phpgw->db->query("SELECT sid FROM sequence");
			$phpgw->db->next_record() ;
			$id=$phpgw->db->f('sid') ;
			$sql ="INSERT INTO parts (id,partnumber,description,bin,rop,unit,weight,listprice,";
			$sql.="sellprice,cost,inventory_accno_id,income_accno_id,expense_accno_id,notes) VALUES " ;
			$sql.="('$id','$iv[partnumber]','$iv[description]','$iv[bin]','$iv[rop]','$iv[unit]',";
			$sql.="'$iv[weight]','$iv[listprice]','$iv[sellprice]','$iv[cost]'," ;
			$sql.="'$iv[inventory_accno_id]','$iv[income_accno_id]','$iv[expense_accno_id]','$notes')" ;
			$phpgw->db->query($sql);
			$phpgw->db->query("UPDATE sequence SET sid=$id+1");
			}
		    else {
			$sql ="INSERT INTO parts (partnumber,description,bin,rop,unit,weight,listprice,";
			$sql.="sellprice,cost,inventory_accno_id,income_accno_id,expense_accno_id,notes) VALUES " ;
			$sql.="('$iv[partnumber]','$iv[description]','$iv[bin]','$iv[rop]','$iv[unit]',";
			$sql.="'$iv[weight]','$iv[listprice]','$iv[sellprice]','$iv[cost]'," ;
			$sql.="'$iv[inventory_accno_id]','$iv[income_accno_id]','$iv[expense_accno_id]','$notes')" ;
			$phpgw->db->query($sql);
			$phpgw->db->query("SELECT id from parts WHERE notes='$notes'");
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			}
		}
	if ($iv[aptax1]<>"") {
		$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$iv[aptax1]','1')";
		$phpgw->db->query($sql);
		}
	if ($iv[aptax2]<>"") {
		$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$iv[aptax2]','2')";
		$phpgw->db->query($sql);
		}
	if ($iv[artax1]<>"") {
		$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$iv[artax1]','1')";
		$phpgw->db->query($sql);
		}
	if ($iv[artax2]<>"") {
		$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$iv[artax2]','2')";
		$phpgw->db->query($sql);
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	if ($edit)		$t->set_var("message","<b>Old inventory [id#$id] updated.<b>") ;
		else 	$t->set_var("message","<b>New inventory [id#$id] added.<b>") ;
	$posted = True ;
	return $posted ;
	}
*/

//---- Write Inventory Detail

    function inventory_write(&$t, &$iv) {
	global $phpgw ;

	$t->set_var('lang_tbi',lang("(To be implemented)"));
	$t->set_var('lang_ginfo',lang("General Information"));
	$t->set_var('lang_number',lang("Name/Number"));
	$t->set_var('lang_description',lang("Description"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_quantity',lang("Quantity"));
	$t->set_var('lang_bin',lang("Bin Location"));
	$t->set_var('lang_rop',lang("Reorder Level (info only)"));
	$t->set_var('lang_unit',lang("Unit"));
	$t->set_var('lang_weight',lang("Weight"));
	$t->set_var('lang_pricecost',lang("Price/Cost"));
	$t->set_var('lang_listprice',lang("List Price"));
	$t->set_var('lang_sellprice',lang("Selling Price"));
	$t->set_var('lang_priceupdate',lang("Price Last Updated on"));
	$t->set_var('lang_cost',lang("Standard Cost"));
	$t->set_var('lang_costupdate',lang("Cost Last Updated on"));
	$t->set_var('lang_notes',lang("Notes"));
	$t->set_var('lang_linkageaccount',lang("Link to Ledger Accounts"));
	$t->set_var('lang_inventory_accno',lang("Inventory Account"));
	$t->set_var('lang_income_accno',lang("Sales Account"));
	$t->set_var('lang_expense_accno',lang("COGS Account"));
	$t->set_var('lang_tax',lang("Tax"));
	$t->set_var('lang_aptax1',lang("Primary Tax Paid to Vendor"));
	$t->set_var('lang_aptax2',lang("Secondary Tax Paid to Vendor"));
	$t->set_var('lang_artax1',lang("Primary Tax from Customer"));
	$t->set_var('lang_artax2',lang("Secondary Tax from Customer"));
	$t->set_var('lang_cstax1',lang("Primary Tax for Cash Sale"));
	$t->set_var('lang_cstax2',lang("Secondary Tax for Cash Sale"));
	$t->set_var('lang_reserved',lang('Reserved Space'));

	$t->set_var('partnumber',$iv[partnumber]);
	$t->set_var('id',$iv[id]);
	$t->set_var('description',$iv[description]);
	$t->set_var('bin',$iv[bin]);
	$t->set_var('notes',$iv[notes]);
	$t->set_var('rop',$iv[rop]);
	$t->set_var('unit',$iv[unit]);
	$t->set_var('weight',$iv[weight]);
	$t->set_var('listprice',$iv[listprice]);
	$t->set_var('sellprice',$iv[sellprice]);
	$t->set_var('oldprice',$iv[oldprice]);
	$t->set_var('priceupdate',$iv[priceupdate]);
	$t->set_var('cost',$iv[cost]);
	$t->set_var('oldcost',$iv[oldcost]);
	$t->set_var('costupdate',$iv[costupdate]);
	$inv_acc = $iv[inventory_accno_id] ;
	$t->set_var('inventory_accno',$inv_acc);
	$t->set_var('invacc_sl',account_selectlist("WHERE link like '%IC:%' or link like '%IC'",$inv_acc));
	$inc_acc = $iv[income_accno_id] ;
	$t->set_var('income_accno',$inc_acc);
	$t->set_var('incacc_sl', account_selectlist("WHERE link like '%IC_sale%'",$inc_acc));
	$exp_acc = $iv[expense_accno_id] ;
	$t->set_var('expense_accno',$exp_acc);
	$t->set_var('expacc_sl',account_selectlist("WHERE link like '%IC_cogs%'",$exp_acc));
	$t->set_var('aptax1_selectlist',tax_selectlist("WHERE taxgroup='ap'",$iv[aptax1]));
	$t->set_var('aptax2_selectlist',tax_selectlist("WHERE taxgroup='ap'",$iv[aptax2]));
	$t->set_var('artax1_selectlist',tax_selectlist("WHERE taxgroup='ar'",$iv[artax1]));
	$t->set_var('artax2_selectlist',tax_selectlist("WHERE taxgroup='ar'",$iv[artax2]));
	$t->set_var('cstax1_selectlist',tax_selectlist("WHERE taxgroup='cs'",$iv[cstax1]));
	$t->set_var('cstax2_selectlist',tax_selectlist("WHERE taxgroup='cs'",$iv[cstax2]));

	$t->parse('out','report',True);
	}

    }

?>
