<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: backup.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"]	= array('currentapp'		=> 'ck-ledadmin',
					'enable_vfs_class'	=> True ) ;
	include('../header.inc.php');

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledadmin'));
	$t->set_file('report','confirm.tpl');

/*---------------------------------------------------------------------------------*/
//	Attribute tables are backed up via an independently created $tables array
//	Although department is one of the attribute tables, it is included in the main
//	backup list, because it is also one of the built-in tables for ck-hr

	$tables	= array('department','activity','achievement',
			'chart','gl','service','remark','acc_trans','bkr_trans',
			'il','inv_trans','parts','assembly','alternate','makemodel',
			'vendor','customer','tax','vendortax','customertax','itemtax',
			'ap','ar','invoice','payment','receipt','p_match','r_match','ipmatch','ismatch',
			'po','so','quote','oitem','sqmatch','qcash','addon','sprice','cashbox',
			'pos','positem','cbtran','defaults','resourcelock','log',
			'employee','hrcode','address','phone','email','ec','dates','leave','pr','role',
			'attendance','timesheet','ts_trans','leaveapp');

	$phpgw->db->query("SELECT version,attrib1tbl,attrib2tbl,attrib3tbl from defaults") ;
	$phpgw->db->next_record() ;
	$version = $phpgw->db->f('version') ;
	$attrib1tbl = $phpgw->db->f('attrib1tbl') ;
	$attrib2tbl = $phpgw->db->f('attrib2tbl') ;
	$attrib3tbl = $phpgw->db->f('attrib3tbl') ;
	$user	=	trim($phpgw_info["user"]["userid"]) ;
	$db_type =	$phpgw_info["server"]["db_type"] ;
	$host	=	$phpgw_info["server"]["db_host"] ;
	$database =	$phpgw_info["server"]["db_name"] ;
	$dbuser	=	$phpgw_info["server"]["db_user"] ;
	$datetime =	date("Y-m-d; h:m:s") ;
	$dir	=	$phpgw_info["server"]["files_dir"] ;
	$date	=	date("Ymd") ;
	$filename =	$dir."/".$database.".".$date.".$db_type.restore.sql" ;
	$backup = lang("Backup File") ;
	$created = lang("created") ;
	$headercontent = lang("Header Content") ;
	
	umask(000) ;
	if (!is_dir($dir))	mkdir($dir,0777) ;
	if ($fp = fopen($filename,"w")) {
		echo "<br><font size='+2'>$backup [$filename] $created</font><br>" ;
		echo "<br>$headercontent<br><br>" ;
		$line="-- CK-Ledger Backup\n" ;		fputs($fp,$line); echo $line,"<br>";
		$line="-- Version:	$version\n" ;	fputs($fp,$line); echo $line,"<br>";
		$line="-- Backup'er:	$user\n" ;	fputs($fp,$line); echo $line,"<br>";
		$line="-- Host:		$host\n" ;	fputs($fp,$line); echo $line,"<br>";
		$line="-- Database:	$database\n" ;	fputs($fp,$line); echo $line,"<br>";
		$line="-- DBUser:	$dbuser\n" ;	fputs($fp,$line); echo $line,"<br>";
		$line="-- Datetime:	$datetime\n" ;	fputs($fp,$line); echo $line,"<br>";
		$line="--\n";				fputs($fp,$line);

		while (list($key,$table)=each($tables)) {
			$line="DELETE FROM $table;\n" ;			fputs($fp,$line);
			$phpgw->db->query("SELECT * FROM $table") ;
			while ($phpgw->db->next_record()) {
				$r = $phpgw->db->Record ;
				$line = "INSERT INTO $table VALUES (" ;
				while (list($key,$value)=each($r)) {
					if (is_numeric($key)) {
						$value = str_replace(',','\,',addslashes($value)) ;
						$line.= "'$value'," ;
						}
					}
				$line = substr($line,0,-1).");\n" ;	fputs($fp,$line);
				}
			$line="--\n" ;					fputs($fp,$line);
			}
		if ($db_type=="pgsql")	{
			$phpgw->db->query("SELECT nextval('id') as id") ;
			$phpgw->db->next_record() ;
			$id = $phpgw->db->f('id') ;
			$line = "DROP SEQUENCE id;\n" ;			fputs($fp,$line);
			$line = "CREATE SEQUENCE id START $id;\n";	fputs($fp,$line);
			$line="--\n" ;					fputs($fp,$line);
			$phpgw->db->query("SELECT nextval('sid') as sid") ;
			$phpgw->db->next_record() ;
			$sid = $phpgw->db->f('sid') ;
			$line = "DROP SEQUENCE sid;\n" ;		fputs($fp,$line);
			$line = "CREATE SEQUENCE sid START $sid;\n";	fputs($fp,$line);
			$line="--\n" ;					fputs($fp,$line);
			}
		$tables = array("$attrib1tbl","$attrib2tbl","$attrib3tbl") ;
		while (list($key,$table)=each($tables)) {
			$line="**DELETE FROM $table;\n" ;		fputs($fp,$line);
			$phpgw->db->query("SELECT * FROM $table") ;
			while ($phpgw->db->next_record()) {
				$r = $phpgw->db->Record ;
				$line = "INSERT INTO $table VALUES (" ;
				while (list($key,$value)=each($r)) {
					if (is_numeric($key)) {
						$value = str_replace(',','\,',addslashes($value)) ;
						$line.= "'$value'," ;
						}
					}
				$line = "**".substr($line,0,-1).");\n" ;fputs($fp,$line);
				}
			$line="--\n" ;					fputs($fp,$line);
			}

		fclose($fp) ;
		}

	$reminder1=lang("Please remember to backup additionally the (images) folder within your phpgw files area") ;
	$reminder2=lang("Please also maintain separate independent backup of the attribute tables, if they are used by other phpgw modules") ;
	echo "<br>$reminder1<br>$reminder2<br>";

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_confirm',"");
	$t->set_var('lang_yes',lang('Done'));
	$t->set_var('lang_no',lang('Done'));
	$t->set_var('yes_action',$phpgw->link('/ck-ledadmin/index.php')) ;
	$t->set_var('no_action',$phpgw->link('/ck-ledadmin/index.php')) ;
	$t->pparse('out','report');
?>
