<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.contri.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class contri {

//---- contri Validation Checks

    function contri_validate($ct,$oldctname) {
	global $phpgw ;

	$err=""; $error = lang("Error") ;
	$exem = lang("ExemptItem") ;
	$ratetbl = lang("Rate Table") ;
	$row = lang("Row") ;
	$phpgw->db->query("SELECT * from contri WHERE name='$ct[name]'");
	if ($ct[name]<>$oldctname and $phpgw->db->num_rows()>0)
		$err=lang("Company Contribution Type already in use");
	if ($ct[name]=='')		$err=lang("Contribution Name Missing");
	if ($ct[desc]=='')		$err=lang("Contribution Description Missing");
	if ($ct[locality]=='')		$err=lang("Locality Missing");
	if ($ct[floor]=='')		$err=lang("Contribution Floor Value Missing");
	if (!is_numeric($ct[floor]))	$err=lang("Contribution Floor Value must be numeric") ;
	if ($ct[min]=='')		$err=lang("Contribution Minimum Value Missing");
	if ($ct[max]=='')		$err=lang("Contribution Maximum Value Missing");
	if ($ct[min]>$ct[max])		$err=lang("Contribution Minimum > Maximum") ;
	if (!is_numeric($ct[min]))	$err=lang("Contribution Minimum Value must be numeric") ;
	if (!is_numeric($ct[max]))	$err=lang("Contribution Maximum Value must be numeric") ;
	For ($i=1;isset($ct['eaid'.$i]);$i++) {
		$rowi = "[$exem $row $i]" ;
		$min = $ct['exemmin'.$i] ;
		$max = $ct['exemmax'.$i] ;
		if ($ct['eaid'.$i]=='')	$err=$rowi.lang("Allowance/Deduction Code Missing") ;
		if ($min=='')		$err=$rowi.lang("ExemptItem Minimum Value Missing");
		if ($max=='')		$err=$rowi.lang("ExemptItem Maximum Value Missing");
		if ($min>$max)		$err=$rowi.lang("ExemptItem Minimum > Maximum") ;
		if (!is_numeric($min))	$err=$rowi.lang("ExemptItem Minimum Value must be numeric");
		if (!is_numeric($max))	$err=$rowi.lang("ExemptItem Maximum Value must be numeric");
		}
	if (isset($ct[step1]))		$laststep = $ct[step1] ;
	For ($i=1;isset($ct['step'.$i]);$i++) {
		$rowi = "[$ratetbl $row $i]" ;
		$step = $ct['step'.$i] ;
		if ($step=='')			$err=$rowi.lang("Step Value Missing") ;
		if ($step<0)			$err=$rowi.lang("Step Value must be +ve") ;
		if (!is_numeric($step))		$err=$rowi.lang("Step Value must be numeric");
		if ($ct['rate'.$i]=='')		$err=$rowi.lang("Rate Value Missing") ;
		if ($ct['rate'.$i]<0)		$err=$rowi.lang("Rate Value must be +ve") ;
		if (!is_numeric($ct['rate'.$i])) $err=$rowi.lang("Rate Value must be numeric");
		if ($ct['subtract'.$i]=='')	$err=$rowi.lang("Subtract Value Missing") ;
		if ($ct['subtract'.$i]<0)	$err=$rowi.lang("Subtract Value must be +ve") ;
		if (!is_numeric($ct['subtract'.$i])) $err=$rowi.lang("Subtract Value must be numeric");
		if ($i>1) {
			if ($step<=$laststep)	$err=$rowi.lang("Step Value must be strictly ascending") ;
			$laststep = $step ;
			}
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post contri to Database

    function contri_post($ct, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $ct[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql ="INSERT INTO contri (id,name,description,locality,ac_exp,ac_liab,floor,min,actmin,max,actmax) " ;
			$sql.="VALUES ('$id','$ct[name]','$ct[desc]','$ct[locality]','$ct[ac_exp]'," ;
			$sql.="'$ct[ac_liab]','$ct[floor]','$ct[min]','$ct[actmin]','$ct[max]','$ct[actmax]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE contri SET name='$ct[name]',description='$ct[desc]'," ;
			$sql.="locality='$ct[locality]',ac_exp='$ct[ac_exp]',ac_liab='$ct[ac_liab]'," ;
			$sql.="floor='$ct[floor]',min='$ct[min]',actmin='$ct[actmin]'," ;
			$sql.="max='$ct[max]',actmax='$ct[actmax]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from contri where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	if ($op<>'new')	{
		$phpgw->db->query("DELETE from cntrexem where cntrid='$id'");
		$phpgw->db->query("DELETE from cntrrate where cntrid='$id'");
		}
	if ($op<>'delete') {
		For ($i=1;isset($ct['eaid'.$i]);$i++) {
			$eaid		=	$ct['eaid'.$i];
			$exemmin	=	$ct['exemmin'.$i] ;
			$exemactmin	=	$ct['exemactmin'.$i] ;
			$exemmax	=	$ct['exemmax'.$i] ;
			$exemactmax	=	$ct['exemactmax'.$i] ;
			$sql = "INSERT INTO cntrexem (cntrid,pyrcodeid,min,actmin,max,actmax)" ;
			$sql.=	"VALUES ('$id','$eaid','$exemmin','$exemactmin','$exemmax','$exemactmax')" ;
			$phpgw->db->query($sql);
			}
		For ($i=1;isset($ct['step'.$i]);$i++) {
			$step		=	$ct['step'.$i];
			$rate		=	$ct['rate'.$i] ;
			$subtract	=	$ct['subtract'.$i] ;
			$sql = "INSERT INTO cntrrate (cntrid,step,rate,subtract)" ;
			$sql.=	"VALUES ('$id','$step','$rate','$subtract')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Company Contribution Type") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Contribution Header

    function contri_header_write(&$t, &$ct) {
	global $phpgw ;

	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_desc',lang('Description'));
	$t->set_var('lang_locality',lang('Locality'));
	$t->set_var('lang_ac_exp',lang('Payroll Expense Account'));
	$t->set_var('lang_ac_liab',lang('Payroll Liability Account'));
	$t->set_var('lang_floor',lang('Floor'));
	$t->set_var('lang_min',lang('Minimum'));
	$t->set_var('lang_actmin',lang('If < Min'));
	$t->set_var('lang_max',lang('Maximum'));
	$t->set_var('lang_actmax',lang('If > Max'));
	$t->set_var('name',$ct[name]) ;
	$t->set_var('id',$ct[id]) ;
	$t->set_var('desc',$ct[desc]) ;
	$t->set_var('locality',$ct[locality]) ;
	$t->set_var('ac_exp_selectlist',account_selectlist("WHERE link like '%PY_expense%'",$ct[ac_exp])) ;
	$account_sl = account_selectlist("WHERE link like '%PY:%' or link like '%PY'",$ct[ac_liab]) ;
	$t->set_var('ac_liab_selectlist',$account_sl) ;
	$t->set_var('floor',$ct[floor]) ;
	$threshold_sl = "<OPTION value='rej'>".lang('Reject')."</OPTION><OPTION value='lmt'>".lang('Set to Limit')."</OPTION>" ;
	$t->set_var('min',$ct[min]) ;
	$t->set_var('actmin_selectlist',str_replace("'$ct[actmin]'","'$ct[actmin]' selected",$threshold_sl)) ;
	$t->set_var('max',$ct[max]) ;
	$t->set_var('actmax_selectlist',str_replace("'$ct[actmax]'","'$ct[actmax]' selected",$threshold_sl)) ;

	$t->parse('out','report',True);
	}

//---- Write Contribution Detail

    function contri_detail_write(&$t, &$ct, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$exrow_ = lang('exRow')." " ;
	$rtrow_ = lang('rtRow')." " ;
	$id = $ct[id] ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_exem',lang('Items to be excluded from PayrollTotal during Calculation (ExemptItem)'));
	$t->set_var('lang_eaid',lang("Allowance/Deduction"));
	$t->set_var('lang_exemmin',lang("Minimum"));
	$t->set_var('lang_exemactmin',lang('If < Min'));
	$t->set_var('lang_exemmax',lang("Maximum"));
	$t->set_var('lang_exemactmax',lang('If > Max'));
	$t->set_var('lang_delete',lang('Delete'));

	$eaid_sl = eaid_selectlist('','','short') ;
	$threshold_sl = "<OPTION value='rej'>".lang('Reject')."</OPTION><OPTION value='lmt'>".lang('Set to Limit')."</OPTION>" ;
	if (isset($delete))	$delrowno = intval(str_replace($exrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($ct['eaid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		$j = $i ;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$t->set_var('eaid_fld','eaid'.$j) ;
		$t->set_var('exemmin_fld','exemmin'.$j) ;
		$t->set_var('exemactmin_fld','exemactmin'.$j) ;
		$t->set_var('exemmax_fld','exemmax'.$j) ;
		$t->set_var('exemactmax_fld','exemactmax'.$j) ;
		$eaid = $ct['eaid'.$i] ;
		$t->set_var('eaid_selectlist',str_replace("'$eaid'","'$eaid' selected",$eaid_sl)) ;
		$t->set_var('exemmin',$ct['exemmin'.$i]) ;
		$actmin = $ct['exemactmin'.$i] ;
		$t->set_var('exemactmin_selectlist',str_replace("'$actmin'","'$actmin' selected",$threshold_sl)) ;
		$t->set_var('exemmax',$ct['exemmax'.$i]) ;
		$actmax = $ct['exemactmax'.$i] ;
		$t->set_var('exemactmax_selectlist',str_replace("'$actmax'","'$actmax' selected",$threshold_sl)) ;
		if ($posted)	$t->set_var('exdelrowno',"done") ;
			else	$t->set_var('exdelrowno',$exrow_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('exem_section','exem', True);
		}
	if ($i==1)			$t->set_var('exem_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('exem_section','') ;
	if ($newrow==lang('Add New ExemptItem Row')) {
		$t->set_var('eaid_fld','eaid'.$i) ;
		$t->set_var('exemmin_fld','exemmin'.$i) ;
		$t->set_var('exemactmin_fld','exemactmin'.$i) ;
		$t->set_var('exemmax_fld','exemmax'.$i) ;
		$t->set_var('exemactmax_fld','exemactmax'.$i) ;
		$t->set_var('eaid_selectlist',$eaid_sl) ;
		$t->set_var('exemmin','') ;
		$t->set_var('exemactmin_selectlist',$threshold_sl) ;
		$t->set_var('exemmax','') ;
		$t->set_var('exemactmax_selectlist',$threshold_sl) ;
		$t->set_var('exdelrowno',$exrow_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('exem_section','exem', True);
		}

	$t->set_var('lang_ratetbl',lang('(Progressive) Contribution Rate Table'));
	$t->set_var('lang_insert',lang('Insert before'));
	$t->set_var('lang_floor',lang("Floor"));
	$t->set_var('lang_step',lang("Step"));
	$t->set_var('lang_rate',lang("Rate"));
	$t->set_var('lang_subtract',lang("Subtract"));
	$t->set_var('lang_ratemin',lang("Minimum"));
	$t->set_var('lang_ratemax',lang("Maximum"));
	$t->set_var('lang_delete',lang('Delete'));
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($rtrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($ct['step'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('step_fld','step'.$i) ;
			$t->set_var('rate_fld','rate'.$i) ;
			$t->set_var('subtract_fld','subtract'.$i) ;
			$t->set_var('step','') ;
			$t->set_var('rate','') ;
			$t->set_var('subtract','') ;
			$t->set_var('rtdelrowno',$rtrow_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('rate_section','ratetbl', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$t->set_var('step_fld','step'.$j) ;
		$t->set_var('rate_fld','rate'.$j) ;
		$t->set_var('subtract_fld','subtract'.$j) ;
		$t->set_var('step',$ct['step'.$i]) ;
		$t->set_var('rate',$ct['rate'.$i]) ;
		$t->set_var('subtract',$ct['subtract'.$i]) ;

		if ($posted)	$t->set_var('insrowno',"done") ;	else $t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('rtdelrowno',"done") ;	else $t->set_var('rtdelrowno',$rtrow_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('rate_section','ratetbl', True);
		}
	if ($i==1)			$t->set_var('rate_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('rate_section','') ;
	if ($newrow==lang('Add New Rate Table Row')) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('step_fld','step'.$i) ;
		$t->set_var('rate_fld','rate'.$i) ;
		$t->set_var('subtract_fld','subtract'.$i) ;
		$t->set_var('step','') ;
		$t->set_var('rate','') ;
		$t->set_var('subtract','') ;
		$t->set_var('rtdelrowno',$rtrow_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('rate_section','ratetbl', True);
		}

	$t->parse('out','report',True);
	}

    }

?>
