<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.nrtrans.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class nrtrans {

//---- Non-recurring Payroll Item Validation Checks

    function nrtrans_validate($nr,$oldeaid) {
	global $phpgw ;

	$err=""; $error = lang("Error") ;
	$eaid = $nr[eaid] ;
	$qty = $nr[qty] ;
	$amt = $nr[amount] ;
	$nr[empid] = ($nr[empid]=="") ? 0 : $nr[empid] ;
	$phpgw->db->query("SELECT * from payroll WHERE empid='$nr[empid]'");
	if ($phpgw->db->num_rows()==0)		$err=lang("Employee Payroll Master Info missing") ;
	$phpgw->db->query("SELECT * from pyrcode where id='$eaid'");
	$phpgw->db->next_record();
	if ($qty<$phpgw->db->f('minqty'))	$err=lang("Quantity too low");
	if ($qty>$phpgw->db->f('maxqty'))	$err=lang("Quantity too high");
	if ($amt<$phpgw->db->f('minamt'))	$err=lang("Amount too low");
	if ($amt>$phpgw->db->f('maxamt'))	$err=lang("Amount too high");
	if ($qty=="")				$err=lang("Quantity Missing");
	if ($qty<>"" and !is_numeric($qty))	$err=lang("Quantity must be numeric");
	if ($amt=="")				$err=lang("Amount Missing");
	if ($amt<>"" and !is_numeric($amt))	$err=lang("Amount must be numeric");
	if ($phpgw->db->f('single')=="y") {
		$phpgw->db->query("SELECT * from pyrc_trans a, payroll b where a.pyroid=b.id and b.empid='$nr[empid]' and pyrcodeid='$eaid'");
		if ($phpgw->db->num_rows()>0)	$err=lang("This Expense/Allowance (recurring) already exists") ;
		if ($eaid<>$oldeaid) {
			$sql = "SELECT * from pynr_trans where empid='$nr[empid]' and pyrcodeid='$eaid'" ;
			$phpgw->db->query($sql);
			if ($phpgw->db->num_rows()>0)	$err=lang("This Expense/Allowance (non-recurring) already exists") ;
			}
		}
	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Non-recurring Payroll Item to Database

    function nrtrans_post($nr, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $nr[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO pynr_trans (id,empid,pyrcodeid,qty,unit,unitamt,rate,amount,comment,chart_id,approved_by) " ;
			$sql.= "VALUES ('$id','$nr[empid]','$nr[eaid]','$nr[qty]','$nr[unit]'," ;
			$sql.= 	"'$nr[unitamt]','$nr[rate]','$nr[amount]','$nr[comment]'," ;
			$sql.=	"'$nr[chart_id]','$nr[approved_by]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE pynr_trans SET empid='$nr[empid]',pyrcodeid='$nr[eaid]'," ;
			$sql.="qty='$nr[qty]',unit='$nr[unit]',unitamt='$nr[unitamt]'," ;
			$sql.="rate='$nr[rate]',amount='$nr[amount]',comment='$nr[comment]'," ;
			$sql.="chart_id='$nr[chart_id]',approved_by='$nr[approved_by]' WHERE id='$id'";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM pynr_trans WHERE id='$id'");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Non-recurring Payroll Item") ;
	$msg = "$type $tran [id#$id] $actioned." ;

	$user = trim($phpgw_info["user"]["userid"]);
	$phpgw->db->query("SELECT name,id FROM employee WHERE username='$user'");
	$phpgw->db->next_record();
	$pystaffname = $phpgw->db->f('name');
	$pystaffid = $phpgw->db->f('id');
	$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$pystaffid' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$pystaffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername " ;
	$sql.= "FROM employee a, employee b WHERE a.id='$nr[empid]' and a.supervisor=b.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffname = $phpgw->db->f('staffname');
	$superid = $phpgw->db->f('superid');
	$supername = $phpgw->db->f('supername');
	$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$nr[empid]' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$superid' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$recipient = "$staffname < $staffemail >" ;
	$subject = lang("%1's Non-recurring Payroll Item [id#%2] %3 by Payroll Staff",$staffname,$id,$actioned) ;
	$message = '' ;
	$headers = "From: $pystaffname < $pystaffemail > \n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $pystaffname < $pystaffemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	$successmsg = lang("Email advising action on non-recurring payroll item [id#%1] successfully sent to",$id) ;
	$failuremsg = lang("Email advising action on non-recurring payroll item [id#%1] fails to deliver.  Please manually inform",$id) ;
	$lang_staff = lang("Staff:") ;
	if ($result)	$msg = "$msg<br>$lang_staff $successmsg $staffname." ;
		else	$msg = "$msg<br>$lang_staff $failuremsg $staffname." ;
	$recipient = "$supername < $superemail >" ;
	$lang_super = lang("Supervisor:") ;
	$result= mail($recipient,$subject,$message,$headers) ;
	if ($result)	$msg = "$msg<br>$lang_super $successmsg $supername." ;
		else	$msg = "$msg<br>$lang_super $failuremsg $supername." ;

	$t->set_var("message","<b>$msg</b>") ;
	$t->set_var('lang_confirm',"<b>$msg</b>");
//	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.<br>$msg</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Non-recurring Payroll Item Detail

    function nrtrans_write(&$t, &$nr) {
	global $phpgw,$phpgw_info ;

	$t->set_var('lang_empid',lang('Employee Name/#'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_salary',lang('Basic Salary'));
	$t->set_var('lang_period',lang('Pay Period'));
	$t->set_var('lang_daypay',lang('Imputed Daily Pay'));
	$t->set_var('lang_hourpay',lang('Imputed Hourly Pay'));
	$t->set_var('lang_eaid',lang('Expense/Allowance Type'));
	$t->set_var('lang_basis',lang('Basis of Calculation'));
	$t->set_var('lang_qty',lang('Quantity'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_unitamt',lang('Unit Amount'));
	$t->set_var('lang_rate',lang('Pay Rate'));
	$t->set_var('lang_amount',lang('Amount'));
	$t->set_var('lang_comment',lang('Comment'));
	$t->set_var('lang_approved_by',lang('Approved By'));
	$t->set_var('lang_chart_id',lang('Payroll Expense Account'));
	if ($nr[empid]=='')	$where='';	else $where = "WHERE id='$nr[empid]'" ;
	$t->set_var('empid_selectlist',employee_selectlist($where,$nr[empid])) ;
	$t->set_var('id',$nr[id]);
	$t->set_var('salary',$nr[salary]);
	$t->set_var('period',$nr[period]) ;
	$t->set_var('daypay',$nr[daypay]);
	$t->set_var('hourpay',$nr[hourpay]) ;
	$eaid = $nr[eaid] ;
	$t->set_var('eaid_selectlist',eaid_selectlist('',$eaid,'long')) ;

	$qty = 1 ;
	$eaid = ($eaid=="") ? 0 : $eaid ;
	$phpgw->db->query("SELECT * from pyrcode where id='$eaid'");
	$phpgw->db->next_record();
	$basis		=	$phpgw->db->f('basis') ;
	$unit		=	$phpgw->db->f('unit') ;
	$unitamt	=	(substr_count($basis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
	$rate		=	$phpgw->db->f('rate') ;
	$chart_id	=	($nr[rate]==0) ? $phpgw->db->f('chart_id') : $nr[chart_id] ;
	$nr[chart_id]	=	$phpgw->db->f('chart_id') ;
	if (substr_count($basis,'qty')>0)	{$qty = $nr[qty]; $t->set_var('qty_readonly','');}
		else				$t->set_var('qty_readonly','readonly') ;
	if (substr_count($basis,'bs')>0)	$unitamt = $nr[salary] ;
	if (substr_count($basis,'hp')>0)	$unitamt = $nr[hourpay] ;
	if (substr_count($basis,'dp')>0)	$unitamt = $nr[daypay] ;
	$amount = sprintf("%01.2f",$qty*$unitamt*$rate) ;
	if (substr_count($basis,'amt')>0)	{$amount=$nr[amount]; $t->set_var('amt_readonly','');}
		else				$t->set_var('amt_readonly','readonly') ;
	$nr[qty] = $qty ;
	$nr[unit] = $unit ;
	$nr[unitamt] = $unitamt ;
	$nr[rate] = $rate ;
	$nr[amount] = $amount ;
	$nr[chart_id] = $chart_id ;
	$t->set_var('basis',$basis);
	$t->set_var('qty',$qty);
	$t->set_var('unit',$unit);
	$t->set_var('unitamt',$unitamt);
	$t->set_var('rate',$rate);
	$t->set_var('amount',$amount);
	$t->set_var('comment',$nr[comment]);
	$t->set_var('approved_by',$nr[approved_by]);
	$chartid_sl = account_selectlist("WHERE link like '%PY_expense%'",$chart_id) ;
	$t->set_var('chart_id_selectlist',$chartid_sl);
	$t->parse('out','report',True);
	}

    }

?>
