<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.pyrcode.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class pyrcode {

//---- Allowance/Deduction Code Detail Validation Checks

    function pyrcode_validate($p) {
	global $phpgw ;

	$err=""; $error=lang('Error') ;
	if ($p[name]=="")		$err=lang('Allowance/Deduction Code Name Missing');
	if ($p[name]=="basesalary")	$err=lang('Basic Salary should not be deleted') ;
	if (strlen($p[name])>10)	$err=lang('Allowance/Deduction Code Name too long (must be <=10)');
	if ($p[description]=="")	$err=lang('Allowance/Deduction Code Description Missing');
	if (strlen($p[description])>50)	$err=lang('Allowance/Deduction Code Description too long (must be <=50)');

	$basis = $p[basis] ;
	if (substr_count($basis,'qty')>0) {
		if (!is_numeric($p[minqty]))	$err=lang('Min Quantity must be numeric');
		if (!is_numeric($p[maxqty]))	$err=lang('Max Quantity must be numeric');
		if ($p[minqty]>$p[maxqty])	$err=lang('Min Quantity must not > Max Quantity') ;
		}
	if (substr_count($basis,'amt')>0) {
		if (!is_numeric($p[minamt]))	$err=lang('Min Amount must be numeric');
		if (!is_numeric($p[maxamt]))	$err=lang('Max Amount must be numeric');
		if ($p[minamt]>$p[maxamt])	$err=lang('Min Amount must not > Max Amount') ;
		}
	if (substr_count($basis,'pc')>0)
		if (!is_numeric($p[unitamt]))	$err=lang('Unit Amount must be numeric');
	if (!is_numeric($p[rate]))	$err=lang('Pay Rate must be numeric');
	if ($p[rate]==0)		$err=lang('Pay Rate cannot be zero');
	if ($p[rate]=='')		$err=lang('Pay Rate Missing');
	if ($err)			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Allowance/Deduction Code Delete Validation Checks

    function delete_validate($p) {
	global $phpgw ;
	
	$err=""; $error=lang('Error') ;
	$allow = $p[allowdelete] ;
	if ($allow<>"y" and $allow<>"Y")	$err = lang("Allowance/Deduction code flagged deletion not allowed") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Allowance/Deduction Code Detail to Database

    function pyrcode_post($p, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id	= $p[id] ;
	$app	= $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO pyrcode (id,name,description,basis,minqty,maxqty," ;
			$sql.= 	"minamt,maxamt,unitamt,unit,rate,chart_id,allowdelete,single,allowssc) " ;
			$sql.= "VALUES ('$id','$p[name]','$p[description]','$p[basis]','$p[minqty]'," ;
			$sql.=	"'$p[maxqty]','$p[minamt]','$p[maxamt]','$p[unitamt]','$p[unit]'," ;
			$sql.=	"'$p[rate]','$p[chart_id]','$p[allowdelete]','$p[single]','$p[allowssc]')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE pyrcode SET name='$p[name]',description='$p[description]'," ;
			$sql.= "basis='$p[basis]',minqty='$p[minqty]',maxqty='$p[maxqty]',";
			$sql.= "minamt='$p[minamt]',maxamt='$p[maxamt]',unitamt='$p[unitamt]',unit='$p[unit]'," ;
			$sql.= "rate='$p[rate]',chart_id='$p[chart_id]',allowdelete='$p[allowdelete]'," ;
			$sql.= "single='$p[single]',allowssc='$p[allowssc]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from pyrcode where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Allowance/Deduction Code") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Allowance/Deduction Code Detail

    function pyrcode_write(&$t, $p) {
	global $phpgw ;

	$noyes_sl = "<OPTION value='n'>".lang('No')."</OPTION><OPTION value='y'>".lang('Yes')."</OPTION>" ;
	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_name',lang('Code Name (10 char max)'));
	$t->set_var('lang_description',lang('Description (50 char max)'));
	$t->set_var('lang_basis',lang('Basis of Calculation'));
	$t->set_var('lang_minqty',lang('Minimum Quantity'));
	$t->set_var('lang_maxqty',lang('Maximum Quantity'));
	$t->set_var('lang_minamt',lang('Minimum Amount'));
	$t->set_var('lang_maxamt',lang('Maximum Amount'));
	$t->set_var('lang_unitamt',lang('Unit Amount'));
	$t->set_var('lang_unit',lang('Unit Measure'));
	$t->set_var('lang_rate',lang('Pay Rate (should normally be one)'));
	$t->set_var('lang_chart_id',lang('Payroll Expense Account'));
	$t->set_var('lang_single',lang('One item per Payroll'));
	$t->set_var('lang_allowssc',lang('Allow Staff Self Claim'));
	$t->set_var('lang_adelete',lang('Allow Delete'));
	$id = $p[id] ;
	$basis = $p[basis] ;
	$t->set_var('id',$id);
	$t->set_var('name',$p[name]);
	$t->set_var('description',$p[description]);
	$t->set_var('basis_selectlist',basis_selectlist('',$basis));
	$t->set_var('minqty',$p[minqty]);
	$t->set_var('maxqty',$p[maxqty]);
	if (substr_count($basis,'qty')>0)	$t->set_var('qty_readonly','');
			else			$t->set_var('qty_readonly','readonly') ;
	$t->set_var('minamt',$p[minamt]);
	$t->set_var('maxamt',$p[maxamt]);
	if (substr_count($basis,'amt')>0)	$t->set_var('amt_readonly','');
		else				$t->set_var('amt_readonly','readonly') ;
	$t->set_var('unitamt',$p[unitamt]);
	if (substr_count($basis,'pc')>0)	$t->set_var('unitamt_readonly','');
		else				$t->set_var('unitamt_readonly','readonly') ;
	$t->set_var('unit',$p[unit]);
	$t->set_var('rate',$p[rate]);
	$pyexac_sl = account_selectlist("WHERE link like '%PY_expense%'",$p[chart_id]) ;
	$t->set_var('pyexac_selectlist',$pyexac_sl);
	$ad_sl = str_replace("'$p[allowdelete]'","'$p[allowdelete]' selected",$noyes_sl) ;
	$t->set_var('adelete_selectlist',$ad_sl);
	$single_sl = str_replace("'$p[single]'","'$p[single]' selected",$noyes_sl) ;
	$t->set_var('single_selectlist',$single_sl);
	$allowssc_sl = str_replace("'$p[allowssc]'","'$p[allowssc]' selected",$noyes_sl) ;
	$t->set_var('allowssc_selectlist',$allowssc_sl);

	$t->parse('out','report',True);
	}

    }

?>
