<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.reductn.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class reductn {

//---- reductn Validation Checks

    function reductn_validate($rd,$oldrdname) {
	global $phpgw ;

	$err=""; $error = lang("Error") ;
	$exem = lang("ExemptItem") ;
	$ratetbl = lang("Rate Table") ;
	$row = lang("Row") ;
	$phpgw->db->query("SELECT * from reductn WHERE name='$rd[name]'");
	if ($rd[name]<>$oldrdname and $phpgw->db->num_rows()>0)
		$err=lang("Summary Level Reduction Name already in use");
	if ($rd[name]=='')		$err=lang("Reduction Name Missing");
	if ($rd[desc]=='')		$err=lang("Reduction Description Missing");
	if ($rd[locality]=='')		$err=lang("Locality Missing");
	if ($rd[chart_id]=='')		$err=lang("Payroll Reduction Account Missing") ;
	if ($rd[floor]=='')		$err=lang("Reduction Floor Value Missing");
	if (!is_numeric($rd[floor]))	$err=lang("Reduction Floor Value must be numeric") ;
	if ($rd[min]=='')		$err=lang("Reduction Minimum Value Missing");
	if ($rd[max]=='')		$err=lang("Reduction Maximum Value Missing");
	if ($rd[min]>$rd[max])		$err=lang("Reduction Minimum > Maximum") ;
	if (!is_numeric($rd[min]))	$err=lang("Reduction Minimum Value must be numeric") ;
	if (!is_numeric($rd[max]))	$err=lang("Reduction Maximum Value must be numeric") ;
	For ($i=1;isset($rd['eaid'.$i]);$i++) {
		$rowi = "[$exem $row $i]" ;
		$min = $rd['exemmin'.$i] ;
		$max = $rd['exemmax'.$i] ;
		if ($rd['eaid'.$i]=='')	$err=$rowi.lang("Allowance/Deduction Code Missing") ;
		if ($min=='')		$err=$rowi.lang("ExemptItem Minimum Value Missing");
		if ($max=='')		$err=$rowi.lang("ExemptItem Maximum Value Missing");
		if ($min>$max)		$err=$rowi.lang("ExemptItem Minimum > Maximum") ;
		if (!is_numeric($min))	$err=$rowi.lang("ExemptItem Minimum Value must be numeric");
		if (!is_numeric($max))	$err=$rowi.lang("ExemptItem Maximum Value must be numeric");
		}
	if (isset($rd[step1]))		$laststep = $rd[step1] ;
	For ($i=1;isset($rd['step'.$i]);$i++) {
		$rowi = "[$ratetbl $row $i]" ;
		$step = $rd['step'.$i] ;
		if ($step=='')			$err=$rowi.lang("Step Value Missing") ;
		if ($step<0)			$err=$rowi.lang("Step Value must be +ve") ;
		if (!is_numeric($step))		$err=$rowi.lang("Step Value must be numeric");
		if ($rd['rate'.$i]=='')		$err=$rowi.lang("Rate Value Missing") ;
		if ($rd['rate'.$i]<0)		$err=$rowi.lang("Rate Value must be +ve") ;
		if (!is_numeric($rd['rate'.$i])) $err=$rowi.lang("Rate Value must be numeric");
		if ($rd['subtract'.$i]=='')	$err=$rowi.lang("Subtract Value Missing") ;
		if ($rd['subtract'.$i]<0)	$err=$rowi.lang("Subtract Value must be +ve") ;
		if (!is_numeric($rd['subtract'.$i])) $err=$rowi.lang("Subtract Value must be numeric");
		if ($i>1) {
			if ($step<=$laststep)	$err=$rowi.lang("Step Value must be strictly ascending") ;
			$laststep = $step ;
			}
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post reductn to Database

    function reductn_post($rd, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $rd[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql ="INSERT INTO reductn (id,name,description,locality,chart_id,floor,min,actmin,max,actmax) " ;
			$sql.="VALUES ('$id','$rd[name]','$rd[desc]','$rd[locality]','$rd[chart_id]'," ;
			$sql.="'$rd[floor]','$rd[min]','$rd[actmin]','$rd[max]','$rd[actmax]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE reductn SET name='$rd[name]',description='$rd[desc]'," ;
			$sql.="locality='$rd[locality]',chart_id='$rd[chart_id]',floor='$rd[floor]'," ;
			$sql.="min='$rd[min]',actmin='$rd[actmin]',max='$rd[max]',actmax='$rd[actmax]' ";
			$sql.="WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from reductn where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	if ($op<>'new')	{
		$phpgw->db->query("DELETE from rdtnexem where rdtnid='$id'");
		$phpgw->db->query("DELETE from rdtnrate where rdtnid='$id'");
		}
	if ($op<>'delete') {
		For ($i=1;isset($rd['eaid'.$i]);$i++) {
			$eaid		=	$rd['eaid'.$i];
			$exemmin	=	$rd['exemmin'.$i] ;
			$exemactmin	=	$rd['exemactmin'.$i] ;
			$exemmax	=	$rd['exemmax'.$i] ;
			$exemactmax	=	$rd['exemactmax'.$i] ;
			$sql = "INSERT INTO rdtnexem (rdtnid,pyrcodeid,min,actmin,max,actmax)" ;
			$sql.=	"VALUES ('$id','$eaid','$exemmin','$exemactmin','$exemmax','$exemactmax')" ;
			$phpgw->db->query($sql);
			}
		For ($i=1;isset($rd['step'.$i]);$i++) {
			$step		=	$rd['step'.$i];
			$rate		=	$rd['rate'.$i] ;
			$subtract	=	$rd['subtract'.$i] ;
			$sql = "INSERT INTO rdtnrate (rdtnid,step,rate,subtract)" ;
			$sql.=	"VALUES ('$id','$step','$rate','$subtract')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Summary Level Reduction") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write reductn Header

    function reductn_header_write(&$t, &$rd) {
	global $phpgw ;

	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_desc',lang('Description'));
	$t->set_var('lang_locality',lang('Locality'));
	$t->set_var('lang_chart_id',lang('Payroll Expense/Liability Account'));
	$t->set_var('lang_floor',lang('Floor'));
	$t->set_var('lang_min',lang('Minimum'));
	$t->set_var('lang_actmin',lang('If < Min'));
	$t->set_var('lang_max',lang('Maximum'));
	$t->set_var('lang_actmax',lang('If > Max'));
	$t->set_var('name',$rd[name]) ;
	$t->set_var('id',$rd[id]) ;
	$t->set_var('desc',$rd[desc]) ;
	$t->set_var('locality',$rd[locality]) ;
	$account_sl = account_selectlist("WHERE link like '%PY:%' or link like '%PY' or link like '%PY_expense%'",$rd[chart_id]) ;
	$t->set_var('chart_id_selectlist',$account_sl) ;
	$t->set_var('floor',$rd[floor]) ;
	$threshold_sl = "<OPTION value='rej'>".lang('Reject')."</OPTION><OPTION value='lmt'>".lang('Set to Limit')."</OPTION>" ;
	$t->set_var('min',$rd[min]) ;
	$t->set_var('actmin_selectlist',str_replace("'$rd[actmin]'","'$rd[actmin]' selected",$threshold_sl)) ;
	$t->set_var('max',$rd[max]) ;
	$t->set_var('actmax_selectlist',str_replace("'$rd[actmax]'","'$rd[actmax]' selected",$threshold_sl)) ;
	$t->parse('out','report',True);
	}

//---- Write reductn Detail

    function reductn_detail_write(&$t, &$rd, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$exrow_ = lang('exRow')." " ;
	$rtrow_ = lang('rtRow')." " ;
	$id = $rd[id] ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_exem',lang('Items to be excluded from PayrollTotal during Calculation (ExemptItem)'));
	$t->set_var('lang_eaid',lang("Allowance/Deduction"));
	$t->set_var('lang_exemmin',lang("Minimum"));
	$t->set_var('lang_exemactmin',lang('If < Min'));
	$t->set_var('lang_exemmax',lang("Maximum"));
	$t->set_var('lang_exemactmax',lang('If > Max'));
	$t->set_var('lang_delete',lang('Delete'));

	$eaid_sl = eaid_selectlist('','','short') ;
	$threshold_sl = "<OPTION value='rej'>".lang('Reject')."</OPTION><OPTION value='lmt'>".lang('Set to Limit')."</OPTION>" ;
	if (isset($delete))	$delrowno = intval(str_replace($exrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($rd['eaid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		$j = $i ;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$t->set_var('eaid_fld','eaid'.$j) ;
		$t->set_var('exemmin_fld','exemmin'.$j) ;
		$t->set_var('exemactmin_fld','exemactmin'.$j) ;
		$t->set_var('exemmax_fld','exemmax'.$j) ;
		$t->set_var('exemactmax_fld','exemactmax'.$j) ;
		$eaid = $rd['eaid'.$i] ;
		$t->set_var('eaid_selectlist',str_replace("'$eaid'","'$eaid' selected",$eaid_sl)) ;
		$t->set_var('exemmin',$rd['exemmin'.$i]) ;
		$actmin = $rd['exemactmin'.$i] ;
		$t->set_var('exemactmin_selectlist',str_replace("'$actmin'","'$actmin' selected",$threshold_sl)) ;
		$t->set_var('exemmax',$rd['exemmax'.$i]) ;
		$actmax = $rd['exemactmax'.$i] ;
		$t->set_var('exemactmax_selectlist',str_replace("'$actmax'","'$actmax' selected",$threshold_sl)) ;

		if ($posted)	$t->set_var('exdelrowno',"done") ;
			else	$t->set_var('exdelrowno',$exrow_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('exem_section','exem', True);
		}
	if ($i==1)			$t->set_var('exem_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('exem_section','') ;
	if ($newrow==lang('Add New ExemptItem Row')) {
		$t->set_var('eaid_fld','eaid'.$i) ;
		$t->set_var('exemmin_fld','exemmin'.$i) ;
		$t->set_var('exemactmin_fld','exemactmin'.$i) ;
		$t->set_var('exemmax_fld','exemmax'.$i) ;
		$t->set_var('exemactmax_fld','exemactmax'.$i) ;
		$t->set_var('eaid_selectlist',$eaid_sl) ;
		$t->set_var('exemmin','') ;
		$t->set_var('exemactmin_selectlist',$threshold_sl) ;
		$t->set_var('exemmax','') ;
		$t->set_var('exemactmax_selectlist',$threshold_sl) ;
		$t->set_var('exdelrowno',$exrow_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('exem_section','exem', True);
		}

	$t->set_var('lang_ratetbl',lang('(Progressive) Reduction/Tax Rate Table'));
	$t->set_var('lang_insert',lang('Insert before'));
	$t->set_var('lang_floor',lang("Floor"));
	$t->set_var('lang_step',lang("Step"));
	$t->set_var('lang_rate',lang("Rate"));
	$t->set_var('lang_subtract',lang("Subtract"));
	$t->set_var('lang_ratemin',lang("Minimum"));
	$t->set_var('lang_ratemax',lang("Maximum"));
	$t->set_var('lang_delete',lang('Delete'));
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($rtrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($rd['step'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('step_fld','step'.$i) ;
			$t->set_var('rate_fld','rate'.$i) ;
			$t->set_var('subtract_fld','subtract'.$i) ;
			$t->set_var('step','') ;
			$t->set_var('rate','') ;
			$t->set_var('subtract','') ;
			$t->set_var('rtdelrowno',$rtrow_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('rate_section','ratetbl', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$t->set_var('step_fld','step'.$j) ;
		$t->set_var('rate_fld','rate'.$j) ;
		$t->set_var('subtract_fld','subtract'.$j) ;
		$t->set_var('step',$rd['step'.$i]) ;
		$t->set_var('rate',$rd['rate'.$i]) ;
		$t->set_var('subtract',$rd['subtract'.$i]) ;

		if ($posted)	$t->set_var('insrowno',"done") ;	else $t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('rtdelrowno',"done") ;	else $t->set_var('rtdelrowno',$rtrow_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('rate_section','ratetbl', True);
		}
	if ($i==1)			$t->set_var('rate_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('rate_section','') ;
	if ($newrow==lang('Add New Rate Table Row')) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('step_fld','step'.$i) ;
		$t->set_var('rate_fld','rate'.$i) ;
		$t->set_var('subtract_fld','subtract'.$i) ;
		$t->set_var('step','') ;
		$t->set_var('rate','') ;
		$t->set_var('subtract','') ;
		$t->set_var('rtdelrowno',$rtrow_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('rate_section','ratetbl', True);
		}

	$t->parse('out','report',True);
	}

    }

?>
