<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.po.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class po {

//---- PO Detail Validation Checks

    function po_validate($p) {
	global $phpgw ;
	$err="";
	$row = lang("Row") ;
	if ($p[ponumber]=="")			$err=lang('Error: Purchase Order Number Missing');
	if (input2date($p[transdate])=="")	$err=lang('Error: Invalid Purchase Order Date');
	if (input2date($p[duedate])=="")	$err=lang('Error: Invalid Due Date');
	For ($i=1;isset($p['itemid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		if ($p['itemid'.$i]=='')	$err=lang('Error: Item Code Missing');
		if ($p['qty'.$i] and !is_numeric($p['qty'.$i]))
						$err=$rowi.lang("Error: Invalid Qty, must be numeric");
		if ($p['discount'.$i] and !is_numeric($p['discount'.$i]) and $p[taxstatus]<>"t")
						$err=$rowi.lang("Error: Invalid Discount, must be numeric");
		if ($p['cost'.$i] and !is_numeric($p['cost'.$i]))
						$err=$rowi.lang("Error: Invalid Unit Price, must be numeric");
		if ($p['tax1'.$i] and !is_numeric($p['tax1'.$i]))
						$err=$rowi.lang("Error: Invalid Tax1, must be numeric");
		if ($p['tax2'.$i] and !is_numeric($p['tax2'.$i]))
						$err=$rowi.lang("Error: Invalid Tax2, must be numeric");
		if (($p[taxstatus]=="f" or $p[taxstatus]=="t") and $p['tax1_pref'.$i]=='')
						$err=$rowi.lang("Error: Blank Choice on Primary Tax Rate");
		if (($p[taxstatus]=="f" or $p[taxstatus]=="t") and $p['tax2_pref'.$i]=='')
						$err=$rowi.lang("Error: Blank Choice on Secondary Tax Rate");
		}
	if ($err)	$err = "<b>$err</b>" ;
	return $err ;
	}

//---- Post Purchase Order to Database

    function po_post($p, &$t, &$id, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $p[id] ;
	$transdate = $p[transdate] ;
	$taxstatus = $p[taxstatus] ;
	$amount = $p[amount] ;
	$netamount = $p[netamount] ;
	if ($p[taxstatus]=="e")		{$taxstatus = "f" ;	$netamount = $amount ;	}

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO po(id,ponumber,transdate,vendor,taxincluded,amount,netamount,duedate,shipfrom,notes) ";
			$sql.= "VALUES ('$id','$p[ponumber]','$transdate','$p[vendor]','$taxstatus','$amount','$netamount'," ;
			$sql.= "'$p[duedate]','$p[shipfrom]','$p[notes]')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE po SET ponumber='$p[ponumber]',transdate='$transdate',vendor='$p[vendor]',";
			$sql.= "taxincluded='$taxstatus',amount='$amount',netamount='$netamount',";
			$sql.= "duedate='$p[duedate]',shipfrom='$p[shipfrom]',notes='$p[notes]' ";
			$sql.= "WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM po WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE FROM oitem WHERE trans_id=$id") ;
	if ($op<>'delete') {
		For ($i=1;isset($p['itemid'.$i]);$i++) {
			$itemid		= $p['itemid'.$i];
			$itemtype	= $p['itemtype'.$i];
			$desc		= $p['description'.$i];
			$unit		= $p['unit'.$i];
			$qty		= $p['qty'.$i];
			$cost		= $p['cost'.$i];
			$discount	= $p['discount'.$i];
			$tax1		= number_format($p['tax1'.$i],2,".",'');
			$tax2		= number_format($p['tax2'.$i],2,".",'');
			$sql = "INSERT INTO oitem (trans_id,itemid,itemtype,description,unit,qty,cost,discount,tax1,tax2) " ;
			$sql.= "VALUES ('$id','$itemid','$itemtype','$desc','$unit','$qty','$cost','$discount','$tax1','$tax2')";
			$phpgw->db->query($sql);
			}
		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("PO") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write PO Header

    function po_header_write(&$t, $p, $taxscript) {
	global $phpgw ;

	$taxstatus = $p[taxstatus] ;
	$t->set_var('lang_ponumber',lang('PO#'));
	$t->set_var('lang_id',lang('Audit Id:')." ");
	$t->set_var('lang_transdate',lang('PO Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_shipfrom',lang('Ship From'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_vendor',lang('Vendor'));
	$t->set_var('lang_taxstatus',lang('Unit Price Tax Status'));
	$t->set_var('lang_totalamt',lang('Total PO Amount'));
	$t->set_var('ponumber',$p[ponumber]) ;
	$t->set_var('shipfrom',$p[shipfrom]) ;
	$t->set_var('transdate',$p[transdate]) ;
	$t->set_var('duedate',$p[duedate]) ;
	$t->set_var('notes',$p[notes]);
	$vendor = $p[vendor] ;
	$t->set_var('vendor',$vendor) ;
	$t->set_var('vendor_selectlist',vendor_selectlist('',$vendor)) ;
	$optiont = lang('Tax Included') ;
	$optionf = lang('Tax Not Included') ;
	$optione = lang('Tax Exempted') ;
	if ($taxscript=="nt")	$tax_sl = "<OPTION value='e' selected>$optione</OPTION>" ;
	    else {
		$tax_sl = "<OPTION value='t'>$optiont</OPTION>" ;
		$tax_sl.= "<OPTION value='f'>$optionf</OPTION>" ;
		$tax_sl.= "<OPTION value='e'>$optione</OPTION>" ;
		$tax_sl = str_replace("'$taxstatus'","'$taxstatus' selected",$tax_sl) ;
		}
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->set_var('id',$p[id]) ;
	$t->parse('out','report',True);
	}

//---- Reformat Purchase Order Array

    function po_transform(&$p,$newrow,$delete) {
	global $phpgw ;

	$row_ = lang('Row')." " ;
	$temp[id] = $p[id] ;
	$temp[vendor] = $p[vendor] ;
	$temp[transdate] = $p[transdate] ;
	$temp[duedate] = $p[duedate] ;
	$temp[ponumber] = $p[ponumber] ;
	$temp[ordnumber] = $p[ordnumber] ;
	$temp[taxstatus] = $p[taxstatus] ;
	$temp[shipfrom] = $p[shipfrom] ;
	$temp[notes] = $p[notes] ;

	if (isset($delete)) {$delrowno = intval(str_replace($row_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($p['itemid'.$i]);$i++) {
		$itemid = $p['itemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($itemid<0)	{
			$itemid = -$itemid ;
			$qty = $p['qty'.$i]==0 ? 1 : $p['qty'.$i] ;
			$phpgw->db->query("SELECT * FROM assembly WHERE assembly_id='$itemid'");
			while ($phpgw->db->next_record()) {
				$temp['itemid'.$j] = $phpgw->db->f('item_id') ;
				$temp['qty'.$j] = $phpgw->db->f('qty') * $qty ;
				$j++ ;
				}
			continue ;
			}
		$temp['itemid'.$j]		=	$p['itemid'.$i] ;
		$temp['itemtype'.$j]		=	$p['itemtype'.$i] ;
		$temp['description'.$j]		=	$p['description'.$i] ;
		$temp['qty'.$j]			=	$p['qty'.$i] ;
		$temp['unit'.$j]		=	$p['unit'.$i] ;
		$temp['cost'.$j]		=	$p['cost'.$i] ;
		$temp['discount'.$j]		=	$p['discount'.$i] ;
		$temp['tax1_pref'.$j]		=	$p['tax1_pref'.$i] ;
		$temp['tax2_pref'.$j]		=	$p['tax2_pref'.$i] ;
		$temp['tax1'.$j]		=	$p['tax1'.$i] ;
		$temp['tax2'.$j]		=	$p['tax2'.$i] ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=True ;
	if ($newrow)					$temp['itemid'.$j] = "" ;
	$p = $temp ;
	unset($temp) ;
	}

//---- Write PO Detail

    function po_detail_write(&$t,&$p,$posted,$firstime) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$taxstatus = $p[taxstatus] ;
	$tax_warning = lang("***** Choice Pending") ;
	if ($taxstatus<>'e') {
		$tax_pref_slist = "<OPTION value=''></OPTION>" ;
		$tax_pref_slist.= "<OPTION value='i'>".lang('apply item tax rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='v'>".lang('apply vendor rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='s'>".lang('apply my std rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='z'>".lang('tax rate = zero')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='m'>".lang('manual tax input')."</OPTION>" ;
		$vendor = ($p[vendor]=="") ? 0 : $p[vendor];
		$sql = "SELECT vendor_id,rate from vendortax a, tax b " ;
		$sql.= "WHERE vendor_id='$vendor' and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$vtax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,rate from vendortax a, tax b " ;
		$sql.= "WHERE vendor_id='$vendor' and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$vtax2rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,rate from vendortax a, tax b, vendor c " ;
		$sql.= "WHERE c.name='zzzzMyself' and vendor_id=c.id and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,rate from vendortax a, tax b, vendor c " ;
		$sql.= "WHERE c.name='zzzzMyself' and vendor_id=c.id and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax2rate = $phpgw->db->f(rate) ;
		}
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_number',lang('Item Code -- Id<br>(Inventory/Service)'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_btup',lang('BTUP'));
	$t->set_var('lang_discount',lang('Discount')."<br>$");
	$t->set_var('lang_tax',lang('Tax'));
	$phpgw->db->query("SELECT aptax1cap,aptax2cap,aptax1pref,aptax2pref FROM defaults");
	$phpgw->db->next_record() ;
	$t->set_var('lang_tax1',$phpgw->db->f(aptax1cap));
	$t->set_var('lang_tax2',$phpgw->db->f(aptax2cap));
	$tax1pref = $phpgw->db->f(aptax1pref) ;
	$tax2pref = $phpgw->db->f(aptax2pref) ;
	$t->set_var('lang_cost',lang('Unit<br>Price'));
	$t->set_var('lang_itemtotal',lang('Item Total'));
	$t->set_var('lang_netamount',lang('Net of Tax'));
	$t->set_var('lang_delete',lang('Delete<br>Button'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$item_sl = item_selectlist("",'') ;
	$sum_tax1 = $sum_tax2 = $sum_itemtotal = $sum_netamount = 0 ;
	For ($i=1;isset($p['itemid'.$i]);$i++) {
		$t->set_var('itemid_fld','itemid'.$i) ;
		$t->set_var('itemtype_fld','itemtype'.$i) ;
		$t->set_var('description_fld','description'.$i);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('unit_fld','unit'.$i);
		$t->set_var('discount_fld','discount'.$i);
		$t->set_var('cost_fld','cost'.$i);
		$t->set_var('tax1_pref_fld','tax1_pref'.$i);
		$t->set_var('tax2_pref_fld','tax2_pref'.$i);
		$t->set_var('tax1_fld','tax1'.$i);
		$t->set_var('tax2_fld','tax2'.$i);
		$itemid = $p['itemid'.$i] ;
		$t->set_var('itemid',$itemid) ;
		$t->set_var('item_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$item_sl));
		$itemtype = $p['itemtype'.$i] ;
		$description = $p['description'.$i] ;
		$unit = $p['unit'.$i] ;
		$qty = ($itemid<>'' and $p['qty'.$i]=='') ? 1 : $p['qty'.$i] ;
		$discount = $p['discount'.$i] ;
		$cost = $p['cost'.$i] ;
		$tax1_pref = ($p['tax1_pref'.$i] or $posted) ? $p['tax1_pref'.$i] : $tax1pref ;
		$tax2_pref = ($p['tax2_pref'.$i] or $posted) ? $p['tax2_pref'.$i] : $tax2pref ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		if (($tax1_pref=="" or $tax1_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark1',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark1',"");
		if (($tax2_pref=="" or $tax2_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark2',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark2',"");
		$tax1 = $p['tax1'.$i] ;
		$tax2 = $p['tax2'.$i] ;
		$itemid = ($itemid=="") ? 0 : $itemid ;
		if (!$itemtype) {
			$phpgw->db->query("SELECT * FROM service WHERE id='$itemid'");
			if ($phpgw->db->next_record())	$itemtype = "s" ;
			   else {
				$phpgw->db->query("SELECT * FROM parts WHERE id='$itemid'");
				if ($phpgw->db->next_record())	$itemtype = "i" ;
				}
			$description = $description<>'' ? $description : $phpgw->db->f('description');
			$unit = $unit<>'' ? $unit : $phpgw->db->f('unit');
			$cost = $cost<>'' ? $cost : $phpgw->db->f('cost');
			}
		$t->set_var('itemtype',$itemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$unit);
		$t->set_var('qty',$qty);
		$t->set_var('discount',$discount);
		if ($taxstatus=="t" or $posted)	$t->set_var('disc_readonly','readonly');
			else			$t->set_var('disc_readonly','');
		$t->set_var('cost',$cost);
		switch ($tax1_pref) :
			case "v" :	$tax1rate = $vtax1rate ;	break ;
			case "s" :	$tax1rate = $stax1rate ;	break ;
			case "i" :
				$sql = "SELECT rate from itemtax a, tax b " ;
				$sql.= "WHERE item_id='$itemid' and tax_id=id and taxtype='1' and taxgroup='ap'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax1rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax1rate = 0 ;		break ;
			case "m" :	$tax1rate = 0 ;		break ;
			case " " :	$tax1rate = 0 ;		break ;
			case "" :	$tax1rate = 0 ;		break ;
			endswitch ;
		switch ($tax2_pref) :
			case "v" :	$tax2rate = $vtax2rate ;	break ;
			case "s" :	$tax2rate = $stax2rate ;	break ;
			case "i" :
				$sql = "SELECT rate from itemtax a, tax b " ;
				$sql.= "WHERE item_id='$itemid' and tax_id=id and taxtype='2' and taxgroup='ap'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax2rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax2rate = 0 ;		break ;
			case "m" :	$tax2rate = 0 ;		break ;
			case " " :	$tax2rate = 0 ;		break ;
			case "" :	$tax2rate = 0 ;		break ;
			endswitch ;
		switch ($taxstatus) :
			case "f" :
				$t->set_var('btup',$cost);
				$netamount = number_format($qty*$cost-$discount,2,".",'') ;
				$keeptax1 = ($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ") ;
				$keeptax2 = ($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ") ;
				$tax1 = ($keeptax1) ? $tax1 : $netamount*$tax1rate ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $netamount*$tax2rate ;
				$tax2 = number_format($tax2,2,".",'') ;
				$itemtotal = $netamount + $tax1 + $tax2 ;
				break ;
			case "t" :
				$t->set_var('btup','.');
				$t->set_var('discount','');
				$itemtotal = $taxbase = number_format($qty*$cost,2,".",'') ;
				$keeptax1 = ($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ") ;
				$keeptax2 = ($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ") ;
				if ($keeptax1)		$taxbase -= $tax1 ;
				if ($keeptax2)		$taxbase -= $tax2 ;
				$tax1 = ($keeptax1) ? $tax1 : $taxbase*$tax1rate/(1+$tax1rate+$tax2rate) ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $taxbase*$tax2rate/(1+$tax1rate+$tax2rate) ;
				$tax2 = number_format($tax2,2,".",'') ;
				$netamount = $itemtotal - $tax1 - $tax2 ;
				break ;
			case "e" :
				$t->set_var('btup','.');
				$netamount = number_format($qty*$cost-$discount,2,".",'') ;
				$itemtotal = $netamount ;
				$tax1rate = $tax2rate = 0 ;
				$tax1 = $tax2 = 0 ;
				break ;
			endswitch ;
		$sum_tax1 += $tax1 ;
		$sum_tax2 += $tax2 ;
		$sum_itemtotal += $itemtotal ;
		$sum_netamount += $netamount ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		$t->set_var('tax1',$tax1);
		$t->set_var('tax2',$tax2);
		$t->set_var('itemtotal',$itemtotal);
		$t->set_var('netamount',$netamount);
		if ($posted)	$t->set_var('rowno',"done") ;
			else	$t->set_var('rowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);

		$p['itemid'.$i] = $itemid ;
		$p['itemtype'.$i] = $itemtype ;
		$p['description'.$i] = $description ;
		$p['qty'.$i] = $qty ;
		$p['cost'.$i] = $cost ;
		$p['discount'.$i] = $discount ;
		$p['unit'.$i] = $unit ;
		$p['tax1'.$i] = $tax1 ;
		$p['tax2'.$i] = $tax2 ;
		$p['netamount'.$i] = $netamount ;
		}
	$p[amount] = number_format($sum_itemtotal,2,".",'') ;
	$p[netamount] = number_format($sum_netamount,2,".",'') ;
	$t->set_var('lang_totalnet',lang('Total Tax / Net Amount'));
	$t->set_var('lang_totalap',lang('Total Payable'));
	$t->set_var('sum_tax',number_format($sum_tax1+$sum_tax2,2,".",'')) ;
	$t->set_var('sum_netamount',$p[netamount]) ;
	$t->set_var('sum_itemtotal',$p[amount]) ;
	$t->parse('out','report',True);
	}

    }

?>
