<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.addon.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class addon {

//---- Addon Detail Validation Checks

    function addon_validate($ao) {
	global $phpgw ;
	$err=""; $error=lang('Error') ;
	if (!$ao[name] or $ao[name]=="")		$err=lang('AddOn/Discount Name missing');

	if ($ao[factor] and !is_numeric($ao[factor]))	$err=lang('Factor must be numeric');
	if ($ao[factor]<0 and !$ao[minsale])		$err=lang('Min Sale missing');
	if ($ao[factor]>0 and !$ao[maxsale])		$err=lang('Max Sale missing');
	if ($ao[mincount]>$ao[maxcount])		$err=lang('Min count must be <= Max count');
	if ($ao[minsale]>$ao[maxsale])			$err=lang('Min Sale must be <= Max value');
	if ($ao[mincount] and !is_numeric($ao[mincount]))	$err=lang("Min count must be numeric");
	if ($ao[maxcount] and !is_numeric($ao[maxcount]))	$err=lang("Max count must be numeric");
	if ($ao[minsale] and !is_numeric($ao[minsale]))		$err=lang("Min value must be numeric");
	if ($ao[maxsale] and !is_numeric($ao[maxsale]))	$err=lang("Max Sale must be numeric");
	if (input2date($ao[start])=="")			$err=lang('Invalid [Valid from] Date');
	if (input2date($ao[endd])=="")			$err=lang('Invalid [Valid to] Date');
	if (strtotime($ao[start])>strtotime($ao[endd]))	$err=lang('[Valid from] LaterThan [Valid to]');
	if (strtotime($ao[start])=="-1")		$err=lang("[Valid from] beyond valid date range");
	if (strtotime($ao[endd])=="-1")			$err=lang("[Valid to] beyond valid date range");
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Post Addon Detail to Database

    function addon_post($ao, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $ao[id] ;
	$ao[splan_id] = ($ao[splan_id]=="") ? 0 : $ao[splan_id] ;
	
	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO addon(id,name,factor,basis,mincount,maxcount," ;
			$sql.="minsale,maxsale,incacc_id,expacc_id,start,endd,splan_id,notes) " ;
			$sql.="VALUES ('$id','$ao[name]','$ao[factor]','$ao[basis]'," ;
			$sql.="'$ao[mincount]','$ao[maxcount]','$ao[minsale]','$ao[maxsale]'," ;
			$sql.="'$ao[incacc_id]','$ao[expacc_id]','$ao[start]','$ao[endd]','$ao[splan_id]','$ao[notes]')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE addon SET name='$ao[name]',factor='$ao[factor]',basis='$ao[basis]'," ;
			$sql.="mincount='$ao[mincount]',maxcount='$ao[maxcount]',minsale='$ao[minsale]'," ;
			$sql.="maxsale='$ao[maxsale]',incacc_id='$ao[incacc_id]',expacc_id='$ao[expacc_id]'," ;
			$sql.="start='$ao[start]',endd='$ao[endd]',splan_id='$ao[splan_id]',notes='$ao[notes]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM addon WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	if ($op<>'new')		$phpgw->db->query("DELETE FROM itemtax WHERE item_id=$id") ;
	if ($op<>'delete') {
		if ($ao[cstax1]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$ao[cstax1]','1')";
			$phpgw->db->query($sql);
			}
		if ($ao[cstax2]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$ao[cstax2]','2')";
			$phpgw->db->query($sql);
			}
		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("AddOn Charge/Discount") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write AddOn Charge/Discount Detail

    function addon_write(&$t, &$ao) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_splan_id',lang('Sales Promotion ID:')."  ");
	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_factor',lang('Factor (based on Cash Sale Total)'));
	$t->set_var('lang_mincount',lang('Min count per Tran'));
	$t->set_var('lang_maxcount',lang('Max count per Tran'));
	$t->set_var('lang_minsale',lang('Min ($)sale per Tran'));
	$t->set_var('lang_maxsale',lang('Max ($)sale per Tran'));
	$t->set_var('lang_start',lang('Valid from'));
	$t->set_var('lang_endd',lang('Valid to'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_basis',lang('Calculation Basis (g/n)'));
	$t->set_var('lang_linkageaccount',lang("Link to Ledger Accounts and Tax Detail"));
	$t->set_var('lang_income_accno',lang("Income / Tax"));
	$t->set_var('lang_expense_accno',lang("Expense"));
	$t->set_var('lang_cstax1',lang("Primary Tax for the Addon"));
	$t->set_var('lang_cstax2',lang("Secondary Tax for the Addon"));
	$t->set_var('lang_reserved',lang("Reserved Space"));


	$t->set_var('id',$ao[id]);
	$t->set_var('splan_id',$ao[splan_id]);
	$t->set_var('name',$ao[name]);
	$t->set_var('factor',$ao[factor]);
	$t->set_var('mincount',$ao[mincount]);
	$t->set_var('maxcount',$ao[maxcount]);
	$t->set_var('minsale',$ao[minsale]);
	$t->set_var('maxsale',$ao[maxsale]);
	$t->set_var('start',$ao[start]);
	$t->set_var('endd',$ao[endd]);
	$t->set_var('notes',$ao[notes]);
	$basis = $ao[basis] ;
	$basis_sl ="<OPTION value='g'>".lang('g - Gross Cash Sale')."</OPTION><OPTION value='n'>".lang('n - Net Cash Sale')."</OPTION>";
	$basis_sl = str_replace("'$basis'","'$basis'"." selected",$basis_sl) ;
	$t->set_var('basis_option_block',$basis_sl );
	$inc_accno = $ao[incacc_id] ;
	$t->set_var('inc_accno',$inc_accno);
	$t->set_var('inc_acc_option_block', account_selectlist("WHERE link like '%SV_income%' or link like '%CS_tax%'",$inc_accno));
	$exp_accno = $ao[expacc_id] ;
	$t->set_var('exp_accno',$exp_accno);
	$t->set_var('exp_acc_option_block', account_selectlist("WHERE link like '%SV_expense%'",$exp_accno));
	$t->set_var('cstax1_selectlist',tax_selectlist("WHERE taxgroup='cs'",$ao[cstax1]));
	$t->set_var('cstax2_selectlist',tax_selectlist("WHERE taxgroup='cs'",$ao[cstax2]));

	$t->parse('out','report',True);
	}

    }

?>
