<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.cbtran.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class cbtran {

//---- CashBox Transaction Detail Validation Checks

    function cbtran_validate($cbt) {
	global $phpgw ;

	$err="";
	$cboxid = $cbt[cboxid] ;
	$transdate = $cbt[transdate] ;
	$shift = $cbt[shift] ;
	$trantype = $cbt[trantype] ;
	$amount = $cbt[amount] ;
	if (!$cbt[cbtnumber] or $cbt[cbtnumber]=="")	$err=lang('Error: CashBox Transaction Name missing');
	if (input2date($transdate)=="")			$err=lang('Error: Invalid Cash Sale Date');
	if (!$amount or $amount=="")			$err=lang('Error: Transaction Amount missing');
	if (($trantype=="s" or $trantype=="+") and $amount<0)
							$err=lang('Error: s/+ trans must have +ve amount') ;
	if (($trantype=="e" or $trantype=="-") and $amount>0)
							$err=lang('Error: e/- trans must have -ve amount') ;
	$admin = False ;
	$user = trim($phpgw_info["user"]["userid"]);
	$groups = ExecMethod('phpgwapi.accounts.membership',$user) ;
	while (list($key,$value)=each($groups))
		if ($groups["$key"]['account_name']=="Admins")	$admin = True ;
	if (!$admin)					$err=lang('Error: User need to be an [Admins] group user');
	$sql = "SELECT * FROM cbtran WHERE cboxid='$cboxid' and transdate='$transdate' and shift='$shift' and trantype='s'" ;
	$phpgw->db->query($sql) ;
	if ($trantype=='s' and $phpgw->db->num_rows()>0)
		$err=lang("Error: Start-of-shift tran already completed.  If necessary, delete current sos, then reenter.") ;
	if ($trantype<>'s' and $phpgw->db->num_rows()<=0)	$err=lang("Error: Start-of-shift tran pending") ;
	$sql = "SELECT * FROM cbtran WHERE cboxid='$cboxid' and transdate='$transdate' and shift='$shift' and trantype='e'" ;
	$phpgw->db->query($sql) ;
	if ($phpgw->db->num_rows()>0)
		$err=lang("Error: Cashbox closed (end-of-shift completed).  If necessary, delete current eos, then reenter") ;
	$sql = "SELECT max(transdate) as lastdate, max(shift) as lastshift from cbtran where cboxid='$cboxid'" ;
	$phpgw->db->query($sql) ;
	$phpgw->db->next_record() ;
	$lastdate = $phpgw->db->f('lastdate') ;
	$lastshift = $phpgw->db->f('lastshift') ;
	if ($lastdate<>'' and $trantype=='s' and $lastdate<$transdate)	{
		$sql = "SELECT * from cbtran where cboxid='$cboxid' and transdate='$lastdate' and " ;
		$sql.= "shift='$lastshift' and trantype='e'" ;
		$phpgw->db->query($sql) ;
		$sshift = lang("shift") ;
		if (!$phpgw->db->next_record())	$err=lang("Error: Cashbox not closed on")." [$lastdate] $sshift [$lastshift]" ;
		}
	if ($err)	$err = "<b>$err</b>" ;
	return $err ;
	}

//---- Post CashBox Transaction Detail to Database

    function cbtran_post($cbt, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $cbt[id] ;
	$source	= "CBTR" ;
	$cbtnumber = $cbt[cbtnumber] ;
	$desc	= "CB: Cashbox Tran# $cbtnumber";
	$transdate = $cbt[transdate] ;
	$trantype = $cbt[trantype] ;
	$poscac = $cbt[poscashac] ;
	$amount = $cbt[amount] ;
	$negamount = -$cbt[amount] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO cbtran(id,cbtnumber,cboxid,manager,cashier,trantype,transdate,shift,amount) ";
			$sql.="VALUES ('$id','$cbtnumber','$cbt[cboxid]','$cbt[manager]','$cbt[cashier]','$trantype'," ;
			$sql.="'$transdate','$cbt[shift]','$amount')";
			$phpgw->db->query($sql);
			$sql = "INSERT INTO gl(id,source,description,transdate) VALUES('$id','$source','$desc','$transdate')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE cbtran SET cbtnumber='$cbtnumber',cboxid='$cbt[cboxid]',manager='$cbt[manager]',";
			$sql.="cashier='$cbt[cashier]',trantype='$cbt[trantype]',transdate='$transdate'," ;
			$sql.="shift='$cbt[shift]',amount='$amount' WHERE id=$id";
			$phpgw->db->query($sql);
			$sql ="UPDATE gl SET source='$source',description='$desc',transdate='$transdate' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from cbtran where id = $id");
			$phpgw->db->query("DELETE from gl where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	if ($op<>'new')	$phpgw->db->query("DELETE from acc_trans where trans_id='$id'");
	if ($op<>'delete') {
		$sql="INSERT INTO acc_trans(trans_id,chart_id,amount,transdate) VALUES('$id','$poscac','$negamount','$transdate')";
		$phpgw->db->query($sql);
		$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
		$sql.= "VALUES ('$id','$cbt[citac]','$amount','$transdate')" ;
		$phpgw->db->query($sql);
		if ($cbt[trantype]=='e') {
			$netbal = number_format(cashbalance($cbt[cboxid],$transdate,$cbt[shift]),2,".",'') + $amount ;
			$negnetbal = -$netbal ;
			if ($netbal<>0)	{
				$lang_misexp = lang('Miscellaneous Expense') ;
				$phpgw->db->query("SELECT id from chart where lower(description) like lower('%$lang_misexp%')");
				$phpgw->db->next_record() ;
				$misexp = $phpgw->db->f('id') ;
				$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
				$sql.= "VALUES ('$id','$poscac','$netbal','$transdate')" ;
				$phpgw->db->query($sql);
				$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
				$sql.= "VALUES ('$id','$misexp','$negnetbal','$transdate')" ;
				$phpgw->db->query($sql);
				}
			}
		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("CashBox Transaction") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write CashBox Transaction Detail

    function cbtran_write(&$t, &$cbt) {
	global $phpgw ;

	$t->set_var('lang_cbtnumber',lang('CashBox Transaction #:')."  ");
	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_cboxid',lang('Cash Box ID:')."  ");
	$t->set_var('lang_manager',lang('Manager'));
	$t->set_var('lang_cashier',lang('Cashier'));
	$t->set_var('lang_transdate',lang('Cash Sale Date'));
	$t->set_var('lang_shift',lang('Shift'));
	$t->set_var('lang_trantype',lang('Transaction Type'));
	$t->set_var('lang_amount',lang('Transaction Amount'));
	$t->set_var('lang_linkageaccount',lang("Link to Ledger Accounts"));
	$t->set_var('lang_poscashac',lang("Cash at Point of Sale"));
	$t->set_var('lang_citac',lang("Cash in transit"));


	$t->set_var('cbtnumber',$cbt[cbtnumber]) ;
	$t->set_var('id',$cbt[id]);
	$t->set_var('cboxid',$cbt[cboxid]);
	$t->set_var('cboxid_sl',cboxid_selectlist("",$cbt[cboxid]));
	$t->set_var('manager',$cbt[manager]);
	$t->set_var('cashier',$cbt[cashier]);
	$t->set_var('transdate',$cbt[transdate]);
	$t->set_var('shift',$cbt[shift]);
	$t->set_var('shift_sl',shift_selectlist("",$cbt[shift]));
	$t->set_var('trantype',$cbt[trantype]);
	$t->set_var('trantype_sl',trantype_selectlist("",$cbt[trantype]));
	$t->set_var('amount',$cbt[amount]);
	$lang_cashpos = lang('Cash at Point of Sale') ;
	$lang_cashit = lang('Cash in transit') ;
	$t->set_var('poscashac_sl',account_selectlist("WHERE description='$lang_cashpos'",''));
	$t->set_var('citac_sl',account_selectlist("WHERE description='$lang_cashit'",''));

	$t->parse('out','report',True);
	}

    }

?>
