<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.qcash.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class qcash {

//---- Qcash Detail Validation Checks

    function qcash_validate($qc) {
	global $phpgw ;
	$err="";
	if (!$qc[name] or $qc[name]=="")		$err=lang('Error: Quasi-Cash Name missing');
	if ($qc[minsale]>$qc[maxsale])			$err=lang('Error: Min sale must be <= Max sale');
	if ($qc[minqty]>$qc[maxqty])			$err=lang('Error: Min qty must be <= Max qty');
	if ($qc[minvalue]>$qc[maxvalue])		$err=lang('Error: Min value must be <= Max value');
	if ($qc[value] and !is_numeric($qc[value]))	$err=lang("Error: Face value must be numeric");
	if ($qc[minsale] and !is_numeric($qc[minsale]))	$err=lang("Error: Min cash sale must be numeric");
	if ($qc[maxsale] and !is_numeric($qc[maxsale]))	$err=lang("Error: Max cash sale must be numeric");
	if ($qc[minqty] and !is_numeric($qc[minqty]))	$err=lang("Error: Min qty must be numeric");
	if ($qc[maxqty] and !is_numeric($qc[maxqty]))	$err=lang("Error: Max qty must be numeric");
	if ($qc[minvalue] and !is_numeric($qc[minvalue]))	$err=lang("Error: Min value must be numeric");
	if ($qc[maxvalue] and !is_numeric($qc[maxvalue]))	$err=lang("Error: Max value must be numeric");
	if (input2date($qc[start])=="")			$err=lang('Error: Invalid [Valid from] Date');
	if (input2date($qc[endd])=="")			$err=lang('Error: Invalid [Valid to] Date');
	if (strtotime($qc[start])>strtotime($qc[endd]))	$err=lang('Error: [Valid from] LaterThan [Valid to]');
	if (strtotime($qc[start])=="-1")		$err=lang("Error: [Valid from] beyond valid date range");
	if (strtotime($qc[endd])=="-1")			$err=lang("Error: [Valid to] beyond valid date range");
	if ($err)	$err = "<b>$err</b>" ;
	return $err ;
	}

//---- Post Qcash Detail to Database

    function qcash_post($qc, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	
	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $qc[id] ;
	$qc[splan_id] = ($qc[splan_id]=="") ? 0 : $qc[splan_id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO qcash(id,name,value,minsale,maxsale,minqty,maxqty,minvalue,maxvalue," ;
			$sql.=			"start,endd,splan_id,notes,posacc_id) " ;
			$sql.="VALUES ('$id','$qc[name]','$qc[value]','$qc[minsale]','$qc[maxsale]'," ;
			$sql.="'$qc[minqty]','$qc[maxqty]','$qc[minvalue]','$qc[maxvalue]'," ;
			$sql.="'$qc[start]','$qc[endd]','$qc[splan_id]','$qc[notes]','$qc[posacc_id]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE qcash SET name='$qc[name]',value='$qc[value]',minsale='$qc[minsale]'," ;
			$sql.="maxsale='$qc[maxsale]',minqty='$qc[minqty]',maxqty='$qc[maxqty]',";
			$sql.="minvalue='$qc[minvalue]',maxvalue='$qc[maxvalue]',start='$qc[start]',endd='$qc[endd]',";
			$sql.="splan_id='$qc[splan_id]',notes='$qc[notes]',posacc_id='$qc[posacc_id]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM qcash WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Quasi-Cash") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Qcash Detail

    function qcash_write(&$t, &$qc) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_splan_id',lang('Sales Promotion Plan ID:')."  ");
	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_value',lang('Nominal Face Value'));
	$t->set_var('lang_minsale',lang('Min Cash Sale'));
	$t->set_var('lang_maxsale',lang('Max Cash Sale'));
	$t->set_var('lang_minqty',lang('Min Qty per Tran'));
	$t->set_var('lang_maxqty',lang('Max Qty per Tran'));
	$t->set_var('lang_minvalue',lang('Min ($)value per Tran'));
	$t->set_var('lang_maxvalue',lang('Max ($)value per Tran'));
	$t->set_var('lang_start',lang('Valid from:'));
	$t->set_var('lang_endd',lang('Valid to:'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_linkageaccount',lang("Link to Ledger Accounts"));
	$t->set_var('lang_pos_accno',lang("POS - Quasi Cash"));

	$t->set_var('id',$qc[id]);
	$t->set_var('splan_id',$qc[splan_id]);
	$t->set_var('name',$qc[name]);
	$t->set_var('value',$qc[value]);
	$t->set_var('minsale',$qc[minsale]);
	$t->set_var('maxsale',$qc[maxsale]);
	$t->set_var('minqty',$qc[minqty]);
	$t->set_var('maxqty',$qc[maxqty]);
	$t->set_var('minvalue',$qc[minvalue]);
	$t->set_var('maxvalue',$qc[maxvalue]);
	$t->set_var('start',$qc[start]);
	$t->set_var('endd',$qc[endd]);
	$t->set_var('notes',$qc[notes]);
	$pos_accno = $qc[posacc_id] ;
	$t->set_var('pos_accno',$pos_accno);
	$posacsl = account_selectlist("WHERE link like '%CS:%' or link like '%CS'",$pos_accno);
	$t->set_var('pos_acc_option_block', "<OPTION value=''>".lang('N/A')."</OPTION>".$posacsl);
	$t->parse('out','report',True);
	}

    }

?>
