<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.sprice.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class sprice {

//---- Special Price Detail Validation Checks

    function sprice_validate($s) {
	global $phpgw ;
	$err="";
	if (!$s[name] or $s[name]=="")			$err=lang("Error: Special Price Name missing");
	if (!$s[price] or $s[price]=="")		$err=lang("Error: Price missing");
	if ($s[price] and !is_numeric($s[price]))	$err=lang("Error: Price must be numeric");
	if (input2date($s[start])=="")			$err=lang("Error: Invalid [Valid from] Date");
	if (input2date($s[endd])=="")			$err=lang("Error: Invalid [Valid to] Date");
	if (strtotime($s[start])>strtotime($s[endd]))	$err=lang("Error: [Valid from] LaterThan [Valid to]");
	if (strtotime($s[start])=="-1")			$err=lang("Error: [Valid from] beyond valid date range");
	if (strtotime($s[endd])=="-1")			$err=lang("Error: [Valid to] beyond valid date range");
	if ($err)	$err = "<b>$err</b>" ;
	return $err ;
	}

//---- Post Special Price Detail to Database

    function sprice_post($s, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $s[id] ;
	$s[splan_id] = ($s[splan_id]=="") ? 0 : $s[splan_id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO sprice(id,name,itemid,price,start,endd,splan_id,notes) " ;
			$sql.="VALUES ('$id','$s[name]','$s[itemid]','$s[price]','$s[start]','$s[endd]','$s[splan_id]','$s[notes]')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE sprice SET name='$s[name]',itemid='$s[itemid]',price='$s[price]'," ;
			$sql.="start='$s[start]',endd='$s[endd]',splan_id='$s[splan_id]',notes='$s[notes]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM sprice WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Special Price") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Special Price Detail

    function sprice_write(&$t, &$s) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_splan_id',lang('Sales Promotion ID:')."  ");
	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_price',lang('Special Price'));
	$t->set_var('lang_itemid',lang('ID of normally priced item'));
	$t->set_var('lang_start',lang('Valid from'));
	$t->set_var('lang_endd',lang('Valid to'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('id',$s[id]);
	$t->set_var('splan_id',$s[splan_id]);
	$t->set_var('name',$s[name]);
	$t->set_var('price',$s[price]);
	$t->set_var('itemid',$s[itemid]);
	$t->set_var('start',$s[start]);
	$t->set_var('endd',$s[endd]);
	$itemid = $s[itemid] ;
	$t->set_var('itemid_sl',item_selectlist("","$itemid"));
	$t->set_var('notes',$s[notes]);
	$t->parse('out','report',True);
	}

    }

?>
