<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.service.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

	class service {

//---- Service Detail Validation Checks

    function service_validate($s) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	if ($s[servicenumber]=="")				$err=lang("Service Name/Number Missing");
	if ($s[listprice] and !is_numeric($s[listprice]))	$err=lang("Invalid list price, must be numeric");
	if ($s[sellprice] and !is_numeric($s[sellprice]))	$err=lang("Invalid selling price, must be numeric");
	if ($s[cost] and !is_numeric($s[cost]))			$err=lang("Invalid Cost, must be numeric") ;
	if ($s[listprice] and $s[sellprice] and ($s[listprice]<$s[sellprice]))
								$err=lang("List Price < Selling Price") ;
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Service Detail to Database

    function service_post($s, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $s[id] ;
	$pricedate = ($s[oldprice]<>$s[sellprice]) ? date("Y-m-d") : $s[priceupdate] ;
	$costdate = ($s[oldcost]<>$s[cost]) ? date("Y-m-d") : $s[costupdate] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql ="INSERT INTO service(id,servicenumber,description,unit,listprice,sellprice,cost,";
			$sql.="income_accno_id,expense_accno_id,notes) VALUES " ;
			$sql.="('$id','$s[servicenumber]','$s[description]','$s[unit]','$s[listprice]','$s[sellprice]'," ;
			$sql.="'$s[cost]','$s[income_accno_id]','$s[expense_accno_id]','$s[notes]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE service SET servicenumber='$s[servicenumber]',description='$s[description]',";
			$sql.="unit='$s[unit]',listprice='$s[listprice]',sellprice='$s[sellprice]'," ;
			$sql.="priceupdate='$pricedate',cost='$s[cost]',costupdate='$costdate',notes='$s[notes]'," ;
			$sql.="income_accno_id='$s[income_accno_id]',expense_accno_id='$s[expense_accno_id]' " ;
			$sql.="WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from service where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE FROM itemtax WHERE item_id=$id") ;
	if ($op<>'delete') {
		if ($s[aptax1]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$s[aptax1]','1')";
			$phpgw->db->query($sql);
			}
		if ($s[aptax2]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$s[aptax2]','2')";
			$phpgw->db->query($sql);
			}
		if ($s[artax1]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$s[artax1]','1')";
			$phpgw->db->query($sql);
			}
		if ($s[artax2]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$s[artax2]','2')";
			$phpgw->db->query($sql);
			}
		if ($s[cstax1]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$s[cstax1]','1')";
			$phpgw->db->query($sql);
			}
		if ($s[cstax2]<>"") {
			$sql="INSERT INTO itemtax(item_id,tax_id,taxtype) VALUES('$id','$s[cstax2]','2')";
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Service") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Service Detail

    function service_write(&$t, $s) {
	global $phpgw ;

	$t->set_var('lang_tbi',lang("(To be implemented)"));
	$t->set_var('lang_ginfo',lang("General Information"));
	$t->set_var('lang_number',lang("Name/Number"));
	$t->set_var('lang_description',lang("Description"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_quantity',lang("Quantity"));
	$t->set_var('lang_unit',lang("Unit"));
	$t->set_var('lang_pricecost',lang("Price/Cost"));
	$t->set_var('lang_listprice',lang("List Price"));
	$t->set_var('lang_sellprice',lang("Selling Price"));
	$t->set_var('lang_priceupdate',lang("Price Last Updated on"));
	$t->set_var('lang_cost',lang("Standard Cost"));
	$t->set_var('lang_costupdate',lang("Cost Last Updated on"));
	$t->set_var('lang_notes',lang("Notes"));
	$t->set_var('lang_linkageaccount',lang("Link to Ledger Accounts"));
	$t->set_var('lang_income_accno',lang("Income"));
	$t->set_var('lang_expense_accno',lang("Expense"));
	$t->set_var('lang_aptax1',lang("Primary Tax Paid to Vendor"));
	$t->set_var('lang_aptax2',lang("Secondary Tax Paid to Vendor"));
	$t->set_var('lang_artax1',lang("Primary Tax from Customer"));
	$t->set_var('lang_artax2',lang("Secondary Tax from Customer"));
	$t->set_var('lang_cstax1',lang("Primary Tax for Cash Sale"));
	$t->set_var('lang_cstax2',lang("Secondary Tax for Cash Sale"));
	$t->set_var('lang_reserved',lang("Reserved Space")) ;

	$t->set_var('servicenumber',$s[servicenumber]);
	$t->set_var('id',$s[id]);
	$t->set_var('description',$s[description]);
	$t->set_var('notes',$s[notes]);
	$t->set_var('unit',$s[unit]);
	$t->set_var('listprice',$s[listprice]);
	$t->set_var('sellprice',$s[sellprice]);
	$t->set_var('oldprice',$s[oldprice]);
	$t->set_var('priceupdate',$s[priceupdate]);
	$t->set_var('cost',$s[cost]);
	$t->set_var('oldcost',$s[oldcost]);
	$t->set_var('costupdate',$s[costupdate]);
	$inc_accno = $s[income_accno_id] ;
	$t->set_var('income_accno',$inc_accno);
	$t->set_var('inc_acc_option_block', account_selectlist("WHERE link like '%SV_income%'",$inc_accno));
	$exp_accno = $s[expense_accno_id] ;
	$t->set_var('expense_accno',$exp_accno);
	$t->set_var('exp_acc_option_block',account_selectlist("WHERE link like '%SV_expense%'",$exp_accno));
	$t->set_var('aptax1_selectlist',tax_selectlist("WHERE taxgroup='ap'",$s[aptax1]));
	$t->set_var('aptax2_selectlist',tax_selectlist("WHERE taxgroup='ap'",$s[aptax2]));
	$t->set_var('artax1_selectlist',tax_selectlist("WHERE taxgroup='ar'",$s[artax1]));
	$t->set_var('artax2_selectlist',tax_selectlist("WHERE taxgroup='ar'",$s[artax2]));
	$t->set_var('cstax1_selectlist',tax_selectlist("WHERE taxgroup='cs'",$s[cstax1]));
	$t->set_var('cstax2_selectlist',tax_selectlist("WHERE taxgroup='cs'",$s[cstax2]));

	$t->parse('out','report',True);
	}

    }

?>
