<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: functions.inc.php,v 0.0.5 2002/02/11 C K Wu $ */


// This is loaded by default

    function init() {
	}

//---- Set Up Account Number Select Option List

    function account_selectlist($filter,$default) {
	global $phpgw ;

	$sql="SELECT id,accno,description FROM chart $filter ORDER BY accno" ;
	$phpgw->db->query($sql);
	$selectlist="";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id');
		$accno = $phpgw->db->f('accno');
		$description = $phpgw->db->f('description');
		$selectlist .= "<OPTION value='$id'>$accno -- $description</OPTION>" ;
		}
	$selectlist = str_replace("'$default'","'$default'"." selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Tax/Number Select Option List

    function tax_selectlist($filter,$default) {
	global $phpgw ;

	$notax = lang('No Tax') ;
	$phpgw->db->query("SELECT * FROM tax $filter ORDER BY taxnumber");
	$selectlist = "<OPTION value=''>$notax</OPTION>" ;
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$rate = $phpgw->db->f('rate')*100;
		$taxnumber = $phpgw->db->f('taxnumber');
		$selectlist .= "<OPTION value='$id'>$rate% $taxnumber -- $id</OPTION>" ;
		} 
	$selectlist = str_replace("'$default'","'$default'"." selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Item Code Select Option List

    function item_selectlist($filter,$default) {
	global $phpgw ;

	$phpgw->db->query("SELECT id,servicenumber,description FROM service $filter ORDER BY servicenumber");
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$servicenumber = $phpgw->db->f('servicenumber');
		$desc = $phpgw->db->f('description') ;
		$selectlist .= "<OPTION value='$id'>$servicenumber -- $desc -- $id</OPTION>" ;
		}
	$phpgw->db->query("SELECT id,partnumber,description FROM parts $filter ORDER BY partnumber");
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$partnumber = $phpgw->db->f('partnumber');
		$desc = $phpgw->db->f('description') ;
		$selectlist .= "<OPTION value='$id'>$partnumber -- $desc -- $id</OPTION>" ;
		}
	if ($default<>"") $selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Service Select Option List

    function service_selectlist($filter,$default) {
	global $phpgw ;

	$phpgw->db->query("SELECT * FROM service $filter ORDER BY servicenumber");
	$selectlist = "" ;
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id');
		$servicenumber = $phpgw->db->f('servicenumber');
		$description = $phpgw->db->f('description');
		$selectlist .= "<OPTION value='$id'>$servicenumber -- $description -- $id</OPTION>" ;
		}
	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- This function, input2date($idate), is made to check date-input from an HTML-form
 //--- and bring it to the YYYY-MM-DD format that it can be
 //--- insertet in a Date-Field of a MySQL-Table.
 //
 //--- Input-Formats can be:
 //--- "d.m.y" or "y.m.d" or "d.m" or "d"
 //--- if year or month and year are missing, these values are
 //--- taken from the current date.
 //
 //--- When the result-String is empty, the date-input was wrong.
 //
 //--- Usage: $date_ok = input2date($date_from_form_field);
 //

 function input2date($idate)
 {
   $token= "-./ ";

   $p1 = strtok($idate,$token);
   $p2 = strtok($token);
   $p3 = strtok($token);
   $p4 = strtok($token);

   $date= "";
   $y= ""; $m= ""; $d= "";

    // check 'd.m.y'
   if (($p1>0 && $p1<32) &&
       ($p2>0 && $p2<13) &&
       ($p3>32))
   {
     $y=$p3;
     $m=$p2;
     $d=$p1;
   }

    // check 'y.m.d'
   if ($y ==  "" &&
       ($p1>32) &&
       ($p2>0 && $p2<13) &&
       ($p3>0 && $p3<32))
   {
     $y=$p1;
     $m=$p2;
     $d=$p3;
   }

    // check 'd.m'
   if ($y ==  "" &&
       ($p3== "") &&
       ($p2>0 && $p2<13) &&
       ($p1>0 && $p1<32))
   {
     $y=date( "Y");
     $m=$p2;
     $d=$p1;
   }

    // check 'd'
   if ($y ==  "" &&
       ($p3== "") &&
       ($p2== "") &&
       ($p1>0 && $p1<32))
   {
     $y=date( "Y");
     $m=date( "m");
     $d=$p1;
   }

    // add 1900 or 2000 to year
   if ($y!= "" && $y<=99)
   {
     if ($y>=70) $y = $y + 1900;
     if ($y<70) $y = $y + 2000;
   }

   if ($y!= "")
   {
     if (checkdate($m, $d, $y))
       $date= "$y-$m-$d";
   }

   return $date;
 }

    init();

?>
