<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.so.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class so {

//---- SO Detail Validation Checks

    function so_validate($s) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	$row = lang("Row") ;
	if ($s[sonumber]=="")			$err=lang('Sales Order Number Missing');
	if (input2date($s[transdate])=="")	$err=lang('Invalid Sales Order Date');
	if (input2date($s[duedate])=="")	$err=lang('Invalid Due Date');
	For ($i=1;isset($s['itemid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		if ($s['itemid'.$i]=='')	$err=$rowi.lang("Item Code Missing");
		if ($s['qty'.$i] and !is_numeric($s['qty'.$i]))
						$err=$rowi.lang("Invalid Qty, must be numeric");
		if ($s['discount'.$i] and !is_numeric($s['discount'.$i]) and $s[taxstatus]<>"t")
						$err=$rowi.lang("Invalid Discount, must be numeric");
		if ($s['sellprice'.$i] and !is_numeric($s['sellprice'.$i]))
						$err=$rowi.lang("Invalid Unit Price, must be numeric");
		if ($s['tax1'.$i] and !is_numeric($s['tax1'.$i]))
						$err=$rowi.lang("Invalid Tax1, must be numeric");
		if ($s['tax2'.$i] and !is_numeric($s['tax2'.$i]))
						$err=$rowi.lang("Invalid Tax2, must be numeric");
		if (($s[taxstatus]=="f" or $s[taxstatus]=="t") and $s['tax1_pref'.$i]=='')
						$err=$rowi.lang("Blank Choice on Primary Tax Rate");
		if (($s[taxstatus]=="f" or $s[taxstatus]=="t") and $s['tax2_pref'.$i]=='')
						$err=$rowi.lang("Blank Choice on Secondary Tax Rate");
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Post Sales Order to Database

    function so_post($s, &$t, &$id, $op, $script, $quote) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $s[id] ;
	if ($quote)	$quoteid = $id ;
	$transdate = $s[transdate] ;
	$taxstatus = $s[taxstatus] ;
	$amount = $s[amount] ;
	$netamount = $s[netamount] ;
	if ($s[taxstatus]=="e")		{$taxstatus = "f" ;	$netamount = $amount ;	}

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO so (id,sonumber,transdate,customer,taxincluded,amount,netamount,duedate,shipfrom,notes) ";
			$sql.= "VALUES ('$id','$s[sonumber]','$transdate','$s[customer]','$taxstatus','$amount','$netamount'," ;
			$sql.= "'$s[duedate]','$s[shipfrom]','$s[notes]')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE so SET sonumber='$s[sonumber]',transdate='$transdate',customer='$s[customer]',";
			$sql.= "taxincluded='$taxstatus',amount='$amount',netamount='$netamount',";
			$sql.= "duedate='$s[duedate]',shipfrom='$s[shipfrom]',notes='$s[notes]' ";
			$sql.= "WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM so WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	if ($op<>'new')		$phpgw->db->query("DELETE FROM oitem WHERE trans_id=$id") ;
	if ($op<>'delete') {
		For ($i=1;isset($s['itemid'.$i]);$i++) {
			$itemid		= $s['itemid'.$i];
			$itemtype	= $s['itemtype'.$i];
			$desc		= $s['description'.$i];
			$unit		= $s['unit'.$i];
			$qty		= $s['qty'.$i];
			$sellprice	= $s['sellprice'.$i];
			$discount	= $s['discount'.$i];
			$tax1		= number_format($s['tax1'.$i],2,".",'');
			$tax2		= number_format($s['tax2'.$i],2,".",'');
			$sql = "INSERT INTO oitem (trans_id,itemid,itemtype,description,qty,sellprice,discount,tax1,tax2,unit) " ;
			$sql.= "VALUES ('$id','$itemid','$itemtype','$desc','$qty','$sellprice','$discount','$tax1','$tax2','$unit')";
			$phpgw->db->query($sql);
			}
		}
	if ($quote) $phpgw->db->query("UPDATE quote SET so_id='$id' WHERE id='$quoteid'") ;
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("SO") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write SO Header

    function so_header_write(&$t, $s, $taxscript) {
	global $phpgw ;

	$taxstatus = $s[taxstatus] ;
	$t->set_var('lang_sonumber',lang('SO#'));
	$t->set_var('lang_id',lang('Audit Id:')." ");
	$t->set_var('lang_transdate',lang('SO Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_shipfrom',lang('Ship From'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_customer',lang('Customer'));
	$t->set_var('lang_taxstatus',lang('Unit Price Tax Status'));
	$t->set_var('lang_totalamt',lang('Total SO Amount'));
	$t->set_var('sonumber',$s[sonumber]) ;
	$t->set_var('shipfrom',$s[shipfrom]) ;
	$t->set_var('transdate',$s[transdate]) ;
	$t->set_var('duedate',$s[duedate]) ;
	$t->set_var('notes',$s[notes]);
	$customer = $s[customer] ;
	$t->set_var('customer',$customer) ;
	$t->set_var('customer_selectlist',customer_selectlist('',$customer)) ;
	if ($taxscript=="nt")	$tax_sl = "<OPTION value='e' selected>".lang('Tax Exempted')."</OPTION>" ;
	    else {
		$tax_sl = "<OPTION value='t'>".lang('Tax Included')."</OPTION>" ;
		$tax_sl.= "<OPTION value='f'>".lang('Tax Not Included')."</OPTION>" ;
		$tax_sl.= "<OPTION value='e'>".lang('Tax Exempted')."</OPTION>" ;
		$tax_sl = str_replace("'$taxstatus'","'$taxstatus' selected",$tax_sl) ;
		}
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->set_var('id',$s[id]) ;
	$t->parse('out','report',True);
	}

//---- Reformat Sales Order Array

    function so_transform(&$s,$newrow,$delete) {
	global $phpgw ;

	$row_ = lang('Row') ;
	$temp[id] = $s[id] ;
	$temp[customer] = $s[customer] ;
	$temp[transdate] = $s[transdate] ;
	$temp[duedate] = $s[duedate] ;
	$temp[sonumber] = $s[sonumber] ;
	$temp[ordnumber] = $s[ordnumber] ;
	$temp[taxstatus] = $s[taxstatus] ;
	$temp[shipfrom] = $s[shipfrom] ;
	$temp[notes] = $s[notes] ;

	if (isset($delete)) {$delrowno = intval(str_replace($row_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($s['itemid'.$i]);$i++) {
		$itemid = $s['itemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($itemid<0)	{
			$itemid = -$itemid ;
			$qty = $s['qty'.$i]==0 ? 1 : $s['qty'.$i] ;
			$phpgw->db->query("SELECT * FROM assembly WHERE assembly_id='$itemid'");
			while ($phpgw->db->next_record()) {
				$temp['itemid'.$j] = $phpgw->db->f('item_id') ;
				$temp['qty'.$j] = $phpgw->db->f('qty') * $qty ;
				$j++ ;
				}
			continue ;
			}
		$temp['itemid'.$j]		=	$s['itemid'.$i] ;
		$temp['itemtype'.$j]		=	$s['itemtype'.$i] ;
		$temp['description'.$j]		=	$s['description'.$i] ;
		$temp['qty'.$j]			=	$s['qty'.$i] ;
		$temp['unit'.$j]		=	$s['unit'.$i] ;
		$temp['sellprice'.$j]		=	$s['sellprice'.$i] ;
		$temp['discount'.$j]		=	$s['discount'.$i] ;
		$temp['tax1_pref'.$j]		=	$s['tax1_pref'.$i] ;
		$temp['tax2_pref'.$j]		=	$s['tax2_pref'.$i] ;
		$temp['tax1'.$j]		=	$s['tax1'.$i] ;
		$temp['tax2'.$j]		=	$s['tax2'.$i] ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=True ;
	if ($newrow)					$temp['itemid'.$j] = "" ;
	$s = $temp ;
	unset($temp) ;
	}

//---- Write SO Detail

    function so_detail_write(&$t,&$s,$posted,$firstime) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$taxstatus = $s[taxstatus] ;
	$tax_warning = lang("***** Choice Pending") ;
	if ($taxstatus<>'e') {
		$tax_pref_slist = "<OPTION value=''></OPTION>" ;
		$tax_pref_slist.= "<OPTION value='i'>".lang('apply item tax rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='c'>".lang('apply customer rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='s'>".lang('apply my std rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='z'>".lang('tax rate = zero')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='m'>".lang('manual tax input')."</OPTION>" ;
		$customer = ($s[customer]=="") ? 0 : $s[customer] ;
		$sql = "SELECT customer_id,rate from customertax a, tax b " ;
		$sql.= "WHERE customer_id='$customer' and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$ctax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT customer_id,rate from customertax a, tax b " ;
		$sql.= "WHERE customer_id='$customer' and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$ctax2rate = $phpgw->db->f(rate) ;
		$sql = "SELECT customer_id,rate from customertax a, tax b, customer c " ;
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT customer_id,rate from customertax a, tax b, customer c " ;
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax2rate = $phpgw->db->f(rate) ;
		}
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_number',lang('Item Code -- Id<br>(Inventory/Service)'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_btup',lang('BTUP'));
	$t->set_var('lang_discount',lang('Discount<br>$'));
	$t->set_var('lang_tax',lang('Tax'));
	$phpgw->db->query("SELECT artax1cap,artax2cap,artax1pref,artax2pref FROM defaults");
	$phpgw->db->next_record() ;
	$t->set_var('lang_tax1',$phpgw->db->f(artax1cap));
	$t->set_var('lang_tax2',$phpgw->db->f(artax2cap));
	$tax1pref = $phpgw->db->f(artax1pref) ;
	$tax2pref = $phpgw->db->f(artax2pref) ;
	$t->set_var('lang_sellprice',lang('Unit<br>Price'));
	$t->set_var('lang_itemtotal',lang('Item Total'));
	$t->set_var('lang_netamount',lang('Net of Tax'));
	$t->set_var('lang_delete',lang('Delete<br>Button'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$item_sl = item_selectlist("",'') ;
	$sum_tax1 = $sum_tax2 = $sum_itemtotal = $sum_netamount = 0 ;
	For ($i=1;isset($s['itemid'.$i]);$i++) {
		$t->set_var('itemid_fld','itemid'.$i) ;
		$t->set_var('itemtype_fld','itemtype'.$i) ;
		$t->set_var('description_fld','description'.$i);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('unit_fld','unit'.$i);
		$t->set_var('discount_fld','discount'.$i);
		$t->set_var('sellprice_fld','sellprice'.$i);
		$t->set_var('tax1_pref_fld','tax1_pref'.$i);
		$t->set_var('tax2_pref_fld','tax2_pref'.$i);
		$t->set_var('tax1_fld','tax1'.$i);
		$t->set_var('tax2_fld','tax2'.$i);
		$itemid = $s['itemid'.$i] ;
		$t->set_var('itemid',$itemid) ;
		$t->set_var('item_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$item_sl));
		$itemtype = $s['itemtype'.$i] ;
		$description = $s['description'.$i] ;
		$unit = $s['unit'.$i] ;
		$qty = ($itemid<>'' and $s['qty'.$i]=='') ? 1 : $s['qty'.$i] ;
		$discount = $s['discount'.$i] ;
		$sellprice = $s['sellprice'.$i] ;
		$tax1_pref = ($s['tax1_pref'.$i] or $posted) ? $s['tax1_pref'.$i] : $tax1pref ;
		$tax2_pref = ($s['tax2_pref'.$i] or $posted) ? $s['tax2_pref'.$i] : $tax2pref ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		if (($tax1_pref=="" or $tax1_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark1',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark1',"");
		if (($tax2_pref=="" or $tax2_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark2',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark2',"");
		$tax1 = $s['tax1'.$i] ;
		$tax2 = $s['tax2'.$i] ;
		$itemid = ($itemid=="") ? 0 : $itemid ;
		if (!$itemtype) {
			$phpgw->db->query("SELECT * FROM service WHERE id='$itemid'");
			if ($phpgw->db->next_record())	$itemtype = "s" ;
			   else {
				$phpgw->db->query("SELECT * FROM parts WHERE id='$itemid'");
				if ($phpgw->db->next_record())	$itemtype = "i" ;
				}
			$description = $description<>'' ? $description : $phpgw->db->f('description');
			$unit = $unit<>'' ? $unit : $phpgw->db->f('unit');
			$sellprice = $sellprice<>'' ? $sellprice : $phpgw->db->f('sellprice');
			}
		$t->set_var('itemtype',$itemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$unit);
		$t->set_var('qty',$qty);
		$t->set_var('discount',$discount);
		if ($taxstatus=="t" or $posted)	$t->set_var('disc_readonly','readonly');
			else			$t->set_var('disc_readonly','');
		$t->set_var('sellprice',$sellprice);
		switch ($tax1_pref) :
			case "c" :	$tax1rate = $ctax1rate ;	break ;
			case "s" :	$tax1rate = $stax1rate ;	break ;
			case "i" :
				$sql = "SELECT rate from itemtax a, tax b " ;
				$sql.="WHERE item_id='$itemid' and tax_id=id and taxtype='1' and taxgroup='ar'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax1rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax1rate = 0 ;		break ;
			case "m" :	$tax1rate = 0 ;		break ;
			case " " :	$tax1rate = 0 ;		break ;
			case "" :	$tax1rate = 0 ;		break ;
			endswitch ;
		switch ($tax2_pref) :
			case "c" :	$tax2rate = $ctax2rate ;	break ;
			case "s" :	$tax2rate = $stax2rate ;	break ;
			case "i" :
				$sql = "SELECT rate from itemtax a, tax b " ;
				$sql.="WHERE item_id='$itemid' and tax_id=id and taxtype='2' and taxgroup='ar'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax2rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax2rate = 0 ;		break ;
			case "m" :	$tax2rate = 0 ;		break ;
			case " " :	$tax2rate = 0 ;		break ;
			case "" :	$tax2rate = 0 ;		break ;
			endswitch ;
		switch ($taxstatus) :
			case "f" :
				$t->set_var('btup',$sellprice);
				$netamount = number_format($qty*$sellprice-$discount,2,".",'') ;
				$keeptax1 = ($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ") ;
				$keeptax2 = ($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ") ;
				$tax1 = ($keeptax1) ? $tax1 : $netamount*$tax1rate ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $netamount*$tax2rate ;
				$tax2 = number_format($tax2,2,".",'') ;
				$itemtotal = $netamount + $tax1 + $tax2 ;
				break ;
			case "t" :
				$t->set_var('btup','.');
				$t->set_var('discount','');
				$itemtotal = $taxbase = number_format($qty*$sellprice,2,".",'') ;
				$keeptax1 = ($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ") ;
				$keeptax2 = ($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ") ;
				if ($keeptax1)		$taxbase -= $tax1 ;
				if ($keeptax2)		$taxbase -= $tax2 ;
				$tax1 = ($keeptax1) ? $tax1 : $taxbase*$tax1rate/(1+$tax1rate+$tax2rate) ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $taxbase*$tax2rate/(1+$tax1rate+$tax2rate) ;
				$tax2 = number_format($tax2,2,".",'') ;
				$netamount = $itemtotal - $tax1 - $tax2 ;
				break ;
			case "e" :
				$t->set_var('btup','.');
				$netamount = number_format($qty*$sellprice-$discount,2,".",'') ;
				$itemtotal = $netamount ;
				$tax1rate = $tax2rate = 0 ;
				$tax1 = $tax2 = 0 ;
				break ;
			endswitch ;
		$sum_tax1 += $tax1 ;
		$sum_tax2 += $tax2 ;
		$sum_itemtotal += $itemtotal ;
		$sum_netamount += $netamount ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		$t->set_var('tax1',$tax1);
		$t->set_var('tax2',$tax2);
		$t->set_var('itemtotal',$itemtotal);
		$t->set_var('netamount',$netamount);
		if ($posted)	$t->set_var('rowno',"done") ;
			else	$t->set_var('rowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		
		$s['itemid'.$i] = $itemid ;
		$s['itemtype'.$i] = $itemtype ;
		$s['description'.$i] = $description ;
		$s['qty'.$i] = $qty ;
		$s['sellprice'.$i] = $sellprice ;
		$s['discount'.$i] = $discount ;
		$s['unit'.$i] = $unit ;
		$s['tax1'.$i] = $tax1 ;
		$s['tax2'.$i] = $tax2 ;
		$s['netamount'.$i] = $netamount ;
		}

	$s[amount] = number_format($sum_itemtotal,2,".",'') ;
	$s[netamount] = number_format($sum_netamount,2,".",'') ;
	$t->set_var('lang_totalnet',lang('Total Tax / Net Amount'));
	$t->set_var('lang_totalap',lang('Total Payable'));
	$t->set_var('sum_tax',number_format($sum_tax1+$sum_tax2,2,".",'')) ;
	$t->set_var('sum_netamount',$s[netamount]) ;
	$t->set_var('sum_itemtotal',$s[amount]) ;
	$t->parse('out','report',True);
	}

    }

?>
