<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.address.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class address {

//---- Address Validation Checks

    function address_validate($a) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	$lang_address = lang('address') ;
	$hd=$hi=$pa=$po = "" ;
	$row = lang("Row") ;
	For ($i=1;isset($a['addresscode'.$i]);$i++) {
		if ($a['line1'.$i]=='' and $a['line2'.$i]=='' and $a['line3'.$i]=='' and $a['line4'.$i]=='')
						$err="[$row $i]".lang("Blank address") ;
		$addresscode = $a['addresscode'.$i] ;
		$phpgw->db->query("SELECT name FROM hrcode where type='$lang_address' and name='$addresscode'");
		$phpgw->db->next_record() ;
		switch ($phpgw->db->f('name')) :
			case "HD" :	if ($hd<>"") $err="[$row $i]".lang("Duplicate HD address") ;	$hd = "HD" ;	break ;
			case "HI" :	if ($hi<>"") $err="[$row $i]".lang("Duplicate HI address") ;	$hi = "HI" ;	break ;
			case "PA" :	if ($pa<>"") $err="[$row $i]".lang("Duplicate PA address") ;	$pa = "PA" ;	break ;
			case "PO" :	if ($po<>"") $err="[$row $i]".lang("Duplicate PO address") ;	$po = "PO" ;	break ;
			endswitch ;
		}
	if ($i>1 and $hd=="")			$err = lang("HD address missing") ;
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Address to Database

    function address_post($a, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $a[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :						break ;
		case "edit" :	$actioned = lang("updated") ;		break ;
		case "delete" :						break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE from address where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($a['addresscode'.$i]);$i++) {
			$line1 = $a['line1'.$i] ;
			$line2 = $a['line2'.$i] ;
			$line3 = $a['line3'.$i] ;
			$line4 = $a['line4'.$i] ;
			$addresscode = $a['addresscode'.$i] ;
			$region = $a['region'.$i] ;
			$country = $a['country'.$i] ;
			$zip = $a['zip'.$i] ;
			$sql = "INSERT INTO address(empid,line1,line2,line3,line4,addresscode,region,country,zip) " ;
			$sql.= "VALUES('$id','$line1','$line2','$line3','$line4','$addresscode','$region','$country','$zip')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Address for Employee") ;
	$t->set_var("message","<b>$tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Address Header

    function address_header_write(&$t, $a) {
	global $phpgw ;

	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$a[name]) ;
	$t->set_var('id',$a[id]) ;
	$t->parse('out','report',True);
	}

//---- Write Address Detail

    function address_detail_write(&$t, $a, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$id = $a[id] ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_address',lang('Address (Addr) Line1, Line2, Line3, Line4'));
	$t->set_var('lang_codetype',lang("Type of Code") );
	$t->set_var('lang_codedesc',lang("Code -- Description") );
	$t->set_var('lang_addresscode',lang('AddrType:'));
	$t->set_var('lang_region',lang('Region:'));
	$t->set_var('lang_country',lang('Country:'));
	$t->set_var('lang_zip',lang('Zip:'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_reserved',lang('Reserved Space'));
	$lang_address = lang('address') ;
	$lang_region = lang('region') ;
	$lang_country = lang('country') ;
	$lang_zip = lang('zip') ;

	$blankopt = "<OPTION value=''></OPTION>" ;
	$addresscode_sl = hrcodename_selectlist("WHERE type='$lang_address'",'',"long") ;
	$region_sl = "<OPTION value=''></OPTION>".hrcodename_selectlist("WHERE type='$lang_region'",'',"long") ;
	$country_sl = hrcodename_selectlist("WHERE type='$lang_country'",'',"long") ;
	$zip_sl = "<OPTION value=''></OPTION>".hrcodename_selectlist("WHERE type='$lang_zip'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($a['addresscode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('line1_fld','line1'.$i);
			$t->set_var('line2_fld','line2'.$i);
			$t->set_var('line3_fld','line3'.$i);
			$t->set_var('line4_fld','line4'.$i);
			$t->set_var('addresscode_fld','addresscode'.$i) ;
			$t->set_var('region_fld','region'.$i) ;
			$t->set_var('country_fld','country'.$i) ;
			$t->set_var('zip_fld','zip'.$i) ;
			$t->set_var('line1','') ;
			$t->set_var('line2','') ;
			$t->set_var('line3','') ;
			$t->set_var('line4','') ;
			$t->set_var('addresscode_selectlist',$addresscode_sl) ;
			$t->set_var('region_selectlist',$region_sl) ;
			$t->set_var('country_selectlist',$country_sl) ;
			$t->set_var('zip_selectlist',$zip_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$addresscode	= $a['addresscode'.$i] ;
		$region		= $a['region'.$i] ;
		$country	= $a['country'.$i] ;
		$zip		= $a['zip'.$i] ;
		$t->set_var('line1_fld','line1'.$j);
		$t->set_var('line2_fld','line2'.$j);
		$t->set_var('line3_fld','line3'.$j);
		$t->set_var('line4_fld','line4'.$j);
		$t->set_var('addresscode_fld','addresscode'.$j) ;
		$t->set_var('region_fld','region'.$j) ;
		$t->set_var('country_fld','country'.$j) ;
		$t->set_var('zip_fld','zip'.$j) ;

		$t->set_var('line1',$a['line1'.$i]) ;
		$t->set_var('line2',$a['line2'.$i]) ;
		$t->set_var('line3',$a['line3'.$i]) ;
		$t->set_var('line4',$a['line4'.$i]) ;
		$t->set_var('addresscode_selectlist',str_replace("'$addresscode'","'$addresscode' selected",$addresscode_sl)) ;
		$t->set_var('region_selectlist',str_replace("'$region'","'$region' selected",$region_sl)) ;
		$t->set_var('country_selectlist',str_replace("'$country'","'$country' selected",$country_sl)) ;
		$t->set_var('zip_selectlist',str_replace("'$zip'","'$zip' selected",$zip_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('line1_fld','line1'.$i);
		$t->set_var('line2_fld','line2'.$i);
		$t->set_var('line3_fld','line3'.$i);
		$t->set_var('line4_fld','line4'.$i);
		$t->set_var('addresscode_fld','addresscode'.$i) ;
		$t->set_var('region_fld','region'.$i) ;
		$t->set_var('country_fld','country'.$i) ;
		$t->set_var('zip_fld','zip'.$i) ;
		$t->set_var('line1','') ;
		$t->set_var('line2','') ;
		$t->set_var('line3','') ;
		$t->set_var('line4','') ;
		$t->set_var('addresscode_selectlist',$addresscode_sl) ;
		$t->set_var('region_selectlist',$region_sl) ;
		$t->set_var('country_selectlist',$country_sl) ;
		$t->set_var('zip_selectlist',$zip_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

    }

?>

