<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.expenseapp.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class expenseapp {

//---- Expense/Allowance Claim Validation Checks

    function expenseapp_validate($nr,$oldeaid) {
	global $phpgw ;

	$err=""; $error = lang("Error") ;
	$eaid = $nr[eaid] ;
	$qty = $nr[qty] ;
	$amt = $nr[amount] ;
	$phpgw->db->query("SELECT * from pyrcode where id='$eaid'");
	$phpgw->db->next_record();
	if ($qty<$phpgw->db->f('minqty'))	$err=lang("Quantity too low");
	if ($qty>$phpgw->db->f('maxqty'))	$err=lang("Quantity too high");
	if ($amt<$phpgw->db->f('minamt'))	$err=lang("Amount too small");
	if ($amt>$phpgw->db->f('maxamt'))	$err=lang("Amount too large");
	if ($qty=="")				$err=lang("Quantity Missing");
	if ($qty<>"" and !is_numeric($qty))	$err=lang("Quantity must be numeric");
	if ($amt=="")				$err=lang("Amount Missing");
	if ($amt<>"" and !is_numeric($amt))	$err=lang("Amount must be numeric");
	if ($phpgw->db->f('single')=="y") {
		$phpgw->db->query("SELECT * from pyrc_trans where empid='$nr[empid]' and pyrcodeid='$eaid'");
		if ($phpgw->db->num_rows()>0)	$err=lang("This Expense/Allowance (recurring) already exists") ;
		if ($eaid<>$oldeaid) {
			$sql = "SELECT * from pynr_trans where empid='$nr[empid]' and pyrcodeid='$eaid'" ;
			$phpgw->db->query($sql);
			if ($phpgw->db->num_rows()>0)	$err=lang("This Expense/Allowance (non-recurring) already exists") ;
			}
		}
	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Expense/Allowance Claim to Database

    function expenseapp_post($nr, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $nr[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO pynr_trans (id,empid,pyrcodeid,qty,unit,unitamt,rate,amount,comment,chart_id,approved_by) " ;
			$sql.= "VALUES ('$id','$nr[empid]','$nr[eaid]','$nr[qty]','$nr[unit]'," ;
			$sql.= 	"'$nr[unitamt]','$nr[rate]','$nr[amount]','$nr[comment]','$nr[chart_id]','')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE pynr_trans SET empid='$nr[empid]',pyrcodeid='$nr[eaid]'," ;
			$sql.="qty='$nr[qty]',unit='$nr[unit]',unitamt='$nr[unitamt]'," ;
			$sql.="rate='$nr[rate]',amount='$nr[amount]',comment='$nr[comment]'," ;
			$sql.="chart_id='$nr[chart_id]',approved_by='' WHERE id='$id'";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "approve" :
			$sql = "SELECT name FROM employee WHERE username='$user'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$name = $phpgw->db->f('name');
			$sql = "UPDATE pynr_trans SET approved_by='$name' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Pending") ;
			$actioned = lang("approved") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM pynr_trans WHERE id='$id'");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Expense/Allowance Claim") ;
	$msg = "$type $tran [id#$id] $actioned." ;

	if ($op=='new' or $op=='edit') {
		$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername " ;
		$sql.= "FROM employee a, employee b WHERE a.id='$nr[empid]' and a.supervisor=b.id" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$staffname = $phpgw->db->f('staffname');
		$superid = $phpgw->db->f('superid');
		$supername = $phpgw->db->f('supername');
		$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$nr[empid]' and emailcode='BUSI'");
		$phpgw->db->next_record();
		$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
		$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$superid' and emailcode='BUSI'");
		$phpgw->db->next_record();
		$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
		$recipient = "$supername < $superemail >" ;
		$subject = lang("%1's Expense/Allowance Claim [id#%2] %3 => Please approve",$staffname,$id,$actioned) ;
		$message = '' ;
		$headers = "From: $staffname < $staffemail >\n" ;
		$charset = lang('charset') ;
		$headers.= "Content-Type: text/html; charset=$charset \n" ;
		$headers.= "Return-Path: $staffname < $staffemail >\n" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email requesting expense/allowance claim approval successfully sent to") ;
		$failuremsg = lang("Email requesting expense/allowance claim approval fails to deliver.  Please manually inform") ;
		if ($result)	$msg = "$msg<br>$successmsg $supername." ;
			else	$msg = "$msg<br>$failuremsg $supername." ;
		}
	if ($op=='approve') {
		$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername " ;
		$sql.= "FROM employee a, employee b WHERE a.id='$nr[empid]' and a.supervisor=b.id" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$staffname = $phpgw->db->f('staffname');
		$superid = $phpgw->db->f('superid');
		$supername = $phpgw->db->f('supername');
		$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$nr[empid]' and emailcode='BUSI'");
		$phpgw->db->next_record();
		$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
		$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$superid' and emailcode='BUSI'");
		$phpgw->db->next_record();
		$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
		$recipient = "$staffname < $staffemail >" ;
		$subject = lang("%1's Expense/Allowance Claim [id#%2] %3",$staffname,$id,$actioned) ;
		$message = '' ;
		$headers = "From: $supername < $superemail >\n" ;
		$charset = lang('charset') ;
		$headers.= "Content-Type: text/html; charset=$charset \n" ;
		$headers.= "Return-Path: $supername < $superemail >\n" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email approving expense/allowance claim successfully sent to") ;
		$failuremsg = lang("Email approving expense/allowance claim fails to deliver.  Please manually inform") ;
		if ($result)	$msg = "$msg<br>$successmsg $staffname." ;
			else	$msg = "$msg<br>$failuremsg $staffname." ;
		}

	$t->set_var("message","<b>$msg</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Reject Expense/Allowance Claim

    function expenseapp_reject($nr, &$t) {
	global $phpgw, $phpgw_info ;

	$id = $nr[id] ;
	$empid = $nr[empid] ;
	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername " ;
	$sql.= "FROM employee a, employee b WHERE a.id='$empid' and a.supervisor=b.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffname = $phpgw->db->f('staffname');
	$superid = $phpgw->db->f('superid');
	$supername = $phpgw->db->f('supername');
	$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$empid' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$superid' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$recipient = "$staffname < $staffemail >" ;
	$actioned = lang("rejected") ;
	$subject = lang("%1's Expense/Allowance Claim [id#%2] %3.  Reason: %4",$staffname,$id,$actioned,$nr[reason]) ;
	$message = '' ;
	$headers = "From: $supername < $superemail >\n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $supername < $superemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	$successmsg = lang("Email rejecting expense/allowance claim successfully sent to") ;
	$failuremsg = lang("Email rejecting expense/allowance claim fails to deliver.  Please manually inform") ;
	$id = $nr[id] ;
	$type = lang("Pending") ;
	$tran = lang("Expense/Allowance Claim") ;
	$msg = "$type $tran [id#$id] $actioned." ;
	if ($result)	$msg = "$msg<br>$successmsg $staffname." ;
		else	$msg = "$msg<br>$failuremsg $staffname." ;
	$t->set_var("message","<b>$msg</b>") ;
	return True ;
	}

//---- Write Expense/Allowance Claim Detail

    function expenseapp_write(&$t, &$nr) {
	global $phpgw,$phpgw_info ;

	$t->set_var('lang_empid',lang('Employee Name/#'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_salary',lang('Basic Salary'));
	$t->set_var('lang_period',lang('Pay Period'));
	$t->set_var('lang_daypay',lang('Imputed Daily Pay'));
	$t->set_var('lang_hourpay',lang('Imputed Hourly Pay'));
	$t->set_var('lang_eaid',lang('Expense/Allowance Type'));
	$t->set_var('lang_basis',lang('Basis of Calculation'));
	$t->set_var('lang_qty',lang('Quantity'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_unitamt',lang('Unit Amount'));
	$t->set_var('lang_rate',lang('Pay Rate'));
	$t->set_var('lang_amount',lang('Amount'));
	$t->set_var('lang_comment',lang('Comment'));
	$t->set_var('lang_approved_by',lang('Approved By'));
	$user = trim($phpgw_info["user"]["userid"]);
	$where = " WHERE id='$nr[empid]' " ;
//	$where = "WHERE username='$user'" ;
	$t->set_var('empid_selectlist',employee_selectlist($where,$nr[empid])) ;
	$t->set_var('id',$nr[id]);
	$t->set_var('salary',$nr[salary]);
	$t->set_var('period',$nr[period]) ;
	$t->set_var('daypay',$nr[daypay]);
	$t->set_var('hourpay',$nr[hourpay]) ;
	$where = "WHERE allowssc='y'" ;
	$eaid = ($nr[eaid]=="") ? 0 : $nr[eaid] ;
	$t->set_var('eaid_selectlist',eaid_selectlist($where,$eaid,'long')) ;

	$qty = 1 ;
	$phpgw->db->query("SELECT * from pyrcode where id='$eaid'");
	$phpgw->db->next_record();
	$basis		=	$phpgw->db->f('basis') ;
	$unit		=	$phpgw->db->f('unit') ;
	$unitamt	=	(substr_count($basis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
	$rate		=	$phpgw->db->f('rate') ;
//	$chart_id	=	($nr[rate]==0) ? $phpgw->db->f('chart_id') : $nr[chart_id] ;
	$nr[chart_id]	=	$phpgw->db->f('chart_id') ;
	if (substr_count($basis,'qty')>0)	{$qty = $nr[qty]; $t->set_var('qty_readonly','');}
		else				$t->set_var('qty_readonly','readonly') ;
	if (substr_count($basis,'bs')>0)	$unitamt = $nr[salary] ;
	if (substr_count($basis,'hp')>0)	$unitamt = $nr[hourpay] ;
	if (substr_count($basis,'dp')>0)	$unitamt = $nr[daypay] ;
	$amount = sprintf("%01.2f",$qty*$unitamt*$rate) ;
	if (substr_count($basis,'amt')>0)	{$amount=$nr[amount]; $t->set_var('amt_readonly','');}
		else				$t->set_var('amt_readonly','readonly') ;
	$nr[qty] = $qty ;
	$nr[unit] = $unit ;
	$nr[unitamt] = $unitamt ;
	$nr[amount] = $amount ;
	$t->set_var('basis',$basis);
	$t->set_var('qty',$qty);
	$t->set_var('unit',$unit);
	$t->set_var('unitamt',$unitamt);
	$t->set_var('rate',$rate);
	$t->set_var('amount',$amount);
	$t->set_var('comment',$nr[comment]);
	$t->set_var('approved_by',$nr[approved_by]);
	$t->parse('out','report',True);
	}

    }

?>
