<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.leaveapp.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class leaveapp {

//---- Leave Application Detail Validation Checks

    function leaveapp_validate($l) {
	global $phpgw ;

	$err=""; $error = lang("Error") ;
	$leavefrom = $l[leavefrom] ;
	$leaveto = $l[leaveto] ;
	if (input2date($leavefrom)=="")		$err=lang("Invalid From Date");
	if (input2date($leaveto)=="")		$err=lang("Invalid To Date");
	$from = strtotime($leavefrom) ;
	$to = strtotime($leaveto) ;
	if ($from<mktime(0,0,0))		$err=lang("Leave application cannot be retrospective") ;
	if ($leavefrom<>"" and $leaveto<>"" and $from>$to)
						$err=lang("From Date later than To Date") ;
	$duration = $l[duration] ;
	if (!is_numeric($duration) or $duration=='' or $duration==0)
						$err=lang("invalid Workdays figure") ;
	if ($duration*10%5 <>0)			$err=lang("Workdays must be whole day or half a day") ;
	if ($leavefrom<>"" and $leaveto<>"" and ($to-$from)<(($duration-1)*24*60*60))
						$err=lang("Work Days > Leave Period duration") ;
	if (substr($leavefrom,0,4)<>substr($leaveto,0,4))
						$err=lang("Leave From year must equal Leave To year") ;
	if ($l[leavecode]=='SL')		$err=lang("Sick leave is not a valid reason for leave application") ;
	if ($l[leavecode]=='UA')		$err=lang("Unauthorised absence is not a valid reason for leave application") ;
	$l[id] = ($l[id]=="") ? 0 : $l[id] ;
	$sql =	"SELECT * FROM leaveapp WHERE ((leavefrom>='$leavefrom' and leavefrom<='$leaveto') " ;
	$sql.=	"or (leaveto>='$leavefrom' and leaveto<='$leaveto')) and empid=$l[empid] and id<>'$l[id]'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()>0)		$err=lang("This application overlaps with existing leave applications") ;
	$sql =	"SELECT * FROM leaveapp WHERE (('$leavefrom'>=leavefrom and '$leavefrom'<=leaveto) " ;
	$sql.=	"or ('$leaveto'>=leavefrom and '$leaveto'<=leaveto)) and empid=$l[empid] and id<>'$l[id]'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()>0)		$err=lang("This application overlaps with existing leave applications") ;

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}


//---- Post Leave Application Detail to Database

    function leaveapp_post($l, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $l[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO leaveapp (id,empid,leavefrom,leaveto,leavecode,duration,approved_by) " ;
			$sql.= "VALUES ('$id','$l[empid]','$l[leavefrom]','$l[leaveto]','$l[leavecode]','$l[duration]','')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE leaveapp SET empid='$l[empid]',leavefrom='$l[leavefrom]'," ;
			$sql.="leaveto='$l[leaveto]',leavecode='$l[leavecode]',duration='$l[duration]'," ;
			$sql.="approved_by='' WHERE id='$id'";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "approve" :
			$sql = "SELECT name FROM employee WHERE username='$user'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$name = $phpgw->db->f('name');
			$sql = "UPDATE leaveapp SET approved_by='$name' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Pending") ;
			$actioned = lang("approved") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM leaveapp WHERE id='$id'");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Leave Application") ;
	$msg = "$type $tran [id#$id] $actioned." ;
	if ($op=='new' or $op=='edit') {
		$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername " ;
		$sql.= "FROM employee a, employee b WHERE a.id='$l[empid]' and a.supervisor=b.id" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$staffname = $phpgw->db->f('staffname');
		$superid = $phpgw->db->f('superid');
		$supername = $phpgw->db->f('supername');
		$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$l[empid]' and emailcode='BUSI'");
		$phpgw->db->next_record();
		$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
		$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$superid' and emailcode='BUSI'");
		$phpgw->db->next_record();
		$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
		$recipient = "$supername < $superemail >" ;
		$subject = lang("%1's Leave Application [FROM:%2 TO:%3] %4 => Please approve",$staffname,$l[leavefrom],$l[leaveto],$actioned) ;
		$message = '' ;
		$headers = "From: $staffname < $staffemail >\n" ;
		$charset = lang('charset') ;
		$headers.= "Content-Type: text/html; charset=$charset \n" ;
		$headers.= "Return-Path: $staffname < $staffemail >\n" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email requesting leave application approval successfully sent to") ;
		$failuremsg = lang("Email requesting leave application approval fails to deliver.  Please manually inform") ;
		if ($result)	$msg = "$msg<br>$successmsg $supername." ;
			else	$msg = "$msg<br>$failuremsg $supername." ;
		}
	if ($op=='approve') {
		$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername " ;
		$sql.= "FROM employee a, employee b WHERE a.id='$l[empid]' and a.supervisor=b.id" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$staffname = $phpgw->db->f('staffname');
		$superid = $phpgw->db->f('superid');
		$supername = $phpgw->db->f('supername');
		$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$l[empid]' and emailcode='BUSI'");
		$phpgw->db->next_record();
		$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
		$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$superid' and emailcode='BUSI'");
		$phpgw->db->next_record();
		$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
		$recipient = "$staffname < $staffemail >" ;
		$subject = lang("%1's Leave Application [FROM:%2 TO:%3] %4",$staffname,$l[leavefrom],$l[leaveto],$actioned) ;
		$message = '' ;
		$headers = "From: $supername < $superemail >\n" ;
		$charset = lang('charset') ;
		$headers.= "Content-Type: text/html; charset=$charset \n" ;
		$headers.= "Return-Path: $supername < $superemail >\n" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email approving leave application successfully sent to") ;
		$failuremsg = lang("Email approving leave application fails to deliver.  Please manually inform") ;
		if ($result)	$msg = "$msg<br>$successmsg $staffname." ;
			else	$msg = "$msg<br>$failuremsg $staffname." ;
		}
	$t->set_var("message","<b>$msg</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Reject leave application

    function leaveapp_reject($l, &$t) {
	global $phpgw, $phpgw_info ;

	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername " ;
	$sql.= "FROM employee a, employee b WHERE a.id='$l[empid]' and a.supervisor=b.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffname = $phpgw->db->f('staffname');
	$superid = $phpgw->db->f('superid');
	$supername = $phpgw->db->f('supername');
	$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$l[empid]' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$phpgw->db->query("SELECT prefix,suffix FROM email WHERE empid='$superid' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$recipient = "$staffname < $staffemail >" ;
	$actioned = lang("rejected") ;
	$subject = lang("%1's Leave Application [FROM:%2 TO:%3] %4.  Reason: %5",$staffname,$l[leavefrom],$l[leaveto],$actioned,$l[reason]) ;
	$message = '' ;
	$headers = "From: $supername < $superemail >\n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $supername < $superemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	$successmsg = lang("Email rejecting leave application successfully sent to") ;
	$failuremsg = lang("Email rejecting leave application fails to deliver.  Please manually inform") ;
	$id = $l[id] ;
	$type = lang("Pending") ;
	$tran = lang("Leave Application") ;
	$msg = "$type $tran [id#$id] $actioned." ;
	if ($result)	$msg = "$msg<br>$successmsg $staffname." ;
		else	$msg = "$msg<br>$failuremsg $staffname." ;
	$t->set_var("message","<b>$msg</b>") ;
	return True ;
	}

//---- Write Leave Application Detail

    function leaveapp_write(&$t, &$l) {
	global $phpgw ;

	$t->set_var('lang_empid',lang('Employee Name/#'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_leavefrom',lang('Leave From'));
	$t->set_var('lang_leaveto',lang('Leave To'));
	$t->set_var('lang_duration',lang('Duration in Workdays'));
	$t->set_var('lang_leavecode',lang('Leave Code -- Description'));
	$t->set_var('lang_approved_by',lang('Approved By'));
	$lang_leave = lang('leave') ;
	$user = trim($phpgw_info["user"]["userid"]);
	$where = " WHERE id='$l[empid]' " ;
	$t->set_var('empid_selectlist',employee_selectlist($where,$l[empid])) ;
	$t->set_var('staff',$l[staff]);
	$t->set_var('id',$l[id]);
	$t->set_var('leavefrom',$l[leavefrom]);
	$t->set_var('leaveto',$l[leaveto]);
	$t->set_var('duration',$l[duration]);
	$leavecode_sl = hrcodename_selectlist("WHERE type='$lang_leave'",$l[leavecode],'long');
	$t->set_var('leavecode_selectlist',$leavecode_sl);
	$t->set_var('approved_by',$l[approved_by]);
	$t->parse('out','report',True);
	}

    }

?>

