<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.phone.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class phone {

//---- Phone Validation Checks

    function phone_validate($p) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	$row = lang("Row") ;
	$p1pd=$p2ph=$p3mo=$p4pa=$p5ph=$p6fb=$p7fh=$p8pi=$p9pv = "" ;
	For ($i=1;isset($p['phonecode'.$i]);$i++) {
		$prefix = $p['prefix'.$i] ;
		$phone = $p['phone'.$i] ;
		$suffix = $p['suffix'.$i] ;
		if ($phone=="")					$err="[$row $i]".lang("Phone# Missing");
		if ($prefix<>"" and !is_numeric($prefix))	$err="[$row $i]".lang("Phone prefix must be numeric");
		if ($phone<>"" and !is_numeric($phone))		$err="[$row $i]".lang("Phone# must be numeric");
		if ($suffix<>"" and !is_numeric($suffix))	$err="[$row $i]".lang("Phone suffix must be numeric");
		switch ($p['phonecode'.$i]) :
			case "P1PD" :	if ($p1pd<>"") $err="[$row $i]".lang("Duplicate P1PD phone") ;	$p1pd = "P1PD" ;	break ;
			case "P2PM" :	if ($p2pm<>"") $err="[$row $i]".lang("Duplicate P2PM phone") ;	$p2pm = "P2PM" ;	break ;
			case "P3MO" :	if ($p3mo<>"") $err="[$row $i]".lang("Duplicate P3MO phone") ;	$p3mo = "P3MO" ;	break ;
			case "P4PA" :	if ($p4pa<>"") $err="[$row $i]".lang("Duplicate P4PA phone") ;	$p4pa = "P4PA" ;	break ;
			case "P5PH" :	if ($p5ph<>"") $err="[$row $i]".lang("Duplicate P5PH phone") ;	$p5ph = "P5PH" ;	break ;
			case "P6FB" :	if ($p6fb<>"") $err="[$row $i]".lang("Duplicate P6FB phone") ;	$p6fb = "P6FB" ;	break ;
			case "P7FH" :	if ($p7fh<>"") $err="[$row $i]".lang("Duplicate P7FH phone") ;	$p7fh = "P7FH" ;	break ;
			case "P8PI" :	if ($p8pi<>"") $err="[$row $i]".lang("Duplicate P8PI phone") ;	$p8pi = "P8PI" ;	break ;
			case "P9PV" :	if ($p9pv<>"") $err="[$row $i]".lang("Duplicate P9PV phone") ;	$p9pv = "P9PV" ;	break ;
			endswitch ;
		}
	if ($i>1) {
		if ($p2pm==""	)		$err = lang("Phone (Business - Message) missing") ;
		if ($p3mo=="" and $p5ph=="")	$err = lang("Mobile/Home phone missing, ie no off-hour contact") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Phone to Database

    function phone_post($p, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $p[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :						break ;
		case "edit" :	$actioned = lang("updated") ;		break ;
		case "delete" :						break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE from phone where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($p['phonecode'.$i]);$i++) {
			$prefix = $p['prefix'.$i] ;
			$phone = $p['phone'.$i] ;
			$suffix = $p['suffix'.$i] ;
			$phonecode = $p['phonecode'.$i] ;
			$sql = "INSERT INTO phone(empid,prefix,phone,suffix,phonecode) " ;
			$sql.= "VALUES('$id','$prefix','$phone','$suffix','$phonecode')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Phone for Employee") ;
	$t->set_var("message","<b>$tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Phone Header

    function phone_header_write(&$t, $p) {
	global $phpgw ;

	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$p[name]) ;
	$t->set_var('id',$p[id]) ;
	$t->parse('out','report',True);
	}

//---- Write Phone Detail

    function phone_detail_write(&$t, $p, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$lang_phone = lang('phone') ;
	$id = $p[id] ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_prefix',lang("Prefix - Country code..."));
	$t->set_var('lang_phone',lang("Phone Number"));
	$t->set_var('lang_suffix',lang("Suffix - extension..."));
	$t->set_var('lang_pointer',"=>");
	$t->set_var('lang_phonecode',lang("Phone Code -- Description") );
	$t->set_var('lang_delete',lang('Delete'));

	$phonecode_sl = hrcodename_selectlist("WHERE type='$lang_phone'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($p['phonecode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('prefix_fld','prefix'.$i) ;
			$t->set_var('phone_fld','phone'.$i) ;
			$t->set_var('suffix_fld','suffix'.$i) ;
			$t->set_var('phonecode_fld','phonecode'.$i) ;
			$t->set_var('prefix','') ;
			$t->set_var('phone','') ;
			$t->set_var('suffix','') ;
			$t->set_var('phonecode_selectlist',$phonecode_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$phonecode	=	$p['phonecode'.$i] ;

		$t->set_var('prefix_fld','prefix'.$j) ;
		$t->set_var('phone_fld','phone'.$j) ;
		$t->set_var('suffix_fld','suffix'.$j) ;
		$t->set_var('phonecode_fld','phonecode'.$j) ;
		$t->set_var('prefix',$p['prefix'.$i]) ;
		$t->set_var('phone',$p['phone'.$i]) ;
		$t->set_var('suffix',$p['suffix'.$i]) ;
		$t->set_var('phonecode_selectlist',str_replace("'$phonecode'","'$phonecode' selected",$phonecode_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('prefix_fld','prefix'.$i) ;
		$t->set_var('phone_fld','phone'.$i) ;
		$t->set_var('suffix_fld','suffix'.$i) ;
		$t->set_var('phonecode_fld','phonecode'.$i) ;
		$t->set_var('prefix','') ;
		$t->set_var('phone','') ;
		$t->set_var('suffix','') ;
		$t->set_var('phonecode_selectlist',$phonecode_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

    }

?>
